//---------------------------------------------------------------------------
#include <vcl.h>
#include <dos.h>
#include <time.h>
#pragma hdrstop

#include "Key_Thread.h"
#include "Main.h"
#include "ServiceRoutines.h"
#pragma package(smart_init)
extern bool ResetTimer;
extern bool DrawingMap;
bool TimerOn=false;
extern struct TIME_ GetTime(void);
extern Settings PS;

__fastcall KeyThread::KeyThread(bool CreateSuspended)
    : TThread(CreateSuspended)
{
  Priority = tpHigher;
}
//---------------------------------------------------------------------------
void __fastcall KeyThread::Execute()
{
  TimerOn=true;

  struct TIME_ t,t0;
  float t0_,t_,dt;

  //Wait .5 second before redrawing the map in its entirety
  //(but only if no keys are down)
  while (ResetTimer){
    ResetTimer=false;
    t0=GetTime();
    t0_=t0.hour*360000+t0.min*6000+t0.sec*100+t0.hund;
    do {
      t=GetTime();
      t_=t.hour*360000+t.min*6000+t.sec*100+t.hund;
      dt=t_-t0_;
    } while (dt<50);
  }

  Synchronize(ReDraw);
  TimerOn=false;
}
//---------------------------------------------------------------------------
//Redraw the map
void __fastcall KeyThread::ReDraw()
{
  if (!DrawingMap){
    DrawingMap=true;
    MainF->DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
