//---------------------------------------------------------------------------
#include <vcl.h>
#include <iostream.h>
#include <fstream.h>
#include <math.h>
#include <stdio.h>
#include <dos.h>
#pragma hdrstop

#include "Main.h"
#include "StarSet.h"
#include "LocateSet.h"
#include "TimeDateSet.h"
#include "ServiceRoutines.h"
#include "NonStellSet.h"
#include "Key_Thread.h"
#include "ObjInfo.h"
#include "ColSet.h"
#include "PPaths.h"
#include "MapForm.h"
#include "ImageForm.h"
#include "AboutForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cspin"
#pragma resource "*.dfm"
TMainF *MainF;

//Pointers to object database matrices
//Stars
float *ra_star;
float *dec_star;
int *num_star;
short *symb_star;
int **StarBlkIndex;
short **StarBlkNum;
int NStars;
//RNGC objects
float **ra_ngc;
float **dec_ngc;
short **mag_ngc;
short **num_ngc;
short **ext_ngc;
short **type_ngc;
short **cat_ngc;
bool **show_ngc;
short *NumNGC;
//IC objects
float **ra_ic;
float **dec_ic;
short **mag_ic;
short **num_ic;
short **type_ic;
short **cat_ic;
bool **show_ic;
short *NumIC;
//Messier objects
float ra_mes[110];
float dec_mes[110];
short mag_mes[110];
short type_mes[110];
short mes_ngc[110];
bool show_mes[110];
//Lynd clouds
float **ra_lyn;
float **dec_lyn;
short **num_lyn;
short *NumLyn;
//Barnard clouds
float *ra_bar;
float *dec_bar;
short *num_bar;
short *ext_bar;
//Arp galaxies
float *ra_arp;
float *dec_arp;
//RC3 galaxies
float *ra_rc3;
float *dec_rc3;
float *a_rc3;  //major axis
float *b_rc3;  //minor axis
float *pa_rc3; //position angle
float *mag_rc3;
short *num_rc3;
bool *show_rc3;
short *NumRC3; //The index at the beginning of each sky block

//Constellations
int ConstTot[103];
float ConstRA[10000];
float ConstDec[10000];
int ConstFigNSeg[79];
int ConstFigNPts[181];
float ConstFigRA[1000];
float ConstFigDec[1000];
float ConstLabRA[88];
float ConstLabDec[88];
String ConstLabel[88];
//Solar system objects
double OElem[213][15]; //Instantaneous orbital elements
                         //0-99: satelites of the sun
                         //100-199: satelites of earth
                         //200-201: satelites of mars
                         //202-208: Cassini and Herschel's satelites of saturn
                         //209-212: jupiter's galilean satelites
OrbitalElements SSData[213]; //Information for all solar system objects

//Global variables
int lastx=0,lasty=0;
int lastXSB=150,lastYSB=100;
int x0=0,y0=0;
bool drawing=false;
bool SouthHemisphere=false;
bool initialize;
bool DrawTag[432];
extern bool TimerOn;
bool ResetTimer=true;
bool DrawingMap=false; //Flag to indicate that the drawing thread is currently active
int sign=1;
struct TIME_ StartTime;

bool Redraw;
TPoint points[10000];
//Graphics structures used to display the stars
Graphics::TBitmap *text = new Graphics::TBitmap();
Graphics::TBitmap *PlanetSymb = new Graphics::TBitmap();
Graphics::TBitmap *DeepSkySymb = new Graphics::TBitmap();
Graphics::TBitmap *Starpic0 = new Graphics::TBitmap();
Graphics::TBitmap *Starpic1 = new Graphics::TBitmap();
Graphics::TBitmap *Starpic2 = new Graphics::TBitmap();
Graphics::TBitmap *Starpic3 = new Graphics::TBitmap();
Graphics::TBitmap *Starpic4 = new Graphics::TBitmap();
Graphics::TBitmap *Starpic5 = new Graphics::TBitmap();
Graphics::TBitmap *Starpic6 = new Graphics::TBitmap();
Graphics::TBitmap *Starpic7 = new Graphics::TBitmap();
Graphics::TBitmap *Starpic8 = new Graphics::TBitmap();
Graphics::TBitmap *Starpic9 = new Graphics::TBitmap();
Graphics::TBitmap *Starpic10 = new Graphics::TBitmap();
Graphics::TBitmap *Starpic11 = new Graphics::TBitmap();
Graphics::TBitmap *ClipBitmap = new Graphics::TBitmap();
Graphics::TBitmap *ClipBitmap0 = new Graphics::TBitmap();
Graphics::TBitmap *ClipBitmap1 = new Graphics::TBitmap();
Graphics::TBitmap *ClipBitmap2 = new Graphics::TBitmap();
Graphics::TBitmap *ClipBitmap3 = new Graphics::TBitmap();
Graphics::TBitmap *ClipBitmap4 = new Graphics::TBitmap();
Graphics::TBitmap *ClipBitmap5 = new Graphics::TBitmap();
Graphics::TBitmap *ClipBitmap6 = new Graphics::TBitmap();
Graphics::TBitmap *ClipBitmap7 = new Graphics::TBitmap();
Graphics::TBitmap *ClipBitmap8 = new Graphics::TBitmap();
Graphics::TBitmap *ClipBitmap9 = new Graphics::TBitmap();
Graphics::TBitmap *ClipBitmap10 = new Graphics::TBitmap();
Graphics::TBitmap *ClipBitmap11 = new Graphics::TBitmap();
Graphics::TBitmap *BufImg;
TRect SourceRect,DestRect,ImArea;
TRect DestRect0,DestRect1,DestRect2,DestRect3,DestRect4;
TRect DestRect5,DestRect6,DestRect7,DestRect8,DestRect9;
TRect DestRect10,DestRect11;

//Variables that are shared across units
int CatNum[20];  //The catalogue number of the closest object in each catalogue
int ExtNum;  //The catalogue extension number of the closest object
int HighlightNum=0;
int SelectedCatalogue;  //The catalogue index for the selected object
                        //-4=Unknown (used to focus info form on the finder page)
                        //-3=Constellations, -2=stars(SAO),
                        //-1=solar system objects, 0=RNGC, 1=IC,
                        // 2=Messier, etc...
SelectedObjects SO[100]; //Holds information for up to 100 selected objects
HighlightObjects HO[100];//Holds information for up to 100 highlighted objects
int *FavLocs;          //Favorite location indices
int FavLocNum;         //number of "  "  "
Settings PS;
Colors CS;
Angles AL;
String SystemMessage;
bool ProceedFlag;

//Functions defined in ServiceRoutines.cpp
extern void FirstCircle(float *i);
extern void Planar(float *X1,float *x,float *y);
extern void Lambert(float *X1,float *x,float *y);
extern void Lagrange(float *X1,float *x,float *y);
extern void Mercator(float *X1,float *x,float *y);

extern float *vector(int nl, int nh);
extern void free_vector(float *v, int nl, int nh);
extern int *i_vector(int nl,int nh);
extern void free_i_vector(int *v, int nl, int nh);
extern short *s_vector(int nl,int nh);
extern void free_s_vector(short *v, int nl, int nh);
extern float **matrix(int nrl, int nrh, int ncl, int nch);
extern void free_matrix(float **m,int nrl,int nrh,int ncl,int nch);
extern short **s_matrix(int nrl, int nrh, int ncl, int nch);
extern void free_s_matrix(short **m,int nrl,int nrh,int ncl,int nch);
extern int **i_matrix(int nrl, int nrh, int ncl, int nch);
extern void free_i_matrix(int **m,int nrl,int nrh,int ncl,int nch);
extern void free_matrices(int database,int vector_size);

extern void ReturnToScreenEdge(int *w,int *h,int *i);
extern void LoadStarMap(int MaxVmag);
extern void LoadPPSettings(void);
extern void NextDay(struct TIME_ *t);
extern struct TIME_ GetTime(void);
extern float GetLST(void);
extern double GregToJul(TIME_ Greg_t);

extern void EclSatCoord(int n,double *T);
extern void GeoSatCoord(int n);
extern void GetOE(double *T);
extern void GetObliquity(double *T);
extern void LoadOElem(String filename);
extern void PrecessClass(int Class,double jday,double startepoch);

extern void LoadCatalog(int catalog,bool startflag);
extern void LoadConstBound(void);
extern void LoadSettings(String filename);
extern void LoadLocation(int n);
extern void SaveSettings(String filename);

extern String JulToGreg(double jul);
extern String GetTimeDateS(TIME_ time);
extern String GetDecString(float dec, bool HiPrecision);
extern String GetRAString(float ra);
extern bool SkyToScreen(float *q,float *lambda,int *x1,int *y1,float *R0,int *w2,int *h2,bool force_calculation);
extern void ScreenToSky(int *x,int *y,float *q,float *lambda,float *R0,int *w2,int *h2);
extern void HorToEqu(float *h,float *Az,float *q,float *lambda);
extern void EquToHor(float *lambda,float *q,float *Az,float *h,float SidTime);
extern void EqToGal(float *lambda, float *q);
extern void GalToEq(float *lambda, float *q);
extern void EqToEcl(float *lambda, float *q);
extern void EclToEq(float *lambda, float *q);
extern void AdvanceTime(void);
extern struct TIME_ AddSeconds(struct TIME_ t,double d);
extern void Precess_sp(float *ra,float *dec,double *T, double *T0);

extern String GetFilePath(String filename);

//Local routines
void LongLatRange(float *min_lambda, float *max_lambda,\
  float *min_q, float *max_q);
bool PlaneToScreen(int *x, int *y, float *lambda, int *PlaneIndex);
void ScreenToEq(int *x, int *y, float *q, float *lambda, int *PlaneIndex);
void DrawPlaneLine(int *x1,int *y1,int sign,int *PlaneIndex);
void FindPlaneIntersect(int *x1,int *y1,int d,int *PlaneIndex,bool XFixed);

//---------------------------------------------------------------------------
__fastcall TMainF::TMainF(TComponent* Owner)
    : TForm(Owner)
{
  FormClosing = false;
}
//---------------------------------------------------------------------------
//Get the current position
void __fastcall TMainF::ImageMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
  //Part that deals with the map position
  x0=(short)X;
  y0=(short)Y;
  if (Button==mbLeft) drawing=true;
  else FindObject();

  AL.i_ori=AL.incl;
  AL.a_ori=AL.azim;
}
//---------------------------------------------------------------------------
//Get the inclination and azimuth angle
void __fastcall TMainF::ImageMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
  float arg;

  //Displays the sky coordinates of the mouse position
  DrawCoord(&X,&Y,true,false);

  //Deals with shifting the map center position
  if (drawing){

    //Elevation
    if (AL.lat>0) {
      AL.incl=AL.i_ori+sign*(Y-y0)*pi/PS.R0;
    } else {
      AL.incl=AL.i_ori-sign*(Y-y0)*pi/PS.R0;
    }
    if (AL.incl>pihalved){
      sign=-sign;
      y0=Y;
      AL.incl=pi-AL.incl;
      AL.a_ori+=pi;
    }
    if (AL.incl<-pihalved){
      sign=-sign;
      y0=Y;
      AL.incl=-pi-AL.incl;
      AL.a_ori+=pi;
    }
    AL.cosi=cos(AL.incl);
    AL.sini=sin(AL.incl);

    //Azimuth
    if (AL.lat>0) {
      arg=AL.a_ori-(X-x0)*pi/PS.R0;
    } else {
      arg=AL.a_ori+(X-x0)*pi/PS.R0;
    }
    FirstCircle(&arg);
    AL.azim=arg;
    AL.cos_azim=cos(arg);
    AL.sin_azim=sin(arg);

    //Display the center coordinates
    DrawCoord(&X,&Y,false,true);

    if (!DrawingMap){
      DrawingMap=true;
      DrawMap(400,true);
      DrawingMap=false;
    }
    Redraw=true;
  } else {
    Redraw=false;
  }
  lastx=X;
  lasty=Y;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::ImageMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
  if (Redraw){
    if (!DrawingMap){
      DrawingMap=true;
      DrawMap(PS.MaxStarMag,false);
      DrawingMap=false;
    }
  }
  drawing=false;
}
//---------------------------------------------------------------------------
//Shift azimuth using the scroll bar
void __fastcall TMainF::HScrollBarScroll(TObject *Sender,
      TScrollCode ScrollCode, int &ScrollPos)
{
  if (ScrollCode==scEndScroll){
    if (!DrawingMap){
      DrawingMap=true;
      DrawMap(PS.MaxStarMag,false);
      DrawingMap=false;
    }
    drawing=false;
    ScrollPos=150;
    lastXSB=150;
    DefocusControl(HScrollBar,false);
  } else {
    if (!drawing){
      drawing=true;
      AL.a_ori=AL.azim;
    }

    float arg;

    //Change azimuth
    if (AL.lat>0) {
      arg=AL.a_ori-(ScrollPos-lastXSB)*twopi*PS.w/(PS.R0*300);
    } else {
      arg=AL.a_ori+(ScrollPos-lastXSB)*twopi*PS.w/(PS.R0*300);
    }
    FirstCircle(&arg);
    AL.azim=arg;
    AL.cos_azim=cos(arg);
    AL.sin_azim=sin(arg);

    //Display the coordinates
    DrawCoord(&lastx,&lasty,false,true);
    DrawCoord(&lastx,&lasty,true,false);

    if (!DrawingMap){
      DrawingMap=true;
      DrawMap(400,true);
      DrawingMap=false;
    }
  }
}
//---------------------------------------------------------------------------
//Shift elevation using the scroll bar
void __fastcall TMainF::VScrollBarScroll(TObject *Sender,
      TScrollCode ScrollCode, int &ScrollPos)
{
  if (ScrollCode==scEndScroll){
    if (!DrawingMap){
      DrawingMap=true;
      DrawMap(PS.MaxStarMag,false);
      DrawingMap=false;
    }
    drawing=false;
    ScrollPos=100;
    lastYSB=100;
    DefocusControl(VScrollBar,false);
  } else {
    if (!drawing){
      drawing=true;
      AL.i_ori=AL.incl;
    }

    //Change elevation
    //Elevation
    if (AL.lat>0) {
      AL.incl=AL.i_ori+(ScrollPos-lastYSB)*pi*PS.w/(PS.R0*300);
    } else {
      AL.incl=AL.i_ori-(ScrollPos-lastYSB)*pi*PS.w/(PS.R0*300);
    }
    if (AL.incl>pihalved){
      sign=-sign;
      y0=lasty;
      AL.incl=pi-AL.incl;
      AL.a_ori+=pi;
    }
    if (AL.incl<-pihalved){
      sign=-sign;
      y0=lasty;
      AL.incl=-pi-AL.incl;
      AL.a_ori+=pi;
    }
    AL.cosi=cos(AL.incl);
    AL.sini=sin(AL.incl);

    //Display the coordinates
    DrawCoord(&lastx,&lasty,false,true);
    DrawCoord(&lastx,&lasty,true,false);

    if (!DrawingMap){
      DrawingMap=true;
      DrawMap(400,true);
      DrawingMap=false;
    }
  }
}
//---------------------------------------------------------------------------
//Set the drawing tag array and determine the range of
//latitudes and longitudes to use when drawing the grid
void LongLatRange(float *min_lambda, float *max_lambda,\
  float *min_q, float *max_q)
{
  int i,j,x1=0,y1=0,n,m;
  float q,lambda;
  bool proceed;
  bool NPoleVisible=false, SPoleVisible=false;
  *max_q=-pihalved;
  *min_q=pihalved;
  *max_lambda=0;
  *min_lambda=twopi;

  //Set the star drawing tag array
  for (i=0;i<432;i++){
    j=i/18;
    lambda=j*pi/12.0;
    q=(9-i+j*18)*pi/18.0;
    DrawTag[i]=SkyToScreen(&q,&lambda,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
    if (DrawTag[i]){
      if (lambda>*max_lambda) *max_lambda=lambda;
      if (lambda<*min_lambda) *min_lambda=lambda;
      if (q>*max_q) *max_q=q;
      if (q<*min_q) *min_q=q;
    }
  }
  *max_lambda=*max_lambda+twopi/24;
  *min_lambda=*min_lambda-twopi/24;
  *max_q=*max_q+pi/18;
  *min_q=*min_q-pi/18;
  if (*max_lambda>twopi) *max_lambda=twopi;
  if (*min_lambda<0) *min_lambda=0;
  if (*max_q>pihalved) *max_lambda=pihalved;
  if (*min_q<-pihalved) *min_q=-pihalved;

  //Make sure the block in the center of the screen is
  //checked (and its nearest neighbours)
  x1=PS.w2;
  y1=PS.h2;
  ScreenToSky(&x1,&y1,&q,&lambda,&(PS.R0),&(PS.w2),&(PS.h2));
  i=lambda*24/twopi;
  j=(pihalved-q)*18/pi;
  for (int k=i-1;k<i+2;k++){
    for (int l=j-1;l<j+2;l++){
      n=k;
      m=l;
      if (k>23) n-=24;
      if (k<0) n+=24;
      if (l>17) m-=18;
      if (l<0) m+=18;
      DrawTag[n*18+m]=true;
    }
  }
  for (i=0;i<432;i++){
    DrawTag[i]=true;
  }

  //See if one of the poles are visible
  q=pihalved; lambda=0;
  proceed=SkyToScreen(&q,&lambda,&i,&j,&(PS.R0),&(PS.w2),&(PS.h2),false);
  if (proceed) {
    NPoleVisible=true;
  } else {
    q=-pihalved; lambda=0;
    proceed=SkyToScreen(&q,&lambda,&i,&j,&(PS.R0),&(PS.w2),&(PS.h2),false);
    if (proceed){
      SPoleVisible=true;
    }
  }

  //Return the minimum and maximum declinations/RA's to
  //their closest integral grid value
  *min_lambda-=twopi/24;

  *max_lambda+=twopi/24;
  if (*max_lambda>twopi) *max_lambda=twopi;

  *min_q-=pi/18;
  if (*min_q<-pihalved) *min_q=-pihalved;

  *max_q+=pi/18;
  if (*max_q>pihalved) *max_q=pihalved;

  if (*max_lambda==0) *max_lambda=twopi;
  if (*min_lambda==twopi) *min_lambda=0;
  if (*max_lambda==twopi && *min_lambda==0){
    if (SouthHemisphere) *min_q=-pihalved;
    else *max_q=pihalved;
  } else {
    if (*max_q==-pihalved) *max_q=pihalved;
  }
  if (*max_lambda==twopi && *min_lambda==0){
    if (SouthHemisphere) *min_q=-pihalved;
    else *max_q=pihalved;
  } else {
    if (*min_q==pihalved) *min_q=-pihalved;
  }

  //If the south and/or north pole is visible, then
  //use the following settings
  if (NPoleVisible){ //North pole visible
    *max_q=pihalved; *min_lambda=0; *max_lambda=twopi;
  }
  if (SPoleVisible){ //South pole visible
    *min_q=-pihalved; *min_lambda=0; *max_lambda=twopi;
  }
}
//---------------------------------------------------------------------------
//Draw the grid
void __fastcall TMainF::DrawGrid(float *min_lambda,float *max_lambda,\
  float *min_q,float *max_q)
{
  float incr=0,fine_incr;
  float lambda=0,lambda1=0,q=0,q1=0;
  float startlat=0,endlat=0,startlong=0,endlong=0;
  int i,x1=0,y1=0;
  bool testexpression, SpecialIncr, drawingline, proceed, proceed2, first_point;
  String label;
  TRect ImArea=Rect(0,0,PS.w,PS.h);

  if (AL.lat>pihalved) SouthHemisphere=true;

  BufImg->Canvas->Pen->Width=1;

  //Grid colors
  BufImg->Canvas->Pen->Color=CS.MainGrid;
  BufImg->Canvas->Font->Size=8;
  BufImg->Canvas->Font->Color=CS.GridLab;

  //Draws the lines of longitude
  PS.MajLngInc=twopi/24;

  for (lambda=*min_lambda;lambda<=*max_lambda;lambda+=PS.MajLngInc){
    if (((lambda<=1e-5)&&(lambda>=0))\
      ||((lambda<=pihalved+1e-5)&&(lambda>=pihalved-1e-5))\
      ||((lambda<=pi+1e-5)&&(lambda>=pi-1e-5))\
      ||((lambda<=threepihalved+1e-5)&&(lambda>=threepihalved-1e-5))){
      SpecialIncr=true; //These lines are drawn all the way to the pole
    } else {
      SpecialIncr=false;
    }

    if (SouthHemisphere){
      if (!PS.HorizonMask){
        if (SpecialIncr) startlat=pihalved;
        else startlat=pihalved-0.174532925;
      } else {
        //Find the start latitude
        float arg,longitude;
        if (AL.sin_lat==0) arg=1e+15;
        else arg=AL.sin_lat/AL.cos_lat;
        longitude=lambda-AL.l_ori+pihalved;
        FirstCircle(&longitude);
        startlat=atan2(-sin(longitude),arg);
      }
      if (startlat>*min_q) startlat=*min_q;

      if (SpecialIncr) endlat=-pihalved;
      else endlat=-pihalved+0.174532925;
      if (endlat<*max_q) endlat=*max_q;
    } else {
      if (!PS.HorizonMask){
        if (SpecialIncr) startlat=-pihalved;
        else startlat=-pihalved+0.174532925;
      } else {
        //Find the start latitude
        float arg,longitude;
        if (AL.sin_lat==0) arg=1e+15;
        else arg=AL.sin_lat/AL.cos_lat;
        longitude=lambda-AL.l_ori+pihalved;
        FirstCircle(&longitude);
        startlat=atan2(-sin(longitude),arg);
      }
      if (startlat<*min_q) startlat=*min_q;

      if (SpecialIncr) endlat=pihalved;
      else endlat=pihalved-0.174532925;
      if (endlat>*max_q) endlat=*max_q;
    }
    i=PS.R0/PS.w2+1;
    if (PS.Projection==3) incr=(endlat-startlat)/(60*i);
    else incr=(endlat-startlat)/(30*i);
    fine_incr=incr/20;

    //Draw a longitude line
    i=0;
    first_point=true;
    q=startlat;
    if (startlat<endlat) testexpression=(q<=endlat);
    else testexpression=(q>=endlat);
    while (testexpression){
      q1=q;

      //Get the screen coordinates
      proceed=SkyToScreen(&q1,&lambda,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
      if (first_point) {
        drawingline=proceed;
        first_point=false;
      }

      //Add the point to the point array
      if (proceed){
        if (drawingline){
          points[i].x=x1;
          points[i].y=y1;
          i++;

          //Increment the latitude
          q+=incr;
          if (!SouthHemisphere) testexpression=(q<=endlat+incr/2);
          else testexpression=(q>=endlat+incr/2);
        } else {
          //Find the beginning of the line
          q1-=incr;
          do {
            proceed2=SkyToScreen(&q1,&lambda,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
            q1+=fine_incr;
          } while (!proceed2);
          points[i].x=x1;
          points[i].y=y1;
          i++;
          drawingline=true;
          DrawGridLabel(x1,y1,FormatFloat("#0",lambda*3.819718634)+"h");
        }
      } else {
        if (drawingline){
          //Find the end of the line
          q1-=incr;
          do {
            proceed2=SkyToScreen(&q1,&lambda,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
            q1+=fine_incr;
          } while (proceed2);
          points[i].x=x1;
          points[i].y=y1;
          DrawLine(i,false);
          i=0;
          drawingline=false;
          DrawGridLabel(x1,y1,FormatFloat("#0",lambda*3.819718634)+"h");
        } else {
          //Increment the latitude
          q+=incr;
          if (!SouthHemisphere) testexpression=(q<=endlat+incr/2);
          else testexpression=(q>=endlat+incr/2);
        }
      }
    }
    if (drawingline) {
      //All of the last points were good
      DrawLine(i-1,false);
    }
  }

  //Draws the lines of latitude
  startlat=*min_q;
  endlat=*max_q;

  for (q=startlat;q<=endlat;q+=PS.MajLatInc){
    q1=q;
    startlong=*min_lambda;
    endlong=*max_lambda;
    i=PS.R0/PS.w2+1;
    if (PS.Projection==3){
      incr=(endlong-startlong)/(120*i);
    } else {
      incr=(endlong-startlong)/(80*i);
    }
    fine_incr=incr/20;
    i=0;

    //Draw a latitude line
    first_point=true;
    lambda=startlong;
    while (lambda<=endlong+incr/2){
      lambda1=lambda;

      //Get the screen coordinates
      proceed=SkyToScreen(&q1,&lambda1,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
      if (first_point) {
        drawingline=proceed;
        first_point=false;
      }

      //Add the point to the point array
      if (proceed){
        if (drawingline){
          points[i].x=x1;
          points[i].y=y1;
          i++;

          //Increment the longitude
          lambda+=incr;
        } else {
          //Find the beginning of the line
          lambda1-=incr;
          do {
            proceed2=SkyToScreen(&q1,&lambda1,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
            lambda1+=fine_incr;
          } while (!proceed2);
          points[i].x=x1;
          points[i].y=y1;
          i++;
          drawingline=true;
          DrawGridLabel(x1,y1,FormatFloat("##0",q*57.29577951)+"");
        }
      } else {
        if (drawingline){
          //Find the end of the line
          lambda1-=incr;
          do {
            proceed2=SkyToScreen(&q1,&lambda1,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
            lambda1+=fine_incr;
          } while (proceed2);
          points[i].x=x1;
          points[i].y=y1;
          DrawLine(i,false);
          i=0;
          drawingline=false;
          DrawGridLabel(x1,y1,FormatFloat("##0",q*57.29577951)+"");
        } else {
          //Increment the longitude
          lambda+=incr;
        }
      }
    }
    if (drawingline) {
      //All of the last points were good
      DrawLine(i-1,false);
    }
  }
}
//---------------------------------------------------------------------------
//Draws a line, filtering out discontinuities across
//the screen found when using a Mercator projection
void __fastcall TMainF::DrawLine(int n,bool ForceVerify)
{
  if (PS.Projection==3||ForceVerify){
    TPoint n_points[1000];
    int last_x1,last_y1,i,j;
    i=0;
    while (i<n){
      j=0;
      do {
        n_points[j].x=points[i].x;
        n_points[j].y=points[i].y;
        last_x1=points[i].x;
        last_y1=points[i].y;
        i++;
        j++;
      } while ((abs(points[i].x-last_x1)<PS.h2/4)&&(abs(points[i].y-last_y1)<PS.h2/4)&&(i<=n));

      BufImg->Canvas->Polyline(n_points,j-1);
    }
  } else {
    BufImg->Canvas->Polyline(points,n);
  }
}
//---------------------------------------------------------------------------
//Draws a grid line label
void __fastcall TMainF::DrawGridLabel(int x, int y,String label)
{
  if (x<1) x=1;
  if (x>PS.w-15) x=PS.w-15;
  if (y<1) y=1;
  if (y>PS.h-20) x=PS.h-15;
  BufImg->Canvas->TextOut(x,y,label);
}
//---------------------------------------------------------------------------
//Draw special plane intersections (horizon, ecliptic and galactic plane)
//PlaneIndex = 0 for horizon, 1 for ecliptic, 2 for galactic
void __fastcall TMainF::DrawIntersects(int PlaneIndex)
{
  int x1, dx1, y1, dy1, xint, yint, bestx1, ncross,n;
  float q=0, lambda=0, clambda=0, cq=0, lastq, dq, lastdq, bestq, Minlambda, Maxlambda, dlambda, r02, minq;
  bool proceed;

  //Find the coordinates of the center of the screen (in the coordinate system
  //of interest)
  x1=PS.w2;
  y1=PS.h2;
  ScreenToEq(&x1,&y1,&cq,&clambda,&PlaneIndex);

  //Draw the lines
  BufImg->Canvas->Pen->Style=psDash;
  if (PlaneIndex==0) {
    BufImg->Canvas->Pen->Color=CS.Hor;
    BufImg->Canvas->Pen->Style=psSolid;
  } else {
    BufImg->Canvas->Pen->Style=psDash;
  }
  if (PlaneIndex==1) BufImg->Canvas->Pen->Color=CS.Ecl;
  if (PlaneIndex==2) BufImg->Canvas->Pen->Color=CS.Gal;

  //In the case where the scale is sufficiently large, simply draw the full
  //circle
  if (PS.R0<PS.w){
    n=0;
    for (lambda=0; lambda<=twopi; lambda+=pi/160){
      if (PlaneToScreen(&x1,&y1,&lambda,&PlaneIndex)){
        points[n].x=x1;
        points[n].y=y1;
        n++;
      }
    }
    DrawLine(n-1,true);
  } else {
    bool Drawing, IsGood;
    float maxlambda;

    lambda=0;
    dlambda=(pi*PS.w2)/(120*PS.R0);
    x1=PS.w2; y1=PS.h2;
    ScreenToEq(&x1,&y1,&q,&lambda,&PlaneIndex);
    maxlambda=lambda+4*pi*PS.w2/PS.R0;
    lambda=lambda-4*pi*PS.w2/PS.R0;

    while (lambda<=maxlambda){
      IsGood=PlaneToScreen(&x1,&y1,&lambda,&PlaneIndex);
      if (IsGood){
        Drawing=true;
        lambda-=dlambda;
        PlaneToScreen(&x1,&y1,&lambda,&PlaneIndex);
        n=0;
        points[n].x=x1;
        points[n].y=y1;
        lambda+=dlambda;
        PlaneToScreen(&x1,&y1,&lambda,&PlaneIndex);
        n++;
        points[n].x=x1;
        points[n].y=y1;

        while (lambda<=maxlambda && Drawing){
          lambda+=dlambda;
          Drawing=PlaneToScreen(&x1,&y1,&lambda,&PlaneIndex);
          points[n].x=x1;
          points[n].y=y1;
          n++;
        }
        DrawLine(n-1,true);
      }
      lambda+=dlambda;
    }
  }

  if (PlaneIndex==0){
    //Draw the North, South, East, West labels
    float q_=0, lambda_=0;
    TRect source,dest;
    BufImg->Canvas->CopyMode=cmSrcCopy;
    for (int i=0;i<8;i++){
      q=0;
      lambda=i*piquartered;
      //Convert horizon coordinate to sky coordinates
      HorToEqu(&q,&lambda,&q_,&lambda_);
      //Get the screen coordinates
      proceed=SkyToScreen(&q_,&lambda_,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
      if (proceed&&(x1<=PS.w)&&(x1>=0)&&(y1<=PS.h)&&(y1>=0)){
        dest=Rect(x1-10,y1-8,x1+11,y1+9);
        source=Rect(i*21,0,(i+1)*21,17);
        BufImg->Canvas->CopyRect(dest,text->Canvas,source);
      }
    }
  }
  BufImg->Canvas->Pen->Style=psSolid;
}
//---------------------------------------------------------------------------
//Find intersection of plane with screen edge
void FindPlaneIntersect(int *x1,int *y1,int d,int *PlaneIndex,bool XFixed)
{
  float q=0, lambda=0, qinit;

  ScreenToEq(x1,y1,&q,&lambda,PlaneIndex);
  qinit=q;

  if (!XFixed){
    while (qinit*q>0){
      *x1=*x1+d;
      ScreenToEq(x1,y1,&q,&lambda,PlaneIndex);
    }
  } else {
    while (qinit*q>0){
      *y1=*y1+d;
      ScreenToEq(x1,y1,&q,&lambda,PlaneIndex);
    }
  }
}
//---------------------------------------------------------------------------
//Draw the plane line starting at screen coordinate (x1, y1)
void DrawPlaneLine(int *x1,int *y1,int sign, int *PlaneIndex)
{
  float lambda=0, q=0, dlambda, lambda_;
  int n=0, xinit;

  ScreenToEq(x1,y1,&q,&lambda,PlaneIndex);
  if (fabs(q)>0.05){
    *y1=*y1-1;
    ScreenToEq(x1,y1,&q,&lambda,PlaneIndex);
  }
  dlambda=-sign*PS.R0*pihalved/(PS.w2*60);
  points[0].x=*x1;
  points[0].y=*y1;
  n++;
  lambda+=dlambda;
  if (!PlaneToScreen(x1,y1,&lambda,PlaneIndex)) {
    lambda=lambda-2*dlambda;
    dlambda=-dlambda;
  }

  while (PlaneToScreen(x1,y1,&lambda,PlaneIndex)) {
    points[n].x=*x1;
    points[n].y=*y1;
    n++;
    lambda+=dlambda;
  }
  points[n].x=*x1;
  points[n].y=*y1;
  n++;
  MainF->DrawLine(n-1,false);
}
//---------------------------------------------------------------------------
//Get screen coordinates for a particular coordinate system, but only along
//its 0 latitude circle (used for drawing equator planes)
bool PlaneToScreen(int *x1, int *y1, float *lambda, int *PlaneIndex)
{
  float q_=0, lambda_=0, q=0;
  bool Proceed;

  if (*PlaneIndex==0) {
    //Convert horizon coordinates to equatorial coordinates
    HorToEqu(&q,lambda,&q_,&lambda_);
  }
  if (*PlaneIndex==1) {
    //Convert ecliptic coordinates to equatorial coordinates
    lambda_=*lambda;
    EclToEq(&lambda_,&q_);
  }
  if (*PlaneIndex==2){
    //Convert galactic coordinates to equatorial coordinates
    lambda_=*lambda;
    GalToEq(&lambda_,&q_);
  }
  Proceed=SkyToScreen(&q_,&lambda_,x1,y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
  return Proceed;
}
//---------------------------------------------------------------------------
//Get coordinates for a particular coordinate system from the screen (used for
//drawing special planes)
void ScreenToEq(int *x, int *y, float *q, float *lambda, int *PlaneIndex)
{
  bool Proceed;

  ScreenToSky(x,y,q,lambda,&(PS.R0),&(PS.w2),&(PS.h2));
  if (*PlaneIndex==0) {
    //Convert equatorial coordinates to horizon coordinates
    float q_, lambda_;
    q_=*q;
    lambda_=*lambda;
    EquToHor(&lambda_,&q_,lambda,q,AL.l_ori);
  }
  if (*PlaneIndex==1) {
    //Convert equatorial coordinates to ecliptic coordinates
    EqToEcl(lambda,q);
  }
  if (*PlaneIndex==2){
    //Convert equatorial coordinates to galactic coordinates
    EqToGal(lambda,q);
  }
}
//---------------------------------------------------------------------------
//Draw deep sky objects
void __fastcall TMainF::DrawRNGC()
{
  float RA,dec;
  int k,x1,y1;
  bool proceed;

  ClipBitmap->Width=15;
  ClipBitmap->Height=15;
  ClipBitmap->Canvas->Pen->Color=clNone;
  ClipBitmap->Canvas->Brush->Color=clNone;
  DestRect=Rect(0,0,15,15);
  BufImg->Canvas->CopyMode=cmSrcPaint;

  //For catalogues sorted by sky blocks
  for (int l=0;l<432;l++){
    //Only draw objects for blocks that are visible
    if (DrawTag[l]){
      //RNGC objects
      if (PS.UseCat[0]){
        for (k=0;k<NumNGC[l];k++){
          if (show_ngc[l][k]){
            RA=ra_ngc[l][k];
            dec=dec_ngc[l][k];

            //Get the screen coordinates
            proceed=SkyToScreen(&dec,&RA,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);

            //Draw the object
            if (proceed){
              //Stop if it's not on the screen!
              SourceRect=Rect(PS.Symbol[type_ngc[l][k]]*15,type_ngc[l][k]*15,(PS.Symbol[type_ngc[l][k]]+1)*15,(type_ngc[l][k]+1)*15);
              ClipBitmap->Canvas->CopyRect(DestRect,DeepSkySymb->Canvas,SourceRect);
              BufImg->Canvas->Draw(x1-7,y1-7,ClipBitmap);
            }
          }
        }
      }

      //IC Objects
      if (PS.UseCat[1]){
        for (k=0;k<NumIC[l];k++){
          if (show_ic[l][k]){
            RA=ra_ic[l][k];
            dec=dec_ic[l][k];

            //Get the screen coordinates
            proceed=SkyToScreen(&dec,&RA,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);

            //Draw the object
            if (proceed){
              SourceRect=Rect(PS.Symbol[type_ic[l][k]]*15,type_ic[l][k]*15,(PS.Symbol[type_ic[l][k]]+1)*15,(type_ic[l][k]+1)*15);
              ClipBitmap->Canvas->CopyRect(DestRect,DeepSkySymb->Canvas,SourceRect);
              BufImg->Canvas->Draw(x1-7,y1-7,ClipBitmap);
            }
          }
        }
      }

      //Lynd clouds
      if (PS.UseCat[3]&&PS.ShowObjects[18]){
        for (k=0;k<NumLyn[l];k++){
          RA=ra_lyn[l][k];
          dec=dec_lyn[l][k];

          //Get the screen coordinates
          proceed=SkyToScreen(&dec,&RA,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);

          //Draw the object
          if (proceed){
            SourceRect=Rect(PS.Symbol[18]*15,270,(PS.Symbol[18]+1)*15,285);
            ClipBitmap->Canvas->CopyRect(DestRect,DeepSkySymb->Canvas,SourceRect);
            BufImg->Canvas->Draw(x1-7,y1-7,ClipBitmap);
          }
        }
      }
    }
  }

  //For unsorted catalogues
  //Messier Objects
  if (PS.UseCat[2]){
    for (int i=0;i<110;i++){
      if (show_mes[i]){
        RA=ra_mes[i];
        dec=dec_mes[i];

        //Get the screen coordinates
        proceed=SkyToScreen(&dec,&RA,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);

        //Draw the object
        if (proceed){
          SourceRect=Rect(PS.Symbol[type_mes[i]]*15,type_mes[i]*15,(PS.Symbol[type_mes[i]]+1)*15,(type_mes[i]+1)*15);
          ClipBitmap->Canvas->CopyRect(DestRect,DeepSkySymb->Canvas,SourceRect);
          BufImg->Canvas->Draw(x1-7,y1-7,ClipBitmap);
        }
      }
    }
  }

  //Draw Barnard clouds
  if (PS.UseCat[4]&&PS.ShowObjects[18]){
    for (int i=0;i<349;i++){
      RA=ra_bar[i];
      dec=dec_bar[i];

      //Get the screen coordinates
      proceed=SkyToScreen(&dec,&RA,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);

      //Draw the object
      if (proceed){
        SourceRect=Rect(PS.Symbol[18]*15,270,(PS.Symbol[18]+1)*15,285);
        ClipBitmap->Canvas->CopyRect(DestRect,DeepSkySymb->Canvas,SourceRect);
        BufImg->Canvas->Draw(x1-7,y1-7,ClipBitmap);
      }
    }
  }

  //Draw Arp galaxies
  if (PS.UseCat[5]&&PS.ShowObjects[5]){
    for (int i=0;i<338;i++){
      RA=ra_arp[i];
      dec=dec_arp[i];

      //Get the screen coordinates
      proceed=SkyToScreen(&dec,&RA,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);

      //Draw the object
      if (proceed){
        SourceRect=Rect(PS.Symbol[5]*15,75,(PS.Symbol[5]+1)*15,90);
        ClipBitmap->Canvas->CopyRect(DestRect,DeepSkySymb->Canvas,SourceRect);
        BufImg->Canvas->Draw(x1-7,y1-7,ClipBitmap);
      }
    }
  }

  //Draw RC3 galaxies
  if (PS.UseCat[6]&&PS.ShowObjects[5]){
    for (int l=0;l<432;l++){
      for (int i=NumRC3[l];i<NumRC3[l+1];i++){
        if (show_rc3[i]){
          RA=ra_rc3[i];
          dec=dec_rc3[i];

          //Get the screen coordinates
          proceed=SkyToScreen(&dec,&RA,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);

          //Draw the object
          if (proceed){
            //Determine whether the outline of the galaxy should be drawn
            //instead of a glyph
            if (PS.R0*a_rc3[i]/pi>=4){
              //Draw the ellipse representing the galaxy
              DrawGalaxyEllipse(&RA,&dec,&(a_rc3[i]),&(b_rc3[i]),&(pa_rc3[i]));
            } else {
              //Draw the glyph
              SourceRect=Rect(PS.Symbol[5]*15,75,(PS.Symbol[5]+1)*15,90);
              ClipBitmap->Canvas->CopyRect(DestRect,DeepSkySymb->Canvas,SourceRect);
              BufImg->Canvas->Draw(x1-7,y1-7,ClipBitmap);
            }
          }
        }
      }
    }
  }

  BufImg->Canvas->CopyMode=cmSrcCopy;
}
//---------------------------------------------------------------------------
//Draw the galaxy ellipse
void __fastcall TMainF::DrawGalaxyEllipse(float *RA,float *dec,float *a,float *b,float *pa)
{
  float dec_, RA_, sinpa, cospa, a2, b2, a4, b4;
  int x1=0, y1=0;

  //We will use Bezier curves to approximate the ellipse.  The control points
  //are taken to lie on the rectangle bounding the ellipse (i.e. with dimension a by b)
  a2=*a/4;
  b2=*b/4;
  a4=a2/2;
  b4=b2/2;
  sinpa=sin(pihalved+*pa);
  cospa=cos(pihalved+*pa);

  //First point (0,a/2) (this is also the last point)
  dec_=*dec - a2*sinpa;
  RA_=*RA + a2*cospa;
  SkyToScreen(&dec_,&RA_,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
  points[0]=Point(x1,y1);
  points[12]=Point(x1,y1);

  //Control point for first point (-b/4,a/2)
  dec_=*dec - b4*cospa - a2*sinpa;
  RA_=*RA - b4*sinpa + a2*cospa;
  SkyToScreen(&dec_,&RA_,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
  points[1]=Point(x1,y1);

  //Control point for second point (-b/2,a/4)
  dec_=*dec - b2*cospa - a4*sinpa;
  RA_=*RA - b2*sinpa + a4*cospa;
  SkyToScreen(&dec_,&RA_,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
  points[2]=Point(x1,y1);

  //Second point (-b/2,0)
  dec_=*dec - b2*cospa;
  RA_=*RA - b2*sinpa;
  SkyToScreen(&dec_,&RA_,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
  points[3]=Point(x1,y1);

  //Other control point for second point (-b/2,-a/4)
  dec_=*dec - b2*cospa + a4*sinpa;
  RA_=*RA - b2*sinpa - a4*cospa;
  SkyToScreen(&dec_,&RA_,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
  points[4]=Point(x1,y1);

  //Control point for third point (-b/4,-a/2)
  dec_=*dec - b4*cospa + a2*sinpa;
  RA_=*RA - b4*sinpa - a2*cospa;
  SkyToScreen(&dec_,&RA_,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
  points[5]=Point(x1,y1);

  //Third point (0,-a/2)
  dec_=*dec + a2*sinpa;
  RA_=*RA - a2*cospa;
  SkyToScreen(&dec_,&RA_,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
  points[6]=Point(x1,y1);

  //Other control point for third point (b/4,-a/2)
  dec_=*dec + b4*cospa + a2*sinpa;
  RA_=*RA + b4*sinpa - a2*cospa;
  SkyToScreen(&dec_,&RA_,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
  points[7]=Point(x1,y1);

  //Control point for fourth point (b/2,-a/4)
  dec_=*dec + b2*cospa + a4*sinpa;
  RA_=*RA + b2*sinpa - a4*cospa;
  SkyToScreen(&dec_,&RA_,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
  points[8]=Point(x1,y1);

  //Fourth point (b/2,0)
  dec_=*dec + b2*cospa;
  RA_=*RA + b2*sinpa;
  SkyToScreen(&dec_,&RA_,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
  points[9]=Point(x1,y1);

  //Other control point for fourth point (b/2,a/4)
  dec_=*dec + b2*cospa - a4*sinpa;
  RA_=*RA + b2*sinpa + a4*cospa;
  SkyToScreen(&dec_,&RA_,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
  points[10]=Point(x1,y1);

  //Control point for last point (b/4,a/2)
  dec_=*dec + b4*cospa - a2*sinpa;
  RA_=*RA + b4*sinpa + a2*cospa;
  SkyToScreen(&dec_,&RA_,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
  points[11]=Point(x1,y1);

  BufImg->Canvas->Pen->Color=CS.GalOutline;
  BufImg->Canvas->PolyBezier(points,12);
}
//---------------------------------------------------------------------------
//Draw the planets (i.e. all solar system objects)
void __fastcall TMainF::DrawPlanets(double T)
{
  static double T0=0;
  float lambda,q;
  int x1,y1;
  bool proceed;

  ClipBitmap->Width=15;
  ClipBitmap->Height=15;
  ClipBitmap->Canvas->Pen->Color=clNone;
  ClipBitmap->Canvas->Brush->Color=clNone;
  DestRect=Rect(0,0,15,15);
  BufImg->Canvas->CopyMode=cmSrcPaint;

  //Determine the obliquity and orbital elements
  //(only do this once a day, or as appropriate)
  if (fabs(T-T0)>1){
    GetObliquity(&T);
    T0=T;
  }
  GetOE(&T);

  //Get the solar heliocentric coordinate (actually the
  //negative of Earth's coordinates)
  EclSatCoord(0,&T);
  GeoSatCoord(0);

  //Case for satelites of the sun
  for (int i=1;i<PS.NSunSat;i++){
    //Get the heliocentric coordinates of the planet
    EclSatCoord(i,&T);
    //Convert to geocentric equatorial coordinates
    GeoSatCoord(i);
    //Apply light-time correction (if requested, a single
    //iteration is sufficient)
    if (PS.lighttime) {
      //Compute time taken for light to travel from the
      //planet to the earth (in fractional julian days)
      //173.26 = speed of light in Au/julian day
      T=T-OElem[i][11]/173.26; //"apparent" time
      //Recompute the heliocentric coordinates of the planet
      EclSatCoord(i,&T);
      //Convert to geocentric equatorial coordinates
      GeoSatCoord(i);
    }
    lambda=OElem[i][9];
    q=OElem[i][10];
    //Get the screen coordinates
    proceed=SkyToScreen(&q,&lambda,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
    if (proceed){
      SourceRect=Rect(PS.PlanetSymbol[SSData[i].SymbClass],SSData[i].SymbClass*15,(PS.PlanetSymbol[SSData[i].SymbClass]+1)*15,(SSData[i].SymbClass+1)*15);
      ClipBitmap->Canvas->CopyRect(DestRect,PlanetSymb->Canvas,SourceRect);
      BufImg->Canvas->Draw(x1-7,y1-7,ClipBitmap);
    }
  }

  //Case for the sun
  //Get the screen coordinates
  lambda=OElem[0][9];
  q=OElem[0][10];
  proceed=SkyToScreen(&q,&lambda,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
  if (proceed){
    SourceRect=Rect(PS.PlanetSymbol[0],30,(PS.PlanetSymbol[0]+1)*15,45);
    ClipBitmap->Canvas->CopyRect(DestRect,PlanetSymb->Canvas,SourceRect);
    BufImg->Canvas->Draw(x1-7,y1-7,ClipBitmap);
  }

  //Case for satelites of the earth
  for (int i=100;i<PS.NEarSat+100;i++){
    //Get the geocentric ecliptic coordinates of the satelite
    EclSatCoord(i,&T);
    //Convert to topocentric equatorial coordinates
    GeoSatCoord(i);
    lambda=OElem[i][9];
    q=OElem[i][10];
    //Get the screen coordinates
    proceed=SkyToScreen(&q,&lambda,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
    if (proceed){
      SourceRect=Rect(PS.PlanetSymbol[SSData[i].SymbClass],SSData[i].SymbClass*15,(PS.PlanetSymbol[SSData[i].SymbClass]+1)*15,(SSData[i].SymbClass+1)*15);
      ClipBitmap->Canvas->CopyRect(DestRect,PlanetSymb->Canvas,SourceRect);
      BufImg->Canvas->Draw(x1-7,y1-7,ClipBitmap);
    }
  }

  //Case for satelites of Mars
  for (int i=200;i<PS.NMarSat+200;i++){
    //Get the geocentric equatorial coordinates of the satelite
    EclSatCoord(i,&T);
    //Convert to geocentric equatorial coordinates
    GeoSatCoord(i);
    lambda=OElem[i][9];
    q=OElem[i][10];

    //Get the screen coordinates
    proceed=SkyToScreen(&q,&lambda,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
    if (proceed){
      BufImg->Canvas->Pen->Color=clWhite;
      BufImg->Canvas->Brush->Color=clWhite;
      BufImg->Canvas->Ellipse(x1-1,y1-1,x1+1,y1+1);
    }
  }

  //Case for satelites of Saturn
  for (int i=202;i<PS.NSatSat+202;i++){
    //Get the geocentric equatorial coordinates of the satelite
    EclSatCoord(i,&T);
    //Convert to geocentric equatorial coordinates
    GeoSatCoord(i);
    lambda=OElem[i][9];
    q=OElem[i][10];

    //Get the screen coordinates
    proceed=SkyToScreen(&q,&lambda,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
    if (proceed){
      BufImg->Canvas->Pen->Color=clWhite;
      BufImg->Canvas->Brush->Color=clWhite;
      BufImg->Canvas->Ellipse(x1-1,y1-1,x1+1,y1+1);
    }
  }

  //Case for satelites of Jupiter
  for (int i=209;i<PS.NJupSat+209;i++){
    //Get the geocentric equatorial coordinates of the satelite
    EclSatCoord(i,&T);
    //Convert to geocentric equatorial coordinates
    GeoSatCoord(i);
    lambda=OElem[i][9];
    q=OElem[i][10];

    //Get the screen coordinates
    proceed=SkyToScreen(&q,&lambda,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
    if (proceed){
      BufImg->Canvas->Pen->Color=clWhite;
      BufImg->Canvas->Brush->Color=clWhite;
      BufImg->Canvas->Ellipse(x1-1,y1-1,x1+1,y1+1);
    }
  }

  BufImg->Canvas->CopyMode=cmSrcCopy;
}
//---------------------------------------------------------------------------
//Draw the planet paths
void __fastcall TMainF::DrawPlanetPaths(double T)
{
  static double T0=0;
  double TC_, TC, incr;
  float lambda,q;
  int x1,y1;
  bool proceed, firstpoint;

  //Determine the obliquity (only do this once a day, or as appropriate)
  if (fabs(T-T0)>1){
    GetObliquity(&T);
    T0=T;
  }

  for (int i=0; i<211; i++){
    if (SSData[i].ShowPath){

      //Draw the planet path
      if (SSData[i].Increment>0.5 && SSData[i].ShowLines){
        incr=0.5;
        firstpoint=true;
        for (TC=T-SSData[i].PathSD; TC<T+SSData[i].PathED; TC+=incr){
          GetOE(&TC);

          //Get the solar heliocentric coordinate (actually the
          //negative of Earth's coordinates)
          EclSatCoord(0,&TC);
          GeoSatCoord(0);

          //Case for satelites of the sun
          if (i<PS.NSunSat && i!=0){
            //Get the heliocentric coordinates of the planet
            EclSatCoord(i,&TC);
            //Convert to geocentric equatorial coordinates
            GeoSatCoord(i);
            //Apply light-time correction if requested (a single
            //iteration is sufficient)
            if (PS.lighttime) {
              //Compute time taken for light to travel from the
              //planet to the earth (in fractional julian days)
              //173.26 = speed of light in Au/julian day
              TC_=TC-OElem[i][11]/173.26; //"apparent" time
              //Recompute the heliocentric coordinates of the planet
              EclSatCoord(i,&TC_);
              //Convert to geocentric equatorial coordinates
              GeoSatCoord(i);
            }
            lambda=OElem[i][9];
            q=OElem[i][10];
          }

          //Case for the sun
          if (i==0){
            //Get the screen coordinates
            lambda=OElem[0][9];
            q=OElem[0][10];
          }

          //Case for satelites of the earth, Mars, Jupiter and Saturn
          if (i>99){
            //Get the geocentric ecliptic coordinates of the satelite
            EclSatCoord(i,&TC);
            //Convert to topocentric equatorial coordinates
            GeoSatCoord(i);
            lambda=OElem[i][9];
            q=OElem[i][10];
          }

          //Get the screen coordinates
          proceed=SkyToScreen(&q,&lambda,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
          if (proceed){
            BufImg->Canvas->Pen->Color=SSData[i].LineCol;
            BufImg->Canvas->Brush->Color=SSData[i].LineCol;
            if (firstpoint) BufImg->Canvas->MoveTo(x1,y1);
            else BufImg->Canvas->LineTo(x1,y1);
            firstpoint=false;
          }
        }
      }

      //Draw the date points and labels
      for (TC=T-SSData[i].PathSD; TC<=T+SSData[i].PathED; TC+=SSData[i].Increment){
        GetOE(&TC);

        //Get the solar heliocentric coordinate (actually the
        //negative of Earth's coordinates)
        EclSatCoord(0,&TC);
        GeoSatCoord(0);

        //Case for satelites of the sun
        if (i<PS.NSunSat && i!=0){
          //Get the heliocentric coordinates of the planet
          EclSatCoord(i,&TC);
          //Convert to geocentric equatorial coordinates
          GeoSatCoord(i);
          //Apply light-time correction if requested (a single
          //iteration is sufficient)
          if (PS.lighttime) {
            //Compute time taken for light to travel from the
            //planet to the earth (in fractional julian days)
            //173.26 = speed of light in Au/julian day
            TC_=TC-OElem[i][11]/173.26; //"apparent" time
            //Recompute the heliocentric coordinates of the planet
            EclSatCoord(i,&TC_);
            //Convert to geocentric equatorial coordinates
            GeoSatCoord(i);
          }
          lambda=OElem[i][9];
          q=OElem[i][10];
        }

        //Case for the sun
        if (i==0){
          //Get the screen coordinates
          lambda=OElem[0][9];
          q=OElem[0][10];
        }

        //Case for satelites of the earth, Mars, Jupiter and Saturn
        if (i>99){
          //Get the geocentric ecliptic coordinates of the satelite
          EclSatCoord(i,&TC);
          //Convert to topocentric equatorial coordinates
          GeoSatCoord(i);
          lambda=OElem[i][9];
          q=OElem[i][10];
        }

        //Get the screen coordinates
        proceed=SkyToScreen(&q,&lambda,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);
        if (proceed){
          if (SSData[i].ShowPoints && TC!=T){
            BufImg->Canvas->Pen->Color=SSData[i].PointCol;
            BufImg->Canvas->Brush->Color=SSData[i].PointCol;
            BufImg->Canvas->Ellipse(x1-4,y1-4,x1+4,y1+4);
          }
          if (SSData[i].ShowLabels){
            BufImg->Canvas->Brush->Color=clBlack;
            BufImg->Canvas->Font->Color=SSData[i].LabelCol;
            BufImg->Canvas->Font->Size=8;
            BufImg->Canvas->TextOut(x1+9,y1-8,JulToGreg(TC));
            BufImg->Canvas->MoveTo(x1,y1);
          }
        }
      }
    }
  }
  //Restore current orbital elements
  GetOE(&T);
}
//---------------------------------------------------------------------------
//Draw the stars on the map
void __fastcall TMainF::ShowStars(int MaxVmag)
{
  float Ra,Declination;
  int symb_index,k,mag_index,base_index,index,size_index;

  initialize=true;
  BufImg->Canvas->CopyMode=cmSrcPaint;
  mag_index=(PS.MaxStarMag-150)/50;//(MaxVmag-150)/50;

  for (int l=0;l<432;l++){
    //Only draw stars for blocks that are visible
    if (DrawTag[l]){
      if (l>0) base_index=StarBlkIndex[mag_index][l-1];
      else base_index=0;
      for (k=0;k<StarBlkNum[mag_index][l];k++){
        index=base_index+k;
        Ra=ra_star[index];
        Declination=dec_star[index];
        size_index=symb_star[index]/7;
        symb_index=symb_star[index]-size_index*7+PS.StarSizes[size_index];
        DrawStar(&Ra,&Declination,&symb_index,&initialize);
      }
    }
  }
}
//---------------------------------------------------------------------------
//Draws a single star on the map
void __fastcall TMainF::DrawStar(float *RA,float *dec,int *symb_index,\
  bool *initialize)
{
  int x1,y1;
  bool proceed;

  if (AL.lat>pihalved) SouthHemisphere=true;

  //Get the screen coordinates
  proceed=SkyToScreen(dec,RA,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);

  //Draw the star
  if (proceed){
    if (*symb_index<7){
      SourceRect=Rect(*symb_index*12,0,(*symb_index+1)*12,12);
      ClipBitmap0->Canvas->CopyRect(DestRect0,Starpic0->Canvas,SourceRect);
      BufImg->Canvas->Draw(x1-6,y1-6,ClipBitmap0);
    } else { if (*symb_index<14){
      SourceRect=Rect((*symb_index-7)*11,0,(*symb_index-6)*11,11);
      ClipBitmap1->Canvas->CopyRect(DestRect1,Starpic1->Canvas,SourceRect);
      BufImg->Canvas->Draw(x1-6,y1-6,ClipBitmap1);
    } else { if (*symb_index<21){
      SourceRect=Rect((*symb_index-14)*10,0,(*symb_index-13)*10,10);
      ClipBitmap2->Canvas->CopyRect(DestRect2,Starpic2->Canvas,SourceRect);
      BufImg->Canvas->Draw(x1-5,y1-5,ClipBitmap2);
    } else { if (*symb_index<28){
      SourceRect=Rect((*symb_index-21)*9,0,(*symb_index-20)*9,9);
      ClipBitmap3->Canvas->CopyRect(DestRect3,Starpic3->Canvas,SourceRect);
      BufImg->Canvas->Draw(x1-5,y1-5,ClipBitmap3);
    } else { if (*symb_index<35){
      SourceRect=Rect((*symb_index-28)*8,0,(*symb_index-27)*8,8);
      ClipBitmap4->Canvas->CopyRect(DestRect4,Starpic4->Canvas,SourceRect);
      BufImg->Canvas->Draw(x1-4,y1-4,ClipBitmap4);
    } else { if (*symb_index<42){
      SourceRect=Rect((*symb_index-35)*7,0,(*symb_index-34)*7,7);
      ClipBitmap5->Canvas->CopyRect(DestRect5,Starpic5->Canvas,SourceRect);
      BufImg->Canvas->Draw(x1-4,y1-4,ClipBitmap5);
    } else { if (*symb_index<49){
      SourceRect=Rect((*symb_index-42)*6,0,(*symb_index-41)*6,6);
      ClipBitmap6->Canvas->CopyRect(DestRect6,Starpic6->Canvas,SourceRect);
      BufImg->Canvas->Draw(x1-3,y1-3,ClipBitmap6);
    } else { if (*symb_index<56){
      SourceRect=Rect((*symb_index-49)*5,0,(*symb_index-48)*5,5);
      ClipBitmap7->Canvas->CopyRect(DestRect7,Starpic7->Canvas,SourceRect);
      BufImg->Canvas->Draw(x1-2,y1-2,ClipBitmap7);
    } else { if (*symb_index<63){
      SourceRect=Rect((*symb_index-56)*4,0,(*symb_index-55)*4,4);
      ClipBitmap8->Canvas->CopyRect(DestRect8,Starpic8->Canvas,SourceRect);
      BufImg->Canvas->Draw(x1-2,y1-2,ClipBitmap8);
    } else { if (*symb_index<70){
      SourceRect=Rect((*symb_index-63)*3,0,(*symb_index-62)*3,3);
      ClipBitmap9->Canvas->CopyRect(DestRect9,Starpic9->Canvas,SourceRect);
      BufImg->Canvas->Draw(x1-1,y1-1,ClipBitmap9);
    } else { if (*symb_index<77){
      SourceRect=Rect((*symb_index-70)*2,0,(*symb_index-69)*2,2);
      ClipBitmap10->Canvas->CopyRect(DestRect10,Starpic10->Canvas,SourceRect);
      BufImg->Canvas->Draw(x1-1,y1-1,ClipBitmap10);
    } else { if (*symb_index<84){
      SourceRect=Rect(*symb_index-77,0,*symb_index-76,1);
      ClipBitmap11->Canvas->CopyRect(DestRect11,Starpic11->Canvas,SourceRect);
      BufImg->Canvas->Draw(x1,y1,ClipBitmap11);
    }}}}}}}}}}}}
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainF::Lambert1Click(TObject *Sender)
{
  Lambert1->Checked=true;
  PS.Projection=1;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainF::Plane1Click(TObject *Sender)
{
  Plane1->Checked=true;
  PS.Projection=2;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainF::Mercator1Click(TObject *Sender)
{
  Mercator1->Checked=true;
  PS.Projection=3;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainF::Stereographic1Click(TObject *Sender)
{
  Stereographic1->Checked=true;
  PS.Projection=0;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainF::StarSettingClick(TObject *Sender)
{
  StarSettings->ShowModal();
}
//---------------------------------------------------------------------------
//Call up the object information form
void __fastcall TMainF::FindObject()
{
  //Find closest object to the coordinates

  //Look through the list of displayed stars for the closest
  //star to the screen point, but narrow down the search by
  //comparing with the coordinates of the first star in each
  //displayed block.
  short best_i,best_j;
  short l;
  double T,T0;
  int MagIndex,BaseIndex,Index,Cat_Num[20],best_index;
  float q=0,lambda=0,q_,lambda_,qdiff,ldiff;
  float distsq,best_distsq,bestFMT;
  float FMT[20]; //FMT[0]=stars, FMT[1]=planets, FMT[i>1]=catalog[i-2]
  int closest;   //closest=0 -> stars, closest=1 -> planets, closest>1 -> catalog[i-2]

  //Initialize matrix variables
  for (int i=0;i<n_cat+2;i++){
    FMT[i]=1e+8;
    Cat_Num[i]=0;
  }

  //Get the sky coordinates
  ScreenToSky(&x0,&y0,&q,&lambda,&(PS.R0),&(PS.w2),&(PS.h2));

  //Get the catalog RA block in which the object was found, remember that you
  //must use the coordinates precessed back to the Epoch for which the catalog
  //is valid.
  lambda_=lambda;
  q_=q;
  T0=PS.StartEpoch[1];
  T=PS.Epoch;
  Precess_sp(&lambda_,&q_,&T0,&T);
  best_i=24*(lambda_/twopi);
  best_j=18*((pihalved-q_)/pi);
  l=(short)(best_i*18+best_j);

  //Look for the closest star in block l
  if (PS.ShowStars){
    MagIndex=(PS.MaxStarMag-150)/50;
    if (l>0) BaseIndex=StarBlkIndex[MagIndex][l-1];
    else BaseIndex=0;
    best_distsq=10e+8;
    for (int k=0;k<StarBlkNum[MagIndex][l];k++){
      Index=BaseIndex+k;
      qdiff=dec_star[Index]-q_;
      ldiff=ra_star[Index]-lambda_;
      distsq=qdiff*qdiff+ldiff*ldiff;
      if (distsq<best_distsq){
        best_distsq=distsq;
        best_index=(short)Index;
      }
    }
    FMT[0]=best_distsq;  //Figure of merit for closest star position
    CatNum[0]=num_star[best_index];
  }

  //Look for the closest planet
  if (PS.ShowPlanets){
    best_distsq=1e+8;
    //Search satelites of sun
    for (int i=0;i<PS.NSunSat;i++){
      qdiff=OElem[i][10]-q;
      ldiff=OElem[i][9]-lambda;
      distsq=qdiff*qdiff+ldiff*ldiff;
      if (distsq<best_distsq){
        best_distsq=distsq;
        best_i=(short)i;
      }
    }
    //Search satelites of earth
    for (int i=100;i<100+PS.NEarSat;i++){
      qdiff=OElem[i][10]-q;
      ldiff=OElem[i][9]-lambda;
      distsq=qdiff*qdiff+ldiff*ldiff;
      if (distsq<best_distsq){
        best_distsq=distsq;
        best_i=(short)i;
      }
    }
    CatNum[1]=best_i;
    FMT[1]=best_distsq;
  }

  //Look for the closest displayed RNGC object
  if (PS.ShowDeepSky&&PS.UseCat[0]){
    best_distsq=10000000;
    for (int i=0;i<NumNGC[l];i++){
      if (show_ngc[l][i]){
        qdiff=dec_ngc[l][i]-q;
        ldiff=ra_ngc[l][i]-lambda;
        distsq=qdiff*qdiff+ldiff*ldiff;
        if (distsq<best_distsq){
          best_distsq=distsq;
          best_i=(short)i;
        }
      }
    }
    FMT[2]=best_distsq;  //Figure of merit for closest RNGC object
    CatNum[2]=num_ngc[l][best_i];
    ExtNum=ext_ngc[l][best_i];
  }

  //Look for the closest displayed IC object
  if (PS.ShowDeepSky&&PS.UseCat[1]){
    best_distsq=10000000;
    for (int i=0;i<NumIC[l];i++){
      if (show_ic[l][i]){
        qdiff=dec_ic[l][i]-q;
        ldiff=ra_ic[l][i]-lambda;
        distsq=qdiff*qdiff+ldiff*ldiff;
        if (distsq<best_distsq){
          best_distsq=distsq;
          best_i=(short)i;
        }
      }
    }
    FMT[3]=best_distsq;  //Figure of merit for closest IC object
    CatNum[3]=num_ic[l][best_i];
  }

  //Look for the closest displayed Messier object (exhaustive search)
  if (PS.ShowDeepSky&&PS.UseCat[2]){
    best_distsq=10000000;
    for (int i=0;i<110;i++){
      if (show_mes[i]){
        qdiff=dec_mes[i]-q;
        ldiff=ra_mes[i]-lambda;
        distsq=qdiff*qdiff+ldiff*ldiff;
        if (distsq<best_distsq){
          best_distsq=distsq;
          CatNum[4]=i+1;
        }
      }
    }
    FMT[4]=best_distsq;  //Figure of merit for closest Messier object
  }

  //Look for the closest displayed Lynd cloud
  if (PS.ShowDeepSky&&PS.UseCat[3]&&PS.ShowObjects[18]){
    best_distsq=10000000;
    for (int i=0;i<NumLyn[l];i++){
      qdiff=dec_lyn[l][i]-q;
      ldiff=ra_lyn[l][i]-lambda;
      distsq=qdiff*qdiff+ldiff*ldiff;
      if (distsq<best_distsq){
        best_distsq=distsq;
        best_i=(short)i;
      }
    }
    FMT[5]=best_distsq;  //Figure of merit for closest Lynd cloud
    CatNum[5]=num_lyn[l][best_i];
  }

  //Look for the closest displayed Barnard cloud
  if (PS.ShowDeepSky&&PS.UseCat[4]&&PS.ShowObjects[18]){
    best_distsq=10000000;
    for (int i=0;i<349;i++){
      qdiff=dec_bar[i]-q;
      ldiff=ra_bar[i]-lambda;
      distsq=qdiff*qdiff+ldiff*ldiff;
      if (distsq<best_distsq){
        best_distsq=distsq;
        best_i=(short)i;
      }
    }
    FMT[6]=best_distsq;  //Figure of merit for closest Barnard cloud
    CatNum[6]=num_bar[best_i];
    ExtNum=ext_bar[best_i];
  }

  //Look for the closest displayed Arp galaxy
  if (PS.ShowDeepSky&&PS.UseCat[5]&&PS.ShowObjects[5]){
    best_distsq=10000000;
    for (int i=0;i<338;i++){
      qdiff=dec_arp[i]-q;
      ldiff=ra_arp[i]-lambda;
      distsq=qdiff*qdiff+ldiff*ldiff;
      if (distsq<best_distsq){
        best_distsq=distsq;
        best_i=(short)i;
      }
    }
    FMT[7]=best_distsq;  //Figure of merit for closest Arp galaxy
    CatNum[7]=best_i+1;
  }

  //Look for the closest displayed RC3 galaxy
  if (PS.ShowDeepSky&&PS.UseCat[6]&&PS.ShowObjects[5]){
    best_distsq=10000000;
    for (int i=0;i<23011;i++){//(int i=NumRC3[l];i<NumRC3[l+1];i++){
      if (show_rc3[i]){
        qdiff=dec_rc3[i]-q;
        ldiff=ra_rc3[i]-lambda;
        distsq=qdiff*qdiff+ldiff*ldiff;
        if (distsq<best_distsq){
          best_distsq=distsq;
          best_i=(short)i;
        }
      }
    }
    FMT[8]=best_distsq;  //Figure of merit for closest RC3 object
    CatNum[8]=num_rc3[best_i];
  }

  //Decide what type of object is closest
  bestFMT=1e+8;
  for (int i=0;i<n_cat+2;i++){
    if (FMT[i]<bestFMT) {
      closest=i;
      bestFMT=FMT[i];
    }
  }
  SelectedCatalogue=closest-2;
  ObjectInfo->ShowModal();
  drawing=false;
}
//---------------------------------------------------------------------------
//Load location form
void __fastcall TMainF::Location1Click(TObject *Sender)
{
  Location->ShowModal();
}
//---------------------------------------------------------------------------
//Load time/date form
void __fastcall TMainF::DateTimeClick(TObject *Sender)
{
  TimeDate->ShowModal();
}
//---------------------------------------------------------------------------
//Load non-stellar object settings form
void __fastcall TMainF::NonStellarClick(TObject *Sender)
{
  NonStellarSet->ShowModal();

  //Draw the star map
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
//Save settings as default
void __fastcall TMainF::SaveSettingDEFClick(TObject *Sender)
{
  SaveSettings(PS.ProgPath+"SkyAtlas.ini");
}
//---------------------------------------------------------------------------
//Save settings as...
void __fastcall TMainF::SaveSettingASClick(TObject *Sender)
{
  SaveSet->InitialDir=PS.ProgPath;
  SaveSet->Execute();
  SaveSettings(SaveSet->FileName);
}
//---------------------------------------------------------------------------
//Load settings
void __fastcall TMainF::LoadSetASClick(TObject *Sender)
{
  LoadSet->InitialDir=PS.ProgPath;
  LoadSet->Execute();
  LoadSettings(LoadSet->FileName);
}
//---------------------------------------------------------------------------
//Key press event handler
void __fastcall TMainF::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
  //PgUp and PgDown keys control the scale factor
  if (Key==VK_PRIOR||Key==VK_NEXT){
    if (Key==VK_PRIOR) PS.R0=PS.R0*1.5;
    else PS.R0=PS.R0/1.5;
    if (PS.R0>40*PS.w) PS.R0=40*PS.w;
    if (PS.R0<PS.w2) PS.R0=PS.w2;

    //Draw the incomplete map
    if (!DrawingMap){ //Avoids conflicts with other threads
      DrawingMap=true;
      DrawMap(400,true);
      DrawingMap=false;
    }
  }
}
//---------------------------------------------------------------------------
//Key up event handler
void __fastcall TMainF::FormKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  ResetTimer=true;
  if (!TimerOn){
    TThread *KeyTimer = new KeyThread(true);
    KeyTimer->Resume();
  }
}
//---------------------------------------------------------------------------
//Increase the scale
void __fastcall TMainF::ZoomInClick(TObject *Sender)
{
  PS.R0=PS.R0*1.5;
  if (PS.R0>40*PS.w) PS.R0=40*PS.w;

  //Draw the incomplete map
  if (!DrawingMap){ //Avoids conflicts with other threads
    DrawingMap=true;
    DrawMap(400,true);
    DrawingMap=false;
  }

  ResetTimer=true;
  if (!TimerOn){
    TThread *KeyTimer = new KeyThread(true);
    KeyTimer->Resume();
  }
  DefocusControl(ZoomIn,false);
}
//---------------------------------------------------------------------------
//Decrease the scale
void __fastcall TMainF::ZoomOutClick(TObject *Sender)
{
  PS.R0=PS.R0/1.5;
  if (PS.Projection==3){
    if (PS.R0<PS.w2/pihalved) PS.R0=PS.w2/pihalved;
  } else {
    if (PS.R0<PS.w2) PS.R0=PS.w2;
  }

  //Draw the incomplete map
  if (!DrawingMap){ //Avoids conflicts with other threads
    DrawingMap=true;
    DrawMap(400,true);
    DrawingMap=false;
  }

  ResetTimer=true;
  if (!TimerOn){
    TThread *KeyTimer = new KeyThread(true);
    KeyTimer->Resume();
  }
  DefocusControl(ZoomOut,false);
}
//---------------------------------------------------------------------------
//Set the scale to 1
void __fastcall TMainF::Zoom1Click(TObject *Sender)
{
  PS.R0=PS.w2;

  //Draw the incomplete map
  if (!DrawingMap){ //Avoids conflicts with other threads
    DrawingMap=true;
    DrawMap(400,true);
    DrawingMap=false;
  }

  ResetTimer=true;
  if (!TimerOn){
    TThread *KeyTimer = new KeyThread(false);
    KeyTimer->Resume();
  }
  DefocusControl(Zoom1,false);
}
//---------------------------------------------------------------------------
void __fastcall TMainF::HorizonMaskClick(TObject *Sender)
{
  HorizonMask->Checked=!HorizonMask->Checked;
  PS.HorizonMask=!PS.HorizonMask;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
//Redraw the map
void __fastcall TMainF::DrawMap(int MaxStarMag,bool OnlyStars)
{
  //Erase the canvas (actually, this provides the color
  //for the map beyond the edge of the field of view)
  if (PS.R0<4*PS.w){
    BufImg->Canvas->Pen->Color=CS.BackGnd;
    BufImg->Canvas->Brush->Color=CS.BackGnd;
    BufImg->Canvas->Rectangle(0,0,PS.w,PS.h);
  }

  //Draw the sky
  BufImg->Canvas->Pen->Color=CS.Sky;
  BufImg->Canvas->Brush->Color=CS.Sky;
  if (PS.R0<4*PS.w){
    if (PS.Projection==0){
      BufImg->Canvas->Ellipse(PS.w2-PS.R0/2,PS.h2-PS.R0/2,PS.w2+PS.R0/2,PS.h2+PS.R0/2);
    } else {if (PS.Projection==1){
      BufImg->Canvas->Ellipse(PS.w2-PS.R0,PS.h2-PS.R0,PS.w2+PS.R0,PS.h2+PS.R0);
    } else {if (PS.Projection==2){
      BufImg->Canvas->Rectangle(0,0,PS.w,PS.h);
    } else {
      BufImg->Canvas->Rectangle(PS.w2-PS.R0*pihalved,0,PS.w2+PS.R0*pihalved,PS.h);
    }}}
  } else {
    //In this case the edge of the field of view is not visible,
    //so just paint the entire screen
    BufImg->Canvas->Rectangle(0,0,PS.w,PS.h);
  }

  //Get the latitude and longitude range
  float min_lambda,max_lambda,min_q,max_q;
  LongLatRange(&min_lambda,&max_lambda,&min_q,&max_q);

  if (PS.DrawConstLab) DrawConstLab();
  if (PS.ShowGrid) DrawGrid(&min_lambda,&max_lambda,&min_q,&max_q);
  if (PS.ShowHorLine) DrawIntersects(0);
  if (PS.ShowEclLine) DrawIntersects(1);
  if (PS.ShowGalLine) DrawIntersects(2);
  if (PS.DrawConstBound&&!OnlyStars) DrawConstBound();
  if (PS.DrawConstFig) DrawConstFig();
  if (PS.ShowStars) ShowStars(MaxStarMag);
  if (PS.ShowPlanetPaths&&!OnlyStars) DrawPlanetPaths(PS.time.jul);
  if (PS.ShowPlanets&&!OnlyStars) DrawPlanets(PS.time.jul);

  if (PS.ShowDeepSky&&!OnlyStars) DrawRNGC();
  DrawHighlights();
  Image->Picture->Bitmap=BufImg;
  Image->Repaint();
}
//---------------------------------------------------------------------------
//Location drop-down box
void __fastcall TMainF::LocationBoxChange(TObject *Sender)
{
  PS.location=FavLocs[LocationBox->ItemIndex];
  LoadLocation(PS.location);
  StatusBar->Panels->Items[2]->Text=LocationBox->Text;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
  DefocusControl(LocationBox,false);
}
//---------------------------------------------------------------------------
//Local time drop down box
void __fastcall TMainF::TimeSkipChange(TObject *Sender)
{
  //Advance the time
  double d[15]={0,0.041666666,0.083333333,0.166666666,0.33333,0.5,1.0,\
                2.0,4.0,7.0,14.0,30.0,60.0,120.0,365.0};
  PS.time=AddSeconds(GetTime(),d[TimeSkip->ItemIndex]);
  PS.time.jul=GregToJul(PS.time);

  //Get Sidereal Time
  float angle;
  angle=GetLST();
  FirstCircle(&angle);
  AL.l_ori=angle;

  //Update time captions
  StatusBar->Panels->Items[3]->Text="LT: "+GetTimeDateS(PS.time)+ "  JD: "+FormatFloat("###########0.00",PS.time.jul);

  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
  DefocusControl(TimeSkip,false);
}
//---------------------------------------------------------------------------
void __fastcall TMainF::CoordinateGridClick(TObject *Sender)
{
  CoordinateGrid->Checked=!CoordinateGrid->Checked;
  PS.ShowGrid=!PS.ShowGrid;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainF::StarsClick(TObject *Sender)
{
  Stars->Checked=!Stars->Checked;
  PS.ShowStars=!PS.ShowStars;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainF::DeepSkyObjectsClick(TObject *Sender)
{
  DeepSkyObjects->Checked=!DeepSkyObjects->Checked;
  PS.ShowDeepSky=!PS.ShowDeepSky;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainF::ShowPlanetsClick(TObject *Sender)
{
  ShowPlanets->Checked=!ShowPlanets->Checked;
  PS.ShowPlanets=!PS.ShowPlanets;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
//Displays mouse coordinates and center coordinates
void __fastcall TMainF::DrawCoord(int *X, int *Y,bool DrawMouseCoord,bool DrawCtrCoord)
{
  float q=0,lambda=0;
  float elev,Az;
  Az=AL.azim;
  elev=AL.incl;

  //Displays the sky coordinates of the mouse position
  if (DrawMouseCoord){
    ScreenToSky(X,Y,&q,&lambda,&(PS.R0),&(PS.w2),&(PS.h2));
    if (PS.MouseCoordType==0){
      StatusBar->Panels->Items[0]->Text=GetRAString(lambda)+", "+GetDecString(q,false);
    } else {
      if (PS.MouseCoordType==1){
        EquToHor(&lambda,&q,&Az,&elev,AL.l_ori);
        StatusBar->Panels->Items[0]->Text=GetDecString(elev,false)+", "+GetDecString(Az,false);
      } else {
        if (PS.MouseCoordType==2){
          EqToGal(&lambda,&q);
          StatusBar->Panels->Items[0]->Text=GetDecString(lambda,false)+", "+GetDecString(q,false);
        } else {
          EqToEcl(&lambda,&q);
          StatusBar->Panels->Items[0]->Text=GetDecString(lambda,false)+", "+GetDecString(q,false);
        }
      }
    }
  }

  //Display the center coordinates
  if (DrawCtrCoord){
    if (PS.CenterCoordType==0){
      HorToEqu(&elev,&Az,&q,&lambda);
      StatusBar->Panels->Items[1]->Text=GetRAString(lambda)+", "+GetDecString(q,false);
    } else {
      if (PS.CenterCoordType==1){
        StatusBar->Panels->Items[1]->Text=GetDecString(elev,false)+", "+GetDecString(Az,false);
      } else {
        if (PS.CenterCoordType==2){
          HorToEqu(&elev,&Az,&q,&lambda);
          EqToGal(&lambda,&q);
          StatusBar->Panels->Items[1]->Text=GetDecString(lambda,false)+", "+GetDecString(q,false);
        } else {
          HorToEqu(&elev,&Az,&q,&lambda);
          EqToEcl(&lambda,&q);
          StatusBar->Panels->Items[1]->Text=GetDecString(lambda,false)+", "+GetDecString(q,false);
        }
      }
    }
  }
}
//---------------------------------------------------------------------------
//Highlights the items in the highlight list
void __fastcall TMainF::DrawHighlights(void)
{
  for (int i=0;i<HighlightNum;i++){
    Highlight(&i,true);
  }
}
//---------------------------------------------------------------------------
//Highlights or removes highlight from an item in the highlighted object list
void __fastcall TMainF::Highlight(int *ItemIndex,bool HighlightState)
{
  float dec,ra;
  int x1,y1;
  dec=HO[*ItemIndex].dec;
  ra=HO[*ItemIndex].ra;
  FirstCircle(&ra);
  SkyToScreen(&dec,&ra,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);

  if (HighlightState){
    BufImg->Canvas->Brush->Style=bsClear;
    BufImg->Canvas->Pen->Color=CS.HighLight;
    BufImg->Canvas->Pen->Width=2;
    BufImg->Canvas->Ellipse(x1-8,y1-8,x1+8,y1+8);
  } else {
    BufImg->Canvas->Brush->Style=bsClear;
    BufImg->Canvas->Pen->Color=CS.BackGnd;
    BufImg->Canvas->Pen->Width=2;
    BufImg->Canvas->Ellipse(x1-8,y1-8,x1+8,y1+8);
  }
}
//---------------------------------------------------------------------------
//This timer redraws the screen at the appropriate interval
//if required
void __fastcall TMainF::RedrawTimerTimer(TObject *Sender)
{
  if (PS.RedrawInterval!=0){
    //Advance the time
    AdvanceTime();
    GregToJul(PS.time);

    //Update display
    UpdateDisplay(Sender);

    //Update object info (if visible)
    if (ObjectInfo->Visible){ObjectInfo->ShowInfo(Sender,PS.time);}
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainF::Every01Second1Click(TObject *Sender)
{
  PS.RedrawInterval=100;
  RedrawTimer->Interval=PS.RedrawInterval;
  Every01Second1->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::EverySecond1Click(TObject *Sender)
{
  PS.RedrawInterval=1000;
  RedrawTimer->Interval=PS.RedrawInterval;
  EverySecond1->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::Every5seconds1Click(TObject *Sender)
{
  PS.RedrawInterval=5000;
  RedrawTimer->Interval=PS.RedrawInterval;
  Every5seconds1->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::Every15seconds1Click(TObject *Sender)
{
  PS.RedrawInterval=15000;
  RedrawTimer->Interval=PS.RedrawInterval;
  Every15seconds1->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::Every30seconds1Click(TObject *Sender)
{
  PS.RedrawInterval=30000;
  RedrawTimer->Interval=PS.RedrawInterval;
  Every30seconds1->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::Everyminute1Click(TObject *Sender)
{
  PS.RedrawInterval=60000;
  RedrawTimer->Interval=PS.RedrawInterval;
  Everyminute1->Checked=true;
}
//---------------------------------------------------------------------------

void __fastcall TMainF::Every2minutes1Click(TObject *Sender)
{
  PS.RedrawInterval=120000;
  RedrawTimer->Interval=PS.RedrawInterval;
  Every2minutes1->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::Every5minutes1Click(TObject *Sender)
{
  PS.RedrawInterval=300000;
  RedrawTimer->Interval=PS.RedrawInterval;
  Every5minutes1->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::Onlywhenasked1Click(TObject *Sender)
{
  PS.RedrawInterval=0;
  RedrawTimer->Interval=PS.RedrawInterval;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::UpdateButClick(TObject *Sender)
{
  //Advance the time
  AdvanceTime();

  //Get sidereal time
  float angle;
  angle=GetLST();
  FirstCircle(&angle);
  AL.l_ori=angle;

  int X=PS.w2, Y=PS.h2;
  DrawCoord(&X,&Y,true,true);

  //Update time captions
  StatusBar->Panels->Items[3]->Text="LT: "+GetTimeDateS(PS.time)+ "  JD: "+FormatFloat("###########0.00",PS.time.jul);

  //Draw the map
  if (!DrawingMap){
    DrawingMap=true;
    MainF->DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainF::RealTimeClick(TObject *Sender)
{
  PS.ClockRate=1;
  RealTime->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::MinuteClick(TObject *Sender)
{
  PS.ClockRate=60;
  Minute->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::QHourClick(TObject *Sender)
{
  PS.ClockRate=900;
  QHour->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::HHourClick(TObject *Sender)
{
  PS.ClockRate=1800;
  HHour->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::Hour1Click(TObject *Sender)
{
  PS.ClockRate=3600;
  Hour1->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::Day1Click(TObject *Sender)
{
  PS.ClockRate=86400;
  Day1->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::MonthClick(TObject *Sender)
{
  PS.ClockRate=2629800;
  Month->Checked=true;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::Year1Click(TObject *Sender)
{
  PS.ClockRate=31557600;
  Year1->Checked=true;
}
//---------------------------------------------------------------------------
//Draws the constellation boundary lines
void __fastcall TMainF::DrawConstBound(void)
{
  BufImg->Canvas->Pen->Width=1;
  BufImg->Canvas->Pen->Color=CS.ConstBnd;

  float ra,dec;
  bool proceed;
  bool started;
  int index,x1,y1,lastx1,lasty1;

  //Draw constellation boundary lines
  for (int i=0;i<102;i++){
    index=0;
    started=false;
    for (int j=ConstTot[i];j<ConstTot[i+1];j++){
      ra=ConstRA[j];
      FirstCircle(&ra);
      dec=ConstDec[j];
      proceed=SkyToScreen(&dec,&ra,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);

      if (j==ConstTot[i]){
        lastx1=x1;
        lasty1=y1;
      }

      if (proceed&&(abs(lastx1-x1)<PS.h)&&(abs(lasty1-y1)<PS.h)){
        started=true;
        //Add the point to the line
        points[index].x=x1;
        points[index].y=y1;
        index++;
      } else {
        if (started&&index>1) {
          //The line started but now has stopped, draw the
          //segment
          BufImg->Canvas->Polyline(points,index-1);
          //Reset the drawing index and tags so that a
          //new segment may be drawn (if a valid segment
          //comes up)
          started=false;
          index=0;
        }
      }
      lastx1=x1;
      lasty1=y1;
    }
    if (started&&index>1){
      if (proceed) BufImg->Canvas->Polyline(points,index-1);
      else BufImg->Canvas->Polyline(points,index);
    }
  }
}
//---------------------------------------------------------------------------
//Draws the constellation figures
void __fastcall TMainF::DrawConstFig(void)
{
  BufImg->Canvas->Pen->Width=1;
  BufImg->Canvas->Pen->Color=CS.ConstFig;

  float ra,dec;
  int index,x1,y1,lastx1=0,lasty1=0;

  int N=0, N2=0;
  for (int i=0;i<79;i++){
    for (int j=0;j<ConstFigNSeg[i];j++){
      index=0;
      for (int k=0;k<ConstFigNPts[N2];k++){
        ra=ConstFigRA[N];
        dec=ConstFigDec[N];
        SkyToScreen(&dec,&ra,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),true);
        N++;

        if (k==0||((x1-lastx1)>=PS.w)||((y1-lasty1)>=PS.h)) BufImg->Canvas->MoveTo(x1,y1);
        else BufImg->Canvas->LineTo(x1,y1);

        lastx1=x1;
        lasty1=y1;
        index++;
      }
      N2++;
    }
  }
}
//---------------------------------------------------------------------------
//Draws the constellation labels
void __fastcall TMainF::DrawConstLab(void)
{
  BufImg->Canvas->Font->Color=CS.ConstLab;
  BufImg->Canvas->Brush->Color=CS.Sky;

  float ra,dec;
  int x1,y1;
  bool proceed;

  for (int i=0;i<88;i++){
    ra=ConstLabRA[i];
    dec=ConstLabDec[i];
    proceed=SkyToScreen(&dec,&ra,&x1,&y1,&(PS.R0),&(PS.w2),&(PS.h2),false);

    if (proceed){
      BufImg->Canvas->TextOut(x1-ConstLabel[i].Length()/2,y1,ConstLabel[i]);
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainF::ConstellationBoundaries1Click(TObject *Sender)
{
  ConstellationBoundaries1->Checked=!ConstellationBoundaries1->Checked;
  PS.DrawConstBound=!PS.DrawConstBound;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainF::ConstellationFigures1Click(TObject *Sender)
{
  ConstellationFigures1->Checked=!ConstellationFigures1->Checked;
  PS.DrawConstFig=!PS.DrawConstFig;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainF::ConstellationLabels1Click(TObject *Sender)
{
  ConstellationLabels1->Checked=!ConstellationLabels1->Checked;
  PS.DrawConstLab=!PS.DrawConstLab;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
//Hide or show tool bar
void __fastcall TMainF::ToolBar3Click(TObject *Sender)
{
  ToolBar3->Checked=!ToolBar3->Checked;
  ToolBar2->Visible=ToolBar3->Checked;

  SetFormSizes(Sender);

  PS.h=BufImg->Height;
  PS.h2=PS.h/2;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
//Hide or show coordinates
void __fastcall TMainF::EclipticPlane1Click(TObject *Sender)
{
  EclipticPlane1->Checked=!EclipticPlane1->Checked;
  PS.ShowEclLine=EclipticPlane1->Checked;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainF::GalacticPlane1Click(TObject *Sender)
{
  GalacticPlane1->Checked=!GalacticPlane1->Checked;
  PS.ShowGalLine=GalacticPlane1->Checked;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainF::HorizonPlane1Click(TObject *Sender)
{
  HorizonPlane1->Checked=!HorizonPlane1->Checked;
  PS.ShowHorLine=HorizonPlane1->Checked;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
//Update display
void __fastcall TMainF::UpdateClick(TObject *Sender)
{
  //Advance the time
  AdvanceTime();

  //Update display
  UpdateDisplay(Sender);

  DefocusControl(Update,false);
}
//---------------------------------------------------------------------------
//Update display (doesn't advance the time)
void __fastcall TMainF::UpdateDisplay(TObject *Sender)
{
  //Update time captions
  StatusBar->Panels->Items[3]->Text="LT: "+GetTimeDateS(PS.time)+ "  JD: "+FormatFloat("###########0.00",PS.time.jul);

  //Get sidereal time
  PS.time;
  float angle;
  angle=GetLST();
  FirstCircle(&angle);
  AL.l_ori=angle;

  int X=PS.w2, Y=PS.h2;
  MainF->DrawCoord(&X,&Y,false,true);

  //Draw the map
  if (!DrawingMap){
    DrawingMap=true;
    MainF->DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
//Show the legend bar
void __fastcall TMainF::ShowLegendClick(TObject *Sender)
{
  ShowLegend->Checked=!ShowLegend->Checked;
  Legend->Visible=ShowLegend->Checked;
  PS.ShowLegend=Legend->Visible;

  SetFormSizes(Sender);

  PS.h=BufImg->Height;
  PS.h2=PS.h/2;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
//Set the drawing canvas based on the form size
void __fastcall TMainF::SetFormSizes(TObject *Sender)
{
  Image->Width=ClientWidth-VScrollBar->Width;
  if (PS.ShowLegend) Image->Height=ClientHeight-HScrollBar->Height-StatusBar->Height-Legend->Height;
  else Image->Height=ClientHeight-HScrollBar->Height-StatusBar->Height;

  BufImg->Width=Image->Width;
  BufImg->Height=Image->Height;
  PS.w=Image->Width;
  PS.w2=PS.w/2;
  PS.h=Image->Height;
  PS.h2=PS.h/2;
  int X=PS.w2, Y=PS.h2;
  MainF->DrawCoord(&X,&Y,true,true);
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
//Hide or show legend
void __fastcall TMainF::LegendButClick(TObject *Sender)
{
  ShowLegendClick(Sender);
  DefocusControl(LegendBut,false);
}
//---------------------------------------------------------------------------
void __fastcall TMainF::EquCoordinates1Click(TObject *Sender)
{
  EquCoordinates1->Checked=true;
  PS.CenterCoordType=0;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::HorCoordinates1Click(TObject *Sender)
{
  HorCoordinates1->Checked=true;
  PS.CenterCoordType=1;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::GalCoordinates1Click(TObject *Sender)
{
  GalCoordinates1->Checked=true;
  PS.CenterCoordType=2;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::EclCoordinates1Click(TObject *Sender)
{
  EclCoordinates1->Checked=true;
  PS.CenterCoordType=3;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::EquCoordinates2Click(TObject *Sender)
{
  EquCoordinates2->Checked=true;
  PS.MouseCoordType=0;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::HorCoordinates2Click(TObject *Sender)
{
  HorCoordinates2->Checked=true;
  PS.MouseCoordType=1;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::GalCoordinates2Click(TObject *Sender)
{
  GalCoordinates2->Checked=true;
  PS.MouseCoordType=2;
}
//---------------------------------------------------------------------------
void __fastcall TMainF::EclCoordinates2Click(TObject *Sender)
{
  EclCoordinates2->Checked=true;
  PS.MouseCoordType=3;
}
//---------------------------------------------------------------------------
//Draw the symbol legend
void __fastcall TMainF::DrawLegend(bool Stars, bool NonStellar, bool Planet, bool Location, bool Planes)
{
  int x,y,symb_index;

  if (Stars){
    String maglabel[12]={"< 1.5","1.5 - 2.0","2.0 - 2.5",\
      "2.5 - 3.0","3.0 - 3.5","3.5 - 4.0","4.0 - 5.0",\
      "5.0 - 6.0","6.0 - 7.0","7.0 - 8.0","8.0 - 9.5",\
      "< 9.5"};
    String speclabel[7]={"O","B","A","F","G","K","M"};

    //The stellar magnitude legend
    StarLegend->Canvas->Pen->Color=clBlack;//(Graphics::TColor)0x00804050;
    StarLegend->Canvas->Brush->Color=clBlack;//(Graphics::TColor)0x00804050;
    StarLegend->Canvas->Rectangle(0,0,StarLegend->Width,StarLegend->Height);
    StarLegend->Canvas->Font->Color=clSilver;

    for (int i=0;i<12;i++){
      symb_index=7*i+3;
      if (i<4) {x=8;y=i*17+7;}
      if (i<8&&i>3) {x=88;y=(i-4)*17+7;}
      if (i<12&&i>7) {x=168;y=(i-8)*17+7;}

      if (symb_index<7){
        SourceRect=Rect(symb_index*12,0,(symb_index+1)*12,12);
        ClipBitmap0->Canvas->CopyRect(DestRect0,Starpic0->Canvas,SourceRect);
        StarLegend->Canvas->Draw(x-6,y-6,ClipBitmap0);
      } else { if (symb_index<14){
        SourceRect=Rect((symb_index-7)*11,0,(symb_index-6)*11,11);
        ClipBitmap1->Canvas->CopyRect(DestRect1,Starpic1->Canvas,SourceRect);
        StarLegend->Canvas->Draw(x-6,y-6,ClipBitmap1);
      } else { if (symb_index<21){
        SourceRect=Rect((symb_index-14)*10,0,(symb_index-13)*10,10);
        ClipBitmap2->Canvas->CopyRect(DestRect2,Starpic2->Canvas,SourceRect);
        StarLegend->Canvas->Draw(x-5,y-5,ClipBitmap2);
      } else { if (symb_index<28){
        SourceRect=Rect((symb_index-21)*9,0,(symb_index-20)*9,9);
        ClipBitmap3->Canvas->CopyRect(DestRect3,Starpic3->Canvas,SourceRect);
        StarLegend->Canvas->Draw(x-5,y-5,ClipBitmap3);
      } else { if (symb_index<35){
        SourceRect=Rect((symb_index-28)*8,0,(symb_index-27)*8,8);
        ClipBitmap4->Canvas->CopyRect(DestRect4,Starpic4->Canvas,SourceRect);
        StarLegend->Canvas->Draw(x-4,y-4,ClipBitmap4);
      } else { if (symb_index<42){
        SourceRect=Rect((symb_index-35)*7,0,(symb_index-34)*7,7);
        ClipBitmap5->Canvas->CopyRect(DestRect5,Starpic5->Canvas,SourceRect);
        StarLegend->Canvas->Draw(x-4,y-4,ClipBitmap5);
      } else { if (symb_index<49){
        SourceRect=Rect((symb_index-42)*6,0,(symb_index-41)*6,6);
        ClipBitmap6->Canvas->CopyRect(DestRect6,Starpic6->Canvas,SourceRect);
        StarLegend->Canvas->Draw(x-3,y-3,ClipBitmap6);
      } else { if (symb_index<56){
        SourceRect=Rect((symb_index-49)*5,0,(symb_index-48)*5,5);
        ClipBitmap7->Canvas->CopyRect(DestRect7,Starpic7->Canvas,SourceRect);
        StarLegend->Canvas->Draw(x-2,y-2,ClipBitmap7);
      } else { if (symb_index<63){
        SourceRect=Rect((symb_index-56)*4,0,(symb_index-55)*4,4);
        ClipBitmap8->Canvas->CopyRect(DestRect8,Starpic8->Canvas,SourceRect);
        StarLegend->Canvas->Draw(x-2,y-2,ClipBitmap8);
      } else { if (symb_index<70){
        SourceRect=Rect((symb_index-63)*3,0,(symb_index-62)*3,3);
        ClipBitmap9->Canvas->CopyRect(DestRect9,Starpic9->Canvas,SourceRect);
        StarLegend->Canvas->Draw(x-1,y-1,ClipBitmap9);
      } else { if (symb_index<77){
        SourceRect=Rect((symb_index-70)*2,0,(symb_index-69)*2,2);
        ClipBitmap10->Canvas->CopyRect(DestRect10,Starpic10->Canvas,SourceRect);
        StarLegend->Canvas->Draw(x-1,y-1,ClipBitmap10);
      } else { if (symb_index<84){
        SourceRect=Rect(symb_index-77,0,symb_index-76,1);
        ClipBitmap11->Canvas->CopyRect(DestRect11,Starpic11->Canvas,SourceRect);
        StarLegend->Canvas->Draw(x,y,ClipBitmap11);
      }}}}}}}}}}}}

      StarLegend->Canvas->TextOut(x+12,y-6,maglabel[i]);
    }

    //The spectral type legend
    SpectLegend->Canvas->Pen->Color=clBlack;//(Graphics::TColor)0x00804050;
    SpectLegend->Canvas->Brush->Color=clBlack;//(Graphics::TColor)0x00804050;
    SpectLegend->Canvas->Rectangle(0,0,SpectLegend->Width,SpectLegend->Height);
    SpectLegend->Canvas->Font->Color=clSilver;

    for (int i=0;i<7;i++){
      x=i*32+8;
      SourceRect=Rect(i*12,0,(i+1)*12,12);
      ClipBitmap0->Canvas->CopyRect(DestRect0,Starpic0->Canvas,SourceRect);
      SpectLegend->Canvas->Draw(x-6,3,ClipBitmap0);

      SpectLegend->Canvas->TextOut(x+10,3,speclabel[i]);
    }
  }

  if (NonStellar){
    //Deep sky object legend
    ClipBitmap->Width=15;
    ClipBitmap->Height=15;
    DestRect=Rect(0,0,15,15);

    String DeepSkylabel[22]={"Unknown S.Obj.","Open Cluster",\
      "Globular Cluster","Diffuse Nebula","Planetary Nebula",\
      "Galaxy","Cluster & Neb.","Non Existent","","","Unknown",\
      "Double Star","Uncertain","Single Star","Triple Star",\
      "Asterism","Plate Defect","Supernova Remnant","Dark nebula",\
      "Quasar","Galaxy Cluster","Pulsar"};
    DeepSkyLegend->Canvas->Pen->Color=clBlack;//(Graphics::TColor)0x00804050;
    DeepSkyLegend->Canvas->Brush->Color=clBlack;//(Graphics::TColor)0x00804050;
    DeepSkyLegend->Canvas->Rectangle(0,0,DeepSkyLegend->Width,DeepSkyLegend->Height);
    DeepSkyLegend->Canvas->Font->Color=clSilver;
    DeepSkyLegend->Canvas->Font->Size=8;

    for (int i=0;i<22;i++){
      if (i<8) {x=0;y=i*16;}
      if (i>7&&i<18) {x=120;y=(i-10)*16;}
      if (i>17) {x=225;y=(i-18)*16;}

      if (i!=8 && i!=9){
        SourceRect=Rect(PS.Symbol[i]*15,i*15,(PS.Symbol[i]+1)*15,(i+1)*15);
        ClipBitmap->Canvas->CopyRect(DestRect,DeepSkySymb->Canvas,SourceRect);
        DeepSkyLegend->Canvas->Draw(x,y,ClipBitmap);
        DeepSkyLegend->Canvas->TextOut(x+20,y+1,DeepSkylabel[i]);
      }
    }
  }

  if (Planet) {
    //Draw planet legend
    String PlanetLabel[10]={"Sun","Mercury","Venus","Mars",
      "Jupiter","Saturn","Uranus","Neptune","Pluto","Moon"};

    ClipBitmap->Width=15;
    ClipBitmap->Height=15;
    DestRect=Rect(0,0,15,15);
    PlanetLegend->Canvas->Pen->Color=clBlack;//(Graphics::TColor)0x00804050;
    PlanetLegend->Canvas->Brush->Color=clBlack;//(Graphics::TColor)0x00804050;
    PlanetLegend->Canvas->Rectangle(0,0,PlanetLegend->Width,PlanetLegend->Height);
    PlanetLegend->Canvas->Font->Color=clSilver;
    PlanetLegend->Canvas->Font->Size=8;

    int j;
    for (int i=0;i<10;i++){
      symb_index=7*i+3;
      if (i<5) {x=0;y=i*16;}
      else {x=90;y=(i-5)*16;}
      if (i<9) j=i;
      else j=100;

      SourceRect=Rect(PS.PlanetSymbol[SSData[j].SymbClass],SSData[j].SymbClass*15,(PS.PlanetSymbol[SSData[j].SymbClass]+1)*15,(SSData[j].SymbClass+1)*15);
      ClipBitmap->Canvas->CopyRect(DestRect,PlanetSymb->Canvas,SourceRect);
      PlanetLegend->Canvas->Draw(x,y,ClipBitmap);
      PlanetLegend->Canvas->TextOut(x+20,y+1,PlanetLabel[i]);
    }
  }

  if (Planes){
    //Draw planes and line legend
    LineLegend->Canvas->Pen->Color=clBlack;//(Graphics::TColor)0x00804050;
    LineLegend->Canvas->Brush->Color=clBlack;//(Graphics::TColor)0x00804050;
    LineLegend->Canvas->Rectangle(0,0,LineLegend->Width,LineLegend->Height);
    LineLegend->Canvas->Font->Color=clSilver;
    LineLegend->Canvas->Font->Size=8;

    //Ecliptic plane
    LineLegend->Canvas->Pen->Color=CS.Ecl;
    LineLegend->Canvas->Pen->Style=psDot;
    LineLegend->Canvas->MoveTo(0,8);
    LineLegend->Canvas->LineTo(20,8);
    LineLegend->Canvas->TextOut(24,2,"Ecliptic");

    //Galactic plane
    LineLegend->Canvas->Pen->Color=CS.Gal;
    LineLegend->Canvas->Pen->Style=psDot;
    LineLegend->Canvas->MoveTo(0,22);
    LineLegend->Canvas->LineTo(20,22);
    LineLegend->Canvas->TextOut(24,16,"Galactic Plane");

    //Horizon line
    LineLegend->Canvas->Pen->Color=CS.Hor;
    LineLegend->Canvas->Pen->Style=psSolid;
    LineLegend->Canvas->MoveTo(0,36);
    LineLegend->Canvas->LineTo(20,36);
    LineLegend->Canvas->TextOut(24,30,"Horizon");
  }
}
//---------------------------------------------------------------------------
//Open the colour settings form
void __fastcall TMainF::Colours1Click(TObject *Sender)
{
  ColorSet->ShowModal();
}
//---------------------------------------------------------------------------
//Close the program
void __fastcall TMainF::ExitClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainF::FormResize(TObject *Sender)
{
  SetFormSizes(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TMainF::Planetpaths1Click(TObject *Sender)
{
  PPathForm->Show();
}
//---------------------------------------------------------------------------
//Horizontal scroll bar responds to action from left/right arrow keys
void __fastcall TMainF::HScrollBarKeyPress(TObject *Sender, char &Key)
{
  float elev=0,Az=0;
  float arg,shift;
  shift=pi*PS.h/(PS.R0*50);

  if (Key==VK_LEFT||Key==VK_RIGHT){
    if (AL.lat<pihalved){
      if (Key==VK_LEFT) AL.azim+=shift;
      if (Key==VK_RIGHT) AL.azim-=shift;
    } else {
      if (Key==VK_LEFT) AL.azim-=shift;
      if (Key==VK_RIGHT) AL.azim+=shift;
    }
    arg=AL.azim;
    FirstCircle(&arg);
    AL.azim=arg;
    AL.cos_azim=cos(arg);
    AL.sin_azim=sin(arg);
    Az=pi-AL.azim;
    elev=-AL.incl;
    if (elev>pihalved) {elev=pi-elev; Az=pi-Az;}
    FirstCircle(&Az);
  }

  //Display the coordinates
  DrawCoord(&lastx,&lasty,false,true);
  DrawCoord(&lastx,&lasty,true,false);

  //Draw the incomplete map
  if (!DrawingMap){ //Avoids conflicts with other threads
    DrawingMap=true;
    DrawMap(400,true);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
//Vertical scroll bar responds to action from up/down arrow keys
void __fastcall TMainF::VScrollBarKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
  float elev=0,Az=0;
  float arg,shift;
  shift=pi*PS.h/(PS.R0*50);

  //Direction keys control the map center position
  if (Key==VK_UP||Key==VK_DOWN){
    if (AL.lat<pihalved){
      if (Key==VK_UP) AL.incl-=shift;
      if (Key==VK_DOWN) AL.incl+=shift;
    } else {
      if (Key==VK_UP) AL.incl+=shift;
      if (Key==VK_DOWN) AL.incl-=shift;
    }
    //Inclination (elevation) angle MUST lie between -pi and +pi
    if (AL.incl>pihalved) {
      AL.incl=-AL.incl-pi;
       AL.a_ori+=pi;
    }
    if (AL.incl<-pihalved) {
      AL.incl+=pi-AL.incl;
      AL.a_ori+=pi;
    }
    AL.cosi=cos(AL.incl);
    AL.sini=sin(AL.incl);
  }

  //Display the coordinates
  DrawCoord(&lastx,&lasty,false,true);
  DrawCoord(&lastx,&lasty,true,false);

  //Draw the incomplete map
  if (!DrawingMap){ //Avoids conflicts with other threads
    DrawingMap=true;
    DrawMap(400,true);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
//Create a map based on the current view
void __fastcall TMainF::Createmap1Click(TObject *Sender)
{
  MapF->ShowModal();
}
//---------------------------------------------------------------------------
//Find an object
void __fastcall TMainF::Findanobject1Click(TObject *Sender)
{
  SelectedCatalogue=-4;
  ObjectInfo->ShowModal();
}
//---------------------------------------------------------------------------
//What to do when the program starts
void __fastcall TMainF::FormShow(TObject *Sender)
{
  String filename,cbuf;

  // Get the working path
  PS.ProgPath = GetFilePath((AnsiString) _argv[0]);

  //Load the star indexing arrays
  FILE *infile;
  filename = PS.ProgPath+"Catalogs\\SAO\\SAO_str.DAT";
  if (!FileExists(filename)) {
    String osbuf = "Could not open file " + filename;
    Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    return;
  }
  infile = fopen(filename.c_str(),"rb");
  fseek(infile,0,SEEK_SET);
  StarBlkIndex=i_matrix(0,19,0,431);
  StarBlkNum=s_matrix(0,19,0,431);
  short *sptr,sbuf=0;
  sptr=&sbuf;
  for (int m=0;m<20;m++){
    for (int l=0;l<432;l++){
      fread(sptr,2,1,infile);
      StarBlkNum[m][l]=*sptr;
      if (l==0) StarBlkIndex[m][l]=*sptr;
      else StarBlkIndex[m][l]=*sptr+StarBlkIndex[m][l-1];
    }
  }
  fclose(infile);

  //Load the system default settings
  LoadSettings(PS.ProgPath + "SkyAtlas.ini");

  //Load symbol bitmap image lists
  filename=PS.ProgPath+"Symbols\\Planets.bmp";
  if (!FileExists(filename)) {
    String osbuf = "Could not open file " + filename;
    Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
  } else {
    PlanetSymb->LoadFromFile(filename);
  }
  filename=PS.ProgPath+"Symbols\\NonStellar.bmp";
  if (!FileExists(filename)) {
    String osbuf = "Could not open file " + filename;
    Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
  } else {
    DeepSkySymb->LoadFromFile(filename);
  }
  filename=PS.ProgPath+"Symbols\\Compas.bmp";
  if (!FileExists(filename)) {
    String osbuf = "Could not open file " + filename;
    Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
  } else {
    text->LoadFromFile(filename);
  }
  
  //Load star symbol image list and setup associated graphic
  //structures
  Starpic0->Width=84;
  Starpic0->Height=12;
  DestRect0=Rect(0,0,12,12);
  ClipBitmap0->Width=12;
  ClipBitmap0->Height=12;
  ClipBitmap0->Canvas->Pen->Color=clNone;
  ClipBitmap0->Canvas->Brush->Color=clNone;

  Starpic1->Width=77;
  Starpic1->Height=11;
  DestRect1=Rect(0,0,11,11);
  ClipBitmap1->Width=11;
  ClipBitmap1->Height=11;
  ClipBitmap1->Canvas->Pen->Color=clNone;
  ClipBitmap1->Canvas->Brush->Color=clNone;

  Starpic2->Width=70;
  Starpic2->Height=10;
  DestRect2=Rect(0,0,10,10);
  ClipBitmap2->Width=10;
  ClipBitmap2->Height=10;
  ClipBitmap2->Canvas->Pen->Color=clNone;
  ClipBitmap2->Canvas->Brush->Color=clNone;

  Starpic3->Width=63;
  Starpic3->Height=9;
  DestRect3=Rect(0,0,9,9);
  ClipBitmap3->Width=9;
  ClipBitmap3->Height=9;
  ClipBitmap3->Canvas->Pen->Color=clNone;
  ClipBitmap3->Canvas->Brush->Color=clNone;

  Starpic4->Width=56;
  Starpic4->Height=8;
  DestRect4=Rect(0,0,8,8);
  ClipBitmap4->Width=8;
  ClipBitmap4->Height=8;
  ClipBitmap4->Canvas->Pen->Color=clNone;
  ClipBitmap4->Canvas->Brush->Color=clNone;

  Starpic5->Width=49;
  Starpic5->Height=7;
  DestRect5=Rect(0,0,7,7);
  ClipBitmap5->Width=7;
  ClipBitmap5->Height=7;
  ClipBitmap5->Canvas->Pen->Color=clNone;
  ClipBitmap5->Canvas->Brush->Color=clNone;

  Starpic6->Width=42;
  Starpic6->Height=6;
  DestRect6=Rect(0,0,6,6);
  ClipBitmap6->Width=6;
  ClipBitmap6->Height=6;
  ClipBitmap6->Canvas->Pen->Color=clNone;
  ClipBitmap6->Canvas->Brush->Color=clNone;

  Starpic7->Width=35;
  Starpic7->Height=5;
  DestRect7=Rect(0,0,5,5);
  ClipBitmap7->Width=5;
  ClipBitmap7->Height=5;
  ClipBitmap7->Canvas->Pen->Color=clNone;
  ClipBitmap7->Canvas->Brush->Color=clNone;

  Starpic8->Width=28;
  Starpic8->Height=4;
  DestRect8=Rect(0,0,4,4);
  ClipBitmap8->Width=4;
  ClipBitmap8->Height=4;
  ClipBitmap8->Canvas->Pen->Color=clNone;
  ClipBitmap8->Canvas->Brush->Color=clNone;

  Starpic9->Width=21;
  Starpic9->Height=3;
  DestRect9=Rect(0,0,3,3);
  ClipBitmap9->Width=3;
  ClipBitmap9->Height=3;
  ClipBitmap9->Canvas->Pen->Color=clNone;
  ClipBitmap9->Canvas->Brush->Color=clNone;

  Starpic10->Width=14;
  Starpic10->Height=2;
  DestRect10=Rect(0,0,2,2);
  ClipBitmap10->Width=2;
  ClipBitmap10->Height=2;
  ClipBitmap10->Canvas->Pen->Color=clNone;
  ClipBitmap10->Canvas->Brush->Color=clNone;

  Starpic11->Width=7;
  Starpic11->Height=1;
  DestRect11=Rect(0,0,1,1);
  ClipBitmap11->Width=1;
  ClipBitmap11->Height=1;
  ClipBitmap11->Canvas->Pen->Color=clNone;
  ClipBitmap11->Canvas->Brush->Color=clNone;

  BufImg=new Graphics::TBitmap();
  BufImg->Assign(Image->Picture->Bitmap);
  BufImg->Dormant();
  BufImg->FreeImage();

  Graphics::TBitmap *InBitMap = new Graphics::TBitmap();
  for (int i=0; i<7;i++){
    SourceRect=Rect(0,0,12,12);
    InBitMap->Width=12;
    InBitMap->Height=12;
    filename=PS.ProgPath+"symbols\\Stars\\"+IntToStr(i)+".bmp";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    } else {
      InBitMap->LoadFromFile(filename);
    }
    DestRect=Rect(i*12,0,(i+1)*12,12);
    Starpic0->Canvas->CopyRect(DestRect,InBitMap->Canvas,SourceRect);

    SourceRect=Rect(0,0,11,11);
    InBitMap->Width=11;
    InBitMap->Height=11;
    filename=PS.ProgPath+"symbols\\Stars\\"+IntToStr(i+7)+".bmp";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    } else {
      InBitMap->LoadFromFile(filename);
    }  
    DestRect=Rect(i*11,0,(i+1)*11,11);
    Starpic1->Canvas->CopyRect(DestRect,InBitMap->Canvas,SourceRect);

    SourceRect=Rect(0,0,10,10);
    InBitMap->Width=10;
    InBitMap->Height=10;
    filename=PS.ProgPath+"symbols\\Stars\\"+IntToStr(i+14)+".bmp";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    } else {
      InBitMap->LoadFromFile(filename);
    }  
    DestRect=Rect(i*10,0,(i+1)*10,10);
    Starpic2->Canvas->CopyRect(DestRect,InBitMap->Canvas,SourceRect);

    SourceRect=Rect(0,0,9,9);
    InBitMap->Width=9;
    InBitMap->Height=9;
    filename=PS.ProgPath+"symbols\\Stars\\"+IntToStr(i+21)+".bmp";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    } else {
      InBitMap->LoadFromFile(filename);
    }
    DestRect=Rect(i*9,0,(i+1)*9,9);
    Starpic3->Canvas->CopyRect(DestRect,InBitMap->Canvas,SourceRect);

    SourceRect=Rect(0,0,8,8);
    InBitMap->Width=8;
    InBitMap->Height=8;
    filename=PS.ProgPath+"symbols\\Stars\\"+IntToStr(i+28)+".bmp";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    } else {
      InBitMap->LoadFromFile(filename);
    }  
    DestRect=Rect(i*8,0,(i+1)*8,8);
    Starpic4->Canvas->CopyRect(DestRect,InBitMap->Canvas,SourceRect);

    SourceRect=Rect(0,0,7,7);
    InBitMap->Width=7;
    InBitMap->Height=7;
    filename=PS.ProgPath+"symbols\\Stars\\"+IntToStr(i+35)+".bmp";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    } else {
      InBitMap->LoadFromFile(filename);
    }
    DestRect=Rect(i*7,0,(i+1)*7,7);
    Starpic5->Canvas->CopyRect(DestRect,InBitMap->Canvas,SourceRect);

    SourceRect=Rect(0,0,6,6);
    InBitMap->Width=6;
    InBitMap->Height=6;
    filename=PS.ProgPath+"symbols\\Stars\\"+IntToStr(i+42)+".bmp";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    } else {
      InBitMap->LoadFromFile(filename);
    }  
    DestRect=Rect(i*6,0,(i+1)*6,6);
    Starpic6->Canvas->CopyRect(DestRect,InBitMap->Canvas,SourceRect);

    SourceRect=Rect(0,0,5,5);
    InBitMap->Width=5;
    InBitMap->Height=5;
    filename=PS.ProgPath+"symbols\\Stars\\"+IntToStr(i+49)+".bmp";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    } else {
      InBitMap->LoadFromFile(filename);
    }
    DestRect=Rect(i*5,0,(i+1)*5,5);
    Starpic7->Canvas->CopyRect(DestRect,InBitMap->Canvas,SourceRect);

    SourceRect=Rect(0,0,4,4);
    InBitMap->Width=4;
    InBitMap->Height=4;
    filename=PS.ProgPath+"symbols\\Stars\\"+IntToStr(i+56)+".bmp";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    } else {
      InBitMap->LoadFromFile(filename);
    }
    DestRect=Rect(i*4,0,(i+1)*4,4);
    Starpic8->Canvas->CopyRect(DestRect,InBitMap->Canvas,SourceRect);

    SourceRect=Rect(0,0,3,3);
    InBitMap->Width=3;
    InBitMap->Height=3;
    filename=PS.ProgPath+"symbols\\Stars\\"+IntToStr(i+63)+".bmp";
    if (!FileExists(filename) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    } else {
      InBitMap->LoadFromFile(filename);
    }
    DestRect=Rect(i*3,0,(i+1)*3,3);
    Starpic9->Canvas->CopyRect(DestRect,InBitMap->Canvas,SourceRect);

    SourceRect=Rect(0,0,2,2);
    InBitMap->Width=2;
    InBitMap->Height=2;
    filename=PS.ProgPath+"symbols\\Stars\\"+IntToStr(i+70)+".bmp";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    } else {
      InBitMap->LoadFromFile(filename);
    }  
    DestRect=Rect(i*2,0,(i+1)*2,2);
    Starpic10->Canvas->CopyRect(DestRect,InBitMap->Canvas,SourceRect);

    SourceRect=Rect(0,0,1,1);
    InBitMap->Width=1;
    InBitMap->Height=1;
    filename=PS.ProgPath+"symbols\\Stars\\"+IntToStr(i+77)+".bmp";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    } else {
      InBitMap->LoadFromFile(filename);
    }
    DestRect=Rect(i,0,i+1,1);
    Starpic11->Canvas->CopyRect(DestRect,InBitMap->Canvas,SourceRect);
  }
  delete InBitMap;


  //Set the main form controls
  MainF->SetForm();

  for (int i=0;i<80;i++){
    points[i].x=0;
    points[i].y=0;
  }

  //Load the orbital element data base
  filename=PS.ProgPath+"\\OElem.dat";
  LoadOElem(filename);
  LoadPPSettings();

  //Get the local time and date
  PS.time=GetTime();
  PS.time.jul=GregToJul(PS.time);

  String lbl;    //The string label used to display the date
  StartTime=PS.time;
  StatusBar->Panels->Items[3]->Text="LT: "+GetTimeDateS(PS.time)+ "  JD: "+FormatFloat("###########0.00",PS.time.jul);

  //Get the Local Mean Sidereal Time
  AL.l_ori=GetLST();

  //Load star info
  LoadStarMap(PS.MaxStarMag);
  PrecessClass(-2,PS.time.jul,0);

  //Load object info from catalogs
  for (int i=0;i<10;i++){
    if (PS.UseCat[i]){
      LoadCatalog(i,true);
      PrecessClass(i,PS.time.jul,0);
    }
  }

  //Load Constellation boundary and figure info
  LoadConstBound();
  PrecessClass(-3,PS.time.jul,0);

  //Initialize angular variables
  AL.cos_lat=cos(AL.lat);
  AL.sin_lat=sin(AL.lat);
  AL.cosi=cos(AL.incl);
  AL.sini=sin(AL.incl);
  AL.cos_azim=cos(AL.azim);
  AL.sin_azim=sin(AL.azim);

  //Draw the legend
  DrawLegend(true,true,true,true,true);

  //Draw the map
  SetFormSizes(Sender);
  RedrawTimer->Enabled=true;

  //Misc. assignments
  for (int i=0;i<20;i++){CatNum[i]=1;}
}
//---------------------------------------------------------------------------
//Set the main form controls
void __fastcall TMainF::SetForm(void)
{
  if (PS.CenterCoordType==0) EquCoordinates1->Checked=true;
  if (PS.CenterCoordType==1) HorCoordinates1->Checked=true;
  if (PS.CenterCoordType==2) GalCoordinates1->Checked=true;
  if (PS.CenterCoordType==3) EclCoordinates1->Checked=true;

  if (PS.MouseCoordType==0) EquCoordinates2->Checked=true;
  if (PS.MouseCoordType==1) HorCoordinates2->Checked=true;
  if (PS.MouseCoordType==2) GalCoordinates2->Checked=true;
  if (PS.MouseCoordType==3) EclCoordinates2->Checked=true;

  if (PS.Projection==0) Stereographic1->Checked=true;
  if (PS.Projection==1) Lambert1->Checked=true;
  if (PS.Projection==2) Plane1->Checked=true;
  if (PS.Projection==3) Mercator1->Checked=true;
  
  HorizonMask->Checked=PS.HorizonMask;
  Stars->Checked=PS.ShowStars;
  DeepSkyObjects->Checked=PS.ShowDeepSky;
  ShowPlanets->Checked=PS.ShowPlanets;
  PPathShow->Checked=PS.ShowPlanetPaths;
  CoordinateGrid->Checked=PS.ShowGrid;
  ConstellationBoundaries1->Checked=PS.DrawConstBound;
  ConstellationFigures1->Checked=PS.DrawConstFig;
  ConstellationLabels1->Checked=PS.DrawConstLab;

  ToolBar2->Visible=PS.ShowTools;
  ToolBar3->Checked=PS.ShowTools;
  Legend->Visible=PS.ShowLegend;
  ShowLegend->Checked=PS.ShowLegend;
  if (PS.ShowLegend) LegendBut->Caption="Hide Legend";
  else LegendBut->Caption="Show Legend";

  MainF->TimeSkip->Items->Insert(0,"1 year from now");
  MainF->TimeSkip->Items->Insert(0,"4 months from now");
  MainF->TimeSkip->Items->Insert(0,"2 months from now");
  MainF->TimeSkip->Items->Insert(0,"1 month from now");
  MainF->TimeSkip->Items->Insert(0,"2 weeks from now");
  MainF->TimeSkip->Items->Insert(0,"1 week from now");
  MainF->TimeSkip->Items->Insert(0,"4 days from now");
  MainF->TimeSkip->Items->Insert(0,"2 days from now");
  MainF->TimeSkip->Items->Insert(0,"1 day from now");
  MainF->TimeSkip->Items->Insert(0,"12 hours from now");
  MainF->TimeSkip->Items->Insert(0,"8 hours from now");
  MainF->TimeSkip->Items->Insert(0,"4 hours from now");
  MainF->TimeSkip->Items->Insert(0,"2 hours from now");
  MainF->TimeSkip->Items->Insert(0,"1 hour from now");
  MainF->TimeSkip->Items->Insert(0,"Local time (now)");
  TimeSkip->ItemIndex=0;

  DefocusControl(MainF->LocationBox,false);
  DefocusControl(MainF->TimeSkip,false);
  DefocusControl(MainF->ZoomIn,false);
  DefocusControl(MainF->ZoomOut,false);
  DefocusControl(MainF->Zoom1,false);
  FocusControl(MainF->ImPanel);
  RedrawTimer->Interval=PS.RedrawInterval;

  if (PS.RedrawInterval==100) Every01Second1->Checked=true;
  if (PS.RedrawInterval==1000) EverySecond1->Checked=true;
  if (PS.RedrawInterval==5000) Every5seconds1->Checked=true;
  if (PS.RedrawInterval==15000) Every15seconds1->Checked=true;
  if (PS.RedrawInterval==30000) Every30seconds1->Checked=true;
  if (PS.RedrawInterval==60000) Everyminute1->Checked=true;
  if (PS.RedrawInterval==120000) Every2minutes1->Checked=true;
  if (PS.RedrawInterval==300000) Every5minutes1->Checked=true;
  if (PS.RedrawInterval==0) Onlywhenasked1->Checked=true;

  if (PS.ClockRate==1) RealTime->Checked=true;
  if (PS.ClockRate==60) Minute->Checked=true;
  if (PS.ClockRate==900) QHour->Checked=true;
  if (PS.ClockRate==1800) HHour->Checked=true;
  if (PS.ClockRate==3600) Hour1->Checked=true;
  if (PS.ClockRate==86400) Day1->Checked=true;
  if (PS.ClockRate==2629800) Month->Checked=true;
  if (PS.ClockRate==31557600) Year1->Checked=true;
}
//---------------------------------------------------------------------------
// Terminate application
void __fastcall TMainF::FormClose(TObject *Sender, TCloseAction &Action)
{
  RedrawTimer->Enabled = false;
  MainF->Enabled = false;
  Cleanup(Sender);
}
//---------------------------------------------------------------------------
//Clean up before exiting
void __fastcall TMainF::Cleanup(TObject *Sender)
{
  if (!FormClosing){
    FormClosing = true;

    //Save program settings
    SaveSettings(PS.ProgPath+"SkyAtlas.ini");
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainF::PPathShowClick(TObject *Sender)
{
  PPathShow->Checked=!PPathShow->Checked;
  PS.ShowPlanetPaths=!PS.ShowPlanetPaths;
  if (!DrawingMap){
    DrawingMap=true;
    DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainF::About1Click(TObject *Sender)
{
  AboutF->Show();
}
//---------------------------------------------------------------------------

