//---------------------------------------------------------------------------
#ifndef MainH
#define MainH
#define piquartered 0.785398163397448279
#define pihalved 1.57079632679489656
#define pi 3.14159265358979323846
#define threepihalved 4.71238898038468967
#define twopi 6.28318530717958623
#define threepi 9.42477796076937935
#define fourpi 12.5663706143591725
//---------------------------------------------------------------------------
//Constants that may change as the program expands
#define n_objects 22 //The number of distinct deep sky object types distinguished
#define n_cat 7     //The number deep sky catalogues supported
//---------------------------------------------------------------------------
#include <dos.h>
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <Dialogs.hpp>
#include "cspin.h"
#include <Buttons.hpp>
#include <Graphics.hpp>
//---------------------------------------------------------------------------
class TMainF : public TForm
{
__published:	// IDE-managed Components
    TMainMenu *MainMenu1;
    TMenuItem *File;
    TMenuItem *Settings;
    TMenuItem *Animations;
    TMenuItem *SaveSettingDEF;
    TMenuItem *SaveSettingAS;
    TMenuItem *N1;
    TMenuItem *Exit;
    TMenuItem *StarSetting;
    TMenuItem *Stereographic1;
    TMenuItem *Lambert1;
    TMenuItem *Plane1;
    TMenuItem *Projection1;
    TMenuItem *Location1;
    TMenuItem *DateTime;
    TMenuItem *NonStellar;
    TMenuItem *N4;
    TSaveDialog *SaveSet;
    TMenuItem *LoadSetAS;
    TOpenDialog *LoadSet;
    TMenuItem *Mercator1;
    TStatusBar *StatusBar;
    TMenuItem *View1;
    TMenuItem *CoordinateGrid;
    TMenuItem *HorizonMask;
    TMenuItem *Stars;
    TMenuItem *DeepSkyObjects;
    TMenuItem *ShowPlanets;
    TPanel *ImPanel;
    TMenuItem *Updatedisplay1;
    TMenuItem *Everyminute1;
    TMenuItem *Every2minutes1;
    TMenuItem *Every5minutes1;
    TMenuItem *Never1;
    TMenuItem *Onlywhenasked1;
    TTimer *RedrawTimer;
    TMenuItem *Every30seconds1;
    TMenuItem *Every15seconds1;
    TMenuItem *Every5seconds1;
    TMenuItem *EverySecond1;
    TMenuItem *Every01Second1;
    TMenuItem *Clockrate1;
    TMenuItem *RealTime;
    TMenuItem *Minute;
    TMenuItem *QHour;
    TMenuItem *HHour;
    TMenuItem *Hour1;
    TMenuItem *Day1;
    TMenuItem *Month;
    TMenuItem *Year1;
    TMenuItem *N5;
    TMenuItem *N6;
    TMenuItem *ConstellationBoundaries1;
    TMenuItem *ConstellationFigures1;
    TMenuItem *ConstellationLabels1;
    TImage *Image;
    TToolBar *ToolBar2;
    TBitBtn *ZoomOut;
    TBitBtn *ZoomIn;
    TBitBtn *Zoom1;
    TMenuItem *N3;
    TMenuItem *ToolBar3;
    TMenuItem *EclipticPlane1;
    TMenuItem *GalacticPlane1;
    TMenuItem *HorizonPlane1;
    TBitBtn *LegendBut;
    TBitBtn *Update;
    TMenuItem *ShowLegend;
    TScrollBar *VScrollBar;
    TPanel *Panel3;
    TScrollBar *HScrollBar;
    TMenuItem *N8;
    TMenuItem *CenterCoordinates1;
    TMenuItem *CursorCoordinates1;
    TMenuItem *EquCoordinates1;
    TMenuItem *HorCoordinates1;
    TMenuItem *GalCoordinates1;
    TMenuItem *EclCoordinates1;
    TMenuItem *EquCoordinates2;
    TMenuItem *HorCoordinates2;
    TMenuItem *GalCoordinates2;
    TMenuItem *EclCoordinates2;
    TComboBox *LocationBox;
    TComboBox *TimeSkip;
    TPanel *Legend;
    TPanel *Panel1;
    TLabel *Label2;
    TImage *StarLegend;
    TPanel *Panel2;
    TLabel *Label3;
    TImage *SpectLegend;
    TPanel *Panel4;
    TImage *DeepSkyLegend;
    TPanel *Panel5;
    TImage *PlanetLegend;
    TPanel *Panel6;
    TImage *LineLegend;
    TMenuItem *N9;
    TMenuItem *Colours1;
    TMenuItem *Createmap1;
    TMenuItem *Tools;
    TMenuItem *Findanobject1;
        TMenuItem *Planetpaths1;
        TMenuItem *PPathShow;
        TMenuItem *Help1;
        TMenuItem *About1;
    void __fastcall ImageMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y);
    void __fastcall ImageMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y);
    void __fastcall ImageMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y);
    void __fastcall Stereographic1Click(TObject *Sender);
    void __fastcall Lambert1Click(TObject *Sender);
    void __fastcall Plane1Click(TObject *Sender);
    void __fastcall StarSettingClick(TObject *Sender);
    void __fastcall Location1Click(TObject *Sender);
    void __fastcall DateTimeClick(TObject *Sender);
    
    void __fastcall NonStellarClick(TObject *Sender);
    void __fastcall SaveSettingDEFClick(TObject *Sender);
    void __fastcall SaveSettingASClick(TObject *Sender);
    void __fastcall LoadSetASClick(TObject *Sender);
    void __fastcall Mercator1Click(TObject *Sender);

    void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    
    void __fastcall FormKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall ZoomInClick(TObject *Sender);
    void __fastcall ZoomOutClick(TObject *Sender);
    void __fastcall HorizonMaskClick(TObject *Sender);

    void __fastcall LocationBoxChange(TObject *Sender);
    void __fastcall TimeSkipChange(TObject *Sender);
    void __fastcall CoordinateGridClick(TObject *Sender);
    void __fastcall StarsClick(TObject *Sender);
    void __fastcall DeepSkyObjectsClick(TObject *Sender);
    void __fastcall ShowPlanetsClick(TObject *Sender);
    void __fastcall Zoom1Click(TObject *Sender);
    
    void __fastcall RedrawTimerTimer(TObject *Sender);
    void __fastcall Everyminute1Click(TObject *Sender);
    void __fastcall Every2minutes1Click(TObject *Sender);
    void __fastcall Every5minutes1Click(TObject *Sender);
    void __fastcall Onlywhenasked1Click(TObject *Sender);
    void __fastcall Every30seconds1Click(TObject *Sender);
    void __fastcall UpdateButClick(TObject *Sender);
    void __fastcall Every01Second1Click(TObject *Sender);
    void __fastcall EverySecond1Click(TObject *Sender);
    void __fastcall Every5seconds1Click(TObject *Sender);
    void __fastcall Every15seconds1Click(TObject *Sender);
    
    void __fastcall RealTimeClick(TObject *Sender);
    void __fastcall MinuteClick(TObject *Sender);
    void __fastcall QHourClick(TObject *Sender);
    void __fastcall HHourClick(TObject *Sender);
    void __fastcall Hour1Click(TObject *Sender);
    void __fastcall Day1Click(TObject *Sender);
    void __fastcall MonthClick(TObject *Sender);
    void __fastcall Year1Click(TObject *Sender);
    void __fastcall ConstellationBoundaries1Click(TObject *Sender);
    void __fastcall ConstellationFigures1Click(TObject *Sender);
    void __fastcall ConstellationLabels1Click(TObject *Sender);
    
    void __fastcall ToolBar3Click(TObject *Sender);
    void __fastcall EclipticPlane1Click(TObject *Sender);
    void __fastcall GalacticPlane1Click(TObject *Sender);
    void __fastcall HorizonPlane1Click(TObject *Sender);
    void __fastcall UpdateClick(TObject *Sender);
    void __fastcall HScrollBarScroll(TObject *Sender,
          TScrollCode ScrollCode, int &ScrollPos);
    
    void __fastcall VScrollBarScroll(TObject *Sender,
          TScrollCode ScrollCode, int &ScrollPos);
    void __fastcall ShowLegendClick(TObject *Sender);
    void __fastcall EquCoordinates1Click(TObject *Sender);
    void __fastcall HorCoordinates1Click(TObject *Sender);
    void __fastcall GalCoordinates1Click(TObject *Sender);
    void __fastcall EclCoordinates1Click(TObject *Sender);
    void __fastcall EquCoordinates2Click(TObject *Sender);
    void __fastcall HorCoordinates2Click(TObject *Sender);
    void __fastcall GalCoordinates2Click(TObject *Sender);
    void __fastcall EclCoordinates2Click(TObject *Sender);
    void __fastcall LegendButClick(TObject *Sender);
    void __fastcall Colours1Click(TObject *Sender);
    void __fastcall ExitClick(TObject *Sender);
    void __fastcall FormResize(TObject *Sender);
    void __fastcall Planetpaths1Click(TObject *Sender);
    
    void __fastcall HScrollBarKeyPress(TObject *Sender, char &Key);
    void __fastcall VScrollBarKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    
    void __fastcall Createmap1Click(TObject *Sender);
    void __fastcall Findanobject1Click(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall PPathShowClick(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
    __fastcall TMainF(TComponent* Owner);
    void __fastcall DrawStar(float *RA,float *dec,int *symb_index,\
      bool *initialize);
    void __fastcall ShowStars(int MaxVmag);
    void __fastcall FindObject();
    void __fastcall DrawPlanets(double T);
    void __fastcall DrawPlanetPaths(double T);
    void __fastcall DrawRNGC();
    void __fastcall DrawMap(int MaxStarMag,bool OnlyStars);
    void __fastcall DrawCoord(int *X, int *Y,bool DrawMouseCoord,bool DrawCtrCoord);
    void __fastcall Highlight(int *ItemIndex,bool HighlightState);
    void __fastcall DrawHighlights(void);
    void __fastcall DrawConstBound(void);
    void __fastcall DrawConstFig(void);
    void __fastcall DrawConstLab(void);
    void __fastcall DrawIntersects(int PlaneIndex);
    void __fastcall DrawGrid(float *min_lambda,float *max_lambda,\
                      float *min_q,float *max_q);
    void __fastcall DrawGridLabel(int x, int y,String label);
    void __fastcall DrawLine(int n,bool ForceVerify);
    void __fastcall UpdateDisplay(TObject *Sender);
    void __fastcall DrawLegend(bool Stars, bool NonStellar, bool Planet, bool Location, bool Planes);
    void __fastcall SetFormSizes(TObject *Sender);
    void __fastcall DrawGalaxyEllipse(float *RA,float *dec,float *a,float *b,float *pa);
    void __fastcall SetForm(void);
    void __fastcall Cleanup(TObject *Sender);

    bool FormClosing;    
};
//---------------------------------------------------------------------------
extern PACKAGE TMainF *MainF;
//---------------------------------------------------------------------------
//Structure to allow easy access of the time and date
struct TIME_ {
  int year;        //current year
  int day;         //day of the month
  int mon;         //month (1 = Jan)
  int min;         //minutes
  int hour;        //hours
  int sec;         //seconds
  float hund;      //hundredths of seconds
  double jul;      //Julian day
  String lbl;    //The string label used to display the date
};
//---------------------------------------------------------------------------
#endif

//---------------------------------------------------------------------------
//Class to hold the main program settings
class Settings{
  public:
    Settings();//Constructor
    String ProgPath;    //Main program path
    int MaxStarMag;     //Maximum stellar visual magnitude x 100
    bool HorizonMask;   //Flags display of the horizon mask
    int Projection;  //The projection to use in displaying the sky
                     //0 = Stereographic
                     //1 = Lambert
                     //2 = Planar
                     //3 = Mercator
    float R0;           //Determines the scale of the map (this is the "radius" of the sky sphere in pixels)
    bool DaylightSavings;  //Apply correction for daylight savings time
    float TimeZone;     //Number of time zones east of Greenwich
    int location;       //Index of observing location
    struct TIME_ time; //The observation time and date
    double Epoch;       //Current observation epoch; defines the epoch
                        //to which catalogued coordinates are precessed.
                        //This variable should only be modified by PrecessClass.
    double StartEpoch[32];   //The epoch for which a catalog is defined.
    bool lighttime;     //Flag to apply light-time corr. for planet positions
    bool refract;       //Flag to apply atm. refraction corr. for object positions
    bool ShowObjects[22];//Flag for non-stellar objects to show
                        //ShowObjects[0] = Unverified Southern object
                        //ShowObjects[1] = Open clusters
                        //ShowObjects[2] = Globular clusters
                        //ShowObjects[3] = Diffuse nebulae
                        //ShowObjects[4] = Planetary nebulae
                        //ShowObjects[5] = Galaxies
                        //ShowObjects[6] = Cluster associated with nebulosity
                        //ShowObjects[7] = Nonexistent
                        //ShowObjects[8] = Object in Large Magellanic Cloud
                        //ShowObjects[9] = Object in Small Magellanic Cloud
                        //ShowObjects[10] = empty
                        //ShowObjects[11] = double star
                        //ShowObjects[12] = uncertain (may not exist)
                        //ShowObjects[13] = single star
                        //ShowObjects[14] = triple star
                        //ShowObjects[15] = asterism
                        //ShowObjects[16] = plate defect
                        //ShowObjects[17] = Supernova remnant
                        //ShowObjects[18] = dark nebula
                        //ShowObjects[19] = Quasars
                        //ShowObjects[20] = Galaxy clusters
                        //ShowObjects[21] = Pulsars
    int Symbol[22];     //Index of the symbol bitmap to use for the non-stellar objects
    int MaxMag[22];     //Limiting visual magnitudes of objects to display
    bool UseCat[10];     //Flag to enable the use of a particular catalogue
                        //UseCat[0] = RNGC catalogue
                        //UseCat[1] = IC catalogue
                        //UseCat[2] = Messier catalogue
                        //UseCat[3] = Lynd dark nebulae
                        //UseCat[4] = Barnard dark nebulae
                        //UseCat[5] = Arp peculiar galaxies
                        //UseCat[7] = RC3 catalogue of galaxies (with size information)
                        //UseCat[6] = Zwicky catalogue
                        //UseCat[8] = Princeton pulsars
                        //UseCat[9] = Monela globular clusters
    bool DrawPPath[9];
    bool DrawObjLab[22];//Print labels for the objects on the map
    float MajLngInc;    //Major grid longitudinal coordinate
    float MinLngInc;    //Minor grid longitudinal coordinate
    float MajLatInc;    //Major grid latitudinal coordinate
    float MinLatInc;    //Minor grid latitudinal coordinate
    int w;    //Map width
    int w2;   //Map half width
    int h;    //Map height
    int h2;   //Map half height
    int MouseCoordType;   //0=Equatorial, 1=Horizon, 2=Galactic, 3=Ecliptic
    int CenterCoordType;  //0=Equatorial, 1=Horizon, 2=Galactic, 3=Ecliptic
    bool ShowStars;
    bool ShowDeepSky;
    bool ShowPlanets;
    bool ShowGrid;
    bool ShowHorLine;
    bool ShowEclLine;
    bool ShowGalLine;
    bool ShowTools;
    bool ShowLegend;
    bool ShowPlanetPaths;
    int StarSizes[12];
    int PlanetSymbol[14]; //The symbols to use for the planets
                          //0=Sun, 1=Mercury, 2=Venus,
                          //3=Mars, 4=Jupiter, 5=Saturn,
                          //6=Uranus, 7=Neptune, 8=Pluto,
                          //9=Earth's Moon, 10=Minor planets,
                          //11=Comets, 12=Artificial satelites
                          //13=Other moons
    int RedrawInterval;   //Interval at which to update the display
    float ClockRate;      //Rate at which the clock is incremented
    bool DrawConstBound;
    bool DrawConstFig;
    bool DrawConstLab;
    int NSunSat;
    int NEarSat;
    int NJupSat;
    int NMarSat;
    int NSatSat;
    bool Topocentric;
    float PlanetResolution;
};
//Constructor for Settings (loads default values)
Settings::Settings() :
  ProgPath("C:\\Sky Atlas\\"),
  HorizonMask(true),
  MaxStarMag(500),
  Projection(0),
  R0(300),
  DaylightSavings(true),
  TimeZone(8),
  lighttime(true),
  refract(false),
  MouseCoordType(0),
  CenterCoordType(0),
  DrawConstBound(true),
  DrawConstFig(true),
  DrawConstLab(true),
  NSunSat(9),
  NEarSat(1),
  NJupSat(0),
  NMarSat(0),
  NSatSat(0),
  ShowHorLine(true),
  ShowEclLine(true),
  ShowGalLine(true),
  ShowPlanetPaths(true),
  RedrawInterval(0),
  PlanetResolution(4)
{
}
//---------------------------------------------------------------------------
//Class to hold the color settings
class Colors{
  public:
    Colors();//Constructor
    Graphics::TColor Hor;
    Graphics::TColor Ecl;
    Graphics::TColor Gal;
    Graphics::TColor Sky;
    Graphics::TColor NightSky;
    Graphics::TColor BackGnd;
    Graphics::TColor HighLight;
    Graphics::TColor MainGrid;
    Graphics::TColor SubGrid;
    Graphics::TColor GridLab;
    Graphics::TColor ConstFig;
    Graphics::TColor ConstLab;
    Graphics::TColor ConstBnd;
    Graphics::TColor GalOutline;
};
//Constructor
Colors::Colors() :
  Hor((Graphics::TColor)0xd06090),
  Ecl((Graphics::TColor)0xdddddd),
  Gal((Graphics::TColor)0x0090b0),
  Sky((Graphics::TColor)0x000000),
  NightSky((Graphics::TColor)0x000000),
  BackGnd((Graphics::TColor)0x803050),
  HighLight((Graphics::TColor)0x00a0ff),
  MainGrid((Graphics::TColor)0x0070a0),
  SubGrid((Graphics::TColor)0x004080),
  GridLab((Graphics::TColor)0xffffff),
  ConstFig((Graphics::TColor)0xd04060),
  ConstLab((Graphics::TColor)0x50a010),
  ConstBnd((Graphics::TColor)0x90f000)
{
}
//---------------------------------------------------------------------------
//Class to hold the angular settings
class Angles{
  public:
    Angles();//Constructor
    float incl;    //Elevation at the center of the screen (not necessarily
                   //equal to the elevation in the sky)
    float elev;    //Elevation of an object in the sky
    float cosi;    //Cosine of the elevation (screen)
    float sini;    //Sine of the elevation (screen)
    float i_ori;   //Origin of the elevation
    float azim;    //Azimuth at the center of the screen
    float cos_azim;//Azimuth at the center of the screen
    float sin_azim;//Azimuth at the center of the screen
    float a_ori;   //Origin of the azimuth
    float l_ori;   //Longitudinal origin in the geocentric eq. system
                   //This sets the local sidereal time.
    float lng;     //Geographic longitude (always measured W of Greenwich)
    float lat;     //Geographic latitude
    float cos_lat; //Cosine of geographic latitude
    float sin_lat; //Sine of geographic latitude
    float sin_ecl; //Sine of the inclination of the ecliptic
    float cos_ecl; //Cosine of the inclination of the ecliptic
    float alt;     //Elevation above sea level (in metres)
};
//Constructor
Angles::Angles() :
    incl(-0.7785398),
    i_ori(0.000001),
    azim(3.14),
    a_ori(0.000001),
    l_ori(0),
    lat(0.87266),
    lng(2.147918),
    alt(0)
{
}
//---------------------------------------------------------------------------
//Structure to hold the planet and satelite data
struct OrbitalElements{
  AnsiString Name;
  double Epoch;      //The epoch (as a julian date) to which
                     //the elements are referenced
  float OE[19];
  float Diam;        //In Earth radii
  float Oblateness;  //fractional
  float Mass;        //In Earth masses
  float Period;      //In Earth days (equatorial region)
  float Inclination; //In radians
  int SymbClass;     //An index representing the symbol class to use
  double PathSD;     //Start date for the displayed planet path (as Julian date)
  double PathED;     //End date for the displayed planet path (as Julian date)
  float Increment;     //Time increment for drawing the planet path
  bool ShowPath;     //Flag indicates if path is drawn
  bool ShowPoints;   //Flag indicates if date points are drawn
  bool ShowLines;    //Flag indicates if lines are drawn between date points
  bool ShowLabels;   //Flag indicates if date labels are drawn
  TColor PointCol;   //Color for date points
  TColor LineCol;    //Color for lines between date points
  TColor LabelCol;   //Color for date point labels
};
//---------------------------------------------------------------------------
//Structure to hold the selected object list data
struct SelectedObjects{
  float ra;        //Right ascension
  float dec;       //Declination
  String Name; //Name of the object as displayed in the selection list
  int CatIndex;    //Index of the catalogue to which the object belongs
                   //-2 = stars, -1 = solar system objects
                   // 0 = RNGC, 1 = IC, 2 = Messier, etc...
  int CatNum;      //Catalogue number of the object
  int CatExt;      //Catalogue number extension (some catalogues use this, eg. RNGC)
  bool Highlight;  //Highlight state of the object (if drawn)
};
//---------------------------------------------------------------------------
//Structure to hold the highlighted object list data
struct HighlightObjects{
  float ra;
  float dec;
  int CatIndex;    //Index of the catalogue to which the object belongs
  int CatNum;      //Catalogue number of the object
  int CatExt;      //Catalogue number extension (some catalogues use this, eg. RNGC)
};

