//---------------------------------------------------------------------------
#ifndef MapFormH
#define MapFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "cspin.h"
#include <Mask.hpp>
#include "CSPIN.h"
#include <Graphics.hpp>
//---------------------------------------------------------------------------
class TMapF : public TForm
{
__published:	// IDE-managed Components
    TMainMenu *MainMenu1;
    TMenuItem *Show1;
    TMenuItem *Print1;
    TMenuItem *PrintPreview1;
    TMenuItem *Stars1;
    TMenuItem *Planets1;
    TMenuItem *Deepskyobjects1;
    TMenuItem *Starlabels1;
    TMenuItem *Deepskyobjectlabels1;
    TMenuItem *Planetlabels1;
    TMenuItem *N1;
    TMenuItem *N2;
    TPanel *Panel1;
    TPanel *Panel2;
    TImage *MapImage;
    TLabel *Label1;
    TCSpinEdit *StarSizes;
    TLabel *Label2;
    TMaskEdit *RA;
    TLabel *Label3;
    TLabel *Label4;
    TMaskEdit *Dec;
    TButton *RedrawBtn;
    TImage *LegendImg;
    TCheckBox *ShowStarLabels2;
    TLabel *Label5;
    TLabel *Label6;
    TCSpinEdit *RAGrid;
    TCSpinEdit *DecGrid;
    TButton *PrintBtn;
    TCheckBox *ShowGrid2;
    TLabel *Label7;
    TCSpinEdit *FOV;
    void __fastcall FormActivate(TObject *Sender);
    
    
    void __fastcall RedrawBtnClick(TObject *Sender);
    void __fastcall Print1Click(TObject *Sender);
    
private:	// User declarations
public:		// User declarations
    __fastcall TMapF(TComponent* Owner);
    void __fastcall DrawMap(TObject *Sender);
    void __fastcall TMapF::DrawGrid(float *min_lambda,float *max_lambda,\
      float *min_q,float *max_q);
    void __fastcall TMapF::DrawGridLabel(int x, int y,String label);
    void __fastcall TMapF::DrawLine(int n,bool ForceVerify);
    void __fastcall TMapF::DrawIntersects(int PlaneIndex);
    void __fastcall TMapF::ShowStars(float sc);
    void __fastcall TMapF::DrawStar(float *RA,float *dec,int *symb_index,\
      float sc,int CatNum);
    void __fastcall TMapF::FormatStarName(String Flamsteed,String ComName,int x1,int y1);
    void __fastcall TMapF::DrawStarLabels(void);
    void __fastcall TMapF::DrawConstFig(void);
    void __fastcall TMapF::SetForm(TObject *Sender);
    void __fastcall TMapF::LoadSettings(TObject *Sender);
    void __fastcall TMapF::DrawLegend(TObject *Sender, float sc);
};
//---------------------------------------------------------------------------
extern PACKAGE TMapF *MapF;
//---------------------------------------------------------------------------
#endif
