//---------------------------------------------------------------------------
#ifndef ObjInfoH
#define ObjInfoH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "cspin.h"
#include <Dialogs.hpp>
#include "CSPIN.h"
#include <Graphics.hpp>
//---------------------------------------------------------------------------
class TObjectInfo : public TForm
{
__published:	// IDE-managed Components
    TPageControl *PageControl;
    TTabSheet *DeepSky;
    TTabSheet *StarPage;
    TTabSheet *PlanetPage;
    TTabSheet *Selections;
    TButton *AddToListBut;
    TBitBtn *OkBut;
    TButton *HighlightBut;
    TButton *CenterBut;
    TLabel *dsNum;
    TLabel *dsName;
    TLabel *dsType;
    TLabel *dsRA;
    TLabel *dsDec;
    TLabel *dsVMag;
    TLabel *dsGalRA;
    TLabel *dsElevation;
    TLabel *dsGalDec;
    TLabel *dsAzimuth;
    TRichEdit *Desc;
    TButton *ShowAsRNGC;
    TButton *ShowAsIC;
    TButton *ShowAsMes;
    TLabel *stNum;
    TLabel *Pre;
    TLabel *Greek;
    TLabel *Suf;
    TLabel *stRA;
    TLabel *stDec;
    TLabel *stRApm;
    TLabel *stDECpm;
    TLabel *stVmag;
    TLabel *stType;
    TLabel *stElevation;
    TLabel *stAzimuth;
    TLabel *plName;
    TLabel *plRA;
    TLabel *plDec;
    TLabel *plRiseTime;
    TLabel *plSetTime;
    TLabel *plElevation;
    TLabel *plAzimuth;
    TLabel *plIllumination;
    TListBox *ObjList;
    TButton *RemoveBut;
    TBevel *Bevel1;
    TPanel *Panel1;
    TImage *PImage;
    TButton *SelectBut;
    TBitBtn *ZoomInBut;
    TBitBtn *Zoom1But;
    TBitBtn *ZoomOutBut;
    TBitBtn *XFlipBut;
    TBitBtn *YFlipBut;
    TLabel *dsRiseTime;
    TLabel *dsSetTime;
    TLabel *stSetTime;
    TLabel *stRiseTime;
    TLabel *stGalRA;
    TLabel *stGalDec;
    TBevel *Bevel2;
    TUpDown *PlanetRes;
    TSpeedButton *ShowSatPath;
    TLabel *SatName;
    TLabel *AngDist;
    TLabel *PosAngle;
    TBevel *Bevel3;
    TLabel *plMag;
    TButton *XCatBtn;
    TTabSheet *FindPage;
    TGroupBox *GroupBox1;
    TLabel *Label2;
    TCSpinEdit *FindNum_;
    TLabel *Label3;
    TComboBox *FindExt_;
    TGroupBox *GroupBox2;
    TCheckBox *CenterOnFound;
    TListBox *SearchCat_;
    TButton *FindByCatBtn;
    TLabel *Label1;
    TListBox *FoundList;
    TLabel *Label4;
    TEdit *SearchString_;
    TButton *FindByStrBtn;
    TCSpinEdit *NMatch_;
    TLabel *Label5;
    TLabel *SearchIndicator;
    TPanel *OPanel;
    TImage *OImage;
    TOpenDialog *OpenD;
    TButton *FullImgBtn;
    void __fastcall FormActivate(TObject *Sender);
    void __fastcall ShowAsICClick(TObject *Sender);
    void __fastcall ShowAsRNGCClick(TObject *Sender);
    void __fastcall ShowAsMesClick(TObject *Sender);
    void __fastcall HighlightButClick(TObject *Sender);
    void __fastcall AddToListButClick(TObject *Sender);
    void __fastcall RemoveButClick(TObject *Sender);
    void __fastcall SelectButClick(TObject *Sender);
    void __fastcall CenterButClick(TObject *Sender);
    void __fastcall ObjListKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall SelectionsShow(TObject *Sender);
    void __fastcall SelectionsHide(TObject *Sender);
    void __fastcall ObjListClick(TObject *Sender);
    void __fastcall ZoomInClick(TObject *Sender);
    void __fastcall ZoomOutButClick(TObject *Sender);
    void __fastcall Zoom1ButClick(TObject *Sender);
    void __fastcall XFlipButClick(TObject *Sender);
    void __fastcall YFlipButClick(TObject *Sender);
    void __fastcall PlanetResClick(TObject *Sender, TUDBtnType Button);
    void __fastcall TimeDateButClick(TObject *Sender);
    void __fastcall ShowSatPathClick(TObject *Sender);
    void __fastcall PImageMouseMove(TObject *Sender, TShiftState Shift, int X, int Y);
    void __fastcall XCatBtnClick(TObject *Sender);
    void __fastcall FindByCatBtnClick(TObject *Sender);
    void __fastcall FindByStrBtnClick(TObject *Sender);
    void __fastcall FoundListClick(TObject *Sender);
    void __fastcall OImageClick(TObject *Sender);
    void __fastcall FullImgBtnClick(TObject *Sender);
        void __fastcall OkButClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
public:		// User declarations
    __fastcall TObjectInfo(TComponent* Owner);
    void __fastcall ShowStarInfo(TObject *Sender,int CatNum);
    AnsiString __fastcall FormatName(TObject *Sender,String Flamsteed,String ComName,bool Display);
    void __fastcall PlanetInfo(TObject *Sender);
    void __fastcall ShowICInfo(TObject *Sender);
    void __fastcall ShowRNGCInfo(TObject *Sender);
    void __fastcall ShowMesInfo(TObject *Sender);
    void __fastcall DrawPlanet(double T);
    void __fastcall DrawPlanetDisk(double T);
    void __fastcall DrawPlanetGrid(int n,float res,double T_);
    void __fastcall ShowLyndInfo(TObject *Sender);
    void __fastcall ShowBarnInfo(TObject *Sender);
    void __fastcall ShowArpInfo(TObject *Sender);
    void __fastcall ShowRC3Info(TObject *Sender);
    void __fastcall ShowInfo(TObject *Sender, struct TIME_ curtime);
    void __fastcall DrawMoonDisk();
    void __fastcall IlluminateDisk(int N);
    void __fastcall SaturnRings(float res, double T);
    void __fastcall ShowObjectInfo(TObject *Sender);
    void __fastcall DisplayImage(bool Found,String filename);
};
//---------------------------------------------------------------------------
extern PACKAGE TObjectInfo *ObjectInfo;
//---------------------------------------------------------------------------
#endif
