//---------------------------------------------------------------------------
#include <vcl.h>
#include <dos.h>
#include <conio.h>
#include <fstream.h>
#include <time.h>
#include <math.h>
#include <stdio.h>
#define NR_END 1
#define FREE_ARG char*
#pragma hdrstop

#include "ServiceRoutines.h"
#include "ObjInfo.h"
#include "Main.h"

#pragma package(smart_init)

double junk=0;

extern Angles AL;
extern Settings PS;
extern Colors CS;

extern bool SouthHemisphere;
extern int FavLocNum;      //The number of favorite location indices
extern TThreadList *pCache;
extern double OElem[213][15]; //Instantaneous orbital elements
                         //0-99: satelites of the sun
                         //100-199: satelites of earth
                         //200-201: satelites of mars
                         //202-208: Cassini and Herschel's satelites of saturn
                         //209-212: jupiter's galilean satelites
extern OrbitalElements SSData[213]; //Information for all solar system objects
extern struct TIME_ StartTime;
extern struct DATE_ StartDate;

//Pointers to object database matrices
//Stars
extern float *ra_star;
extern float *dec_star;
extern int *num_star;
extern short *symb_star;
extern int **StarBlkIndex;
extern short **StarBlkNum;
extern int NStars;
//RNGC objects
extern float **ra_ngc;
extern float **dec_ngc;
extern short **mag_ngc;
extern short **num_ngc;
extern short **ext_ngc;
extern short **type_ngc;
extern bool **show_ngc;
extern short *NumNGC;
//IC objects
extern float **ra_ic;
extern float **dec_ic;
extern short **mag_ic;
extern short **num_ic;
extern short **type_ic;
extern short **cat_ic;
extern bool **show_ic;
extern short *NumIC;
//Messier objects
extern float ra_mes[110];
extern float dec_mes[110];
extern short mag_mes[110];
extern short type_mes[110];
extern short mes_ngc[110];
extern bool show_mes[110];
//Lynd clouds
extern float **ra_lyn;
extern float **dec_lyn;
extern short **num_lyn;
extern short *NumLyn;
//Barnard clouds
extern float *ra_bar;
extern float *dec_bar;
extern short *num_bar;
extern short *ext_bar;
//Arp galaxies
extern float *ra_arp;
extern float *dec_arp;
//RC3 galaxies
extern float *ra_rc3;
extern float *dec_rc3;
extern float *a_rc3;  //major axis
extern float *b_rc3;  //minor axis
extern float *pa_rc3; //position angle
extern float *mag_rc3;
extern short *num_rc3;
extern bool *show_rc3;
extern short *NumRC3;

//Constellations
extern int ConstTot[103];
extern float ConstRA[70318];
extern float ConstDec[70318];
extern int ConstFigNSeg[79];
extern int ConstFigNPts[181];
extern float ConstFigRA[1000];
extern float ConstFigDec[1000];
extern float ConstLabRA[88];
extern float ConstLabDec[88];
extern String ConstLabel[88];

//Functions
void FirstCircle(float *angle);
void FirstCircle2(double *angle);
void Planar(float *X1,float *x,float *y);
void Lambert(float *X1,float *x,float *y);
void Lagrange(float *X1,float *x,float *y);
void Mercator(float *X1,float *x,float *y);

float *vector(int nl, int nh);
void free_vector(float *v, int nl, int nh);
double *d_vector(int nl, int nh);
void free_d_vector(double *v, int nl, int nh);
short *s_vector(int nl,int nh);
void free_s_vector(short *v, int nl, int nh);
int *i_vector(int nl,int nh);
void free_i_vector(int *v, int nl, int nh);
bool *b_vector(int nl,int nh);
void free_b_vector(bool *v, int nl, int nh);
float **matrix(int nrl, int nrh, int ncl, int nch);
void free_matrix(float **m,int nrl,int nrh,int ncl,int nch);
short **s_matrix(int nrl, int nrh, int ncl, int nch);
void free_s_matrix(short **m,int nrl,int nrh,int ncl,int nch);
int **i_matrix(int nrl, int nrh, int ncl, int nch);
void free_i_matrix(int **m,int nrl,int nrh,int ncl,int nch);
void free_matrices(int database,int vector_size);
bool **b_matrix(int nrl, int nrh, int ncl, int nch);
void free_b_matrix(bool **m,int nrl,int nrh,int ncl,int nch);

struct TIME_ GetTime(void);
struct DATE_ GetDate(void);
double GregToJul(TIME_ Greg_t);
void LTtoUT(TIME_ *t);
bool IsLeapYear(int year);
String GetDecString(float dec, bool HiPrecision);
String GetRAString(float ra);
void GetOE_(int i,double *T);

void Precess_sp(float *ra,float *dec,double *T, double *T0);
void Precess(float *X,double *T, double *T0);
void SphToCosines(float *X);
void XRotate(float *X,float *sinlat,float *coslat);
void YRotate(float *X,float *sinangle,float *cosangle);
void ZRotate(float *X,float *sinangle,float *cosangle);
void XRotate2(double *x,double *y,double *z,double *sinangle,double *cosangle);
void YRotate2(double *x,double *y,double *z,double *sinangle,double *cosangle);
void ZRotate2(double *x,double *y,double *z,double *sinangle,double *cosangle);
void HorToEqu(float *h,float *Az,float *q,float *lambda);
void EquToHor(float *lambda,float *q,float *Az,float *h,float SidTime);
void ScreenToSky(int *x,int *y,float *q,float *lambda);
void CosinesToSph(float *X);
void SphToCosines2(double *X);
void InverseLambert(float *X);
void InversePlanar(float *X);
void InverseMercator(float *X);

void LoadLocation(int n,String *name,float *longitude,float *latitude,\
  float *elevation, float *TimeZone,bool *DaylightSavings);

double StripBlank(String s);
bool ReadBool(FILE *infile);
double ReadDouble(FILE *infile);
int ReadInt(FILE *infile);
String ReadStr(FILE *infile);
void WriteBool(FILE *outfile,bool bval);
void WriteDouble(FILE *outfile,double fval);
void WriteInt(FILE *outfile,int ival);
void WriteStr(FILE *outfile,String sbuf);
void SkipToStr(FILE *infile,String str,int NSkip);
bool PlanetToGeoCoord(int *N, double *r, double *T, double *lambda,
  double *phi, double *dalpha, double *ddelta,bool Initialize);
//---------------------------------------------------------------------------
//Planet related functions
//---------------------------------------------------------------------------
//Returns the ecliptic coordinates HCoord[r, beta, lambda] of
//satelite "n" at time T (expressed as the julian date).
void EclSatCoord(int n,double *T)
{
  //Instantaneous Orbital Elements (contained in OElem[i][j])
  //
  //N = longitude of the ascending node, OElem[i][0]
  //i = inclination of the ecliptic, OElem[i][1]
  //w = argument of perihelion, OElem[i][2]
  //a = semi-major axis of orbit, OElem[i][3]
  //e = eccentricity, OElem[i][4]
  //M = mean anomaly, OElem[i][5]
  //x = ecliptic rectangular x coordinate, OElem[i][6]
  //y = ecliptic rectangular y coordinate, OElem[i][7]
  //z = ecliptic rectangular z coordinate, OElem[i][8]
  //lon = longitude, OElem[i][9]
  //lat = latitude, OElem[i][10]
  //r = distance from the origin, OElem[i][11]

  double E, E0, E1, v, xv, yv, r, arg, lon;

  //Case for the sun
  if (n==0){
    //Compute the eccentric anomaly
    E=OElem[0][5]+OElem[0][4]*sin(OElem[0][5])*(1.0+OElem[0][4]*cos(OElem[0][5]));
    E1=E;
    do {
      E0=E1;
      E1=E0-(E0-OElem[0][4]*sin(E0)-OElem[0][5])/(1-OElem[0][4]*cos(E0));
    } while (fabs(E0-E1)>1e-8);
    E=E1;

    //Compute distance r and true anomaly v
    xv=cos(E)-OElem[0][4];
    yv=sqrt(1.0-OElem[0][4]*OElem[0][4])*sin(E);
    v=atan2(yv,xv);
    r=sqrt(xv*xv+yv*yv);

    //True longitude
    lon=v+OElem[0][2];

    //Convert to rectangular coordinates
    OElem[0][6]=r*cos(lon);
    OElem[0][7]=r*sin(lon);
    OElem[0][8]=0;
    OElem[0][9]=lon;
    OElem[0][10]=0;
    OElem[0][11]=r;
  }

  //Case for planets other than pluto and all satelites
  //of any planet
  if (n!=8 && n!=0 && n<209){
    //Compute the eccentric anomaly (rough estimate)
    E=OElem[n][5]+OElem[n][4]*sin(OElem[n][5])*(1.0+OElem[n][4]*cos(OElem[n][5]));
    E1=E;
    do {
      E0=E1;
      E1=E0-(E0-OElem[n][4]*sin(E0)-OElem[n][5])/(1-OElem[n][4]*cos(E0));
    } while (fabs(E0-E1)>1e-8);
    E=E1;

    //Compute distance r and true anomaly v
    xv=OElem[n][3]*(cos(E)-OElem[n][4]);
    yv=OElem[n][3]*sqrt(1.0-OElem[n][4]*OElem[n][4])*sin(E);
    v=atan2(yv,xv);
    FirstCircle2(&v);
    r=sqrt(xv*xv+yv*yv);

    //Get position in space (referred to ecliptic, planetary equator and meridian or laplacian plane)
    OElem[n][6]=r*(cos(OElem[n][0])*cos(v+OElem[n][2])-sin(OElem[n][0])*sin(v+OElem[n][2])*cos(OElem[n][1]));
    OElem[n][7]=r*(sin(OElem[n][0])*cos(v+OElem[n][2])+cos(OElem[n][0])*sin(v+OElem[n][2])*cos(OElem[n][1]));
    OElem[n][8]=r*sin(v+OElem[n][2])*sin(OElem[n][1]);

    //Get longitude and latitude
    arg=atan2(OElem[n][7],OElem[n][6]);
    FirstCircle2(&arg);
    OElem[n][9]=arg;
    OElem[n][10]=atan2(OElem[n][8],sqrt(OElem[n][6]*OElem[n][6]+OElem[n][7]*OElem[n][7]));
    OElem[n][11]=r;
  }

  //Case for pluto
  if (n==8){
    double d,S,P;

    d=*T-SSData[n].Epoch;
    S=50.03 + 0.033459652*d;
    P=238.95 + 0.003968789*d;

    OElem[8][9]=238.9508+0.00400703*d-19.799*sin(P)+19.848*cos(P)\
      +0.897*sin(2*P)-4.956*cos(2*P)+0.610*sin(3*P)+1.211*cos(3*P)\
      -0.341*sin(4*P)-.190*cos(4*P)+0.128*sin(5*P)-0.034*cos(5*P)\
      -.038*sin(6*P)+0.031*cos(6*P)+0.020*sin(S-P)-0.010*cos(S-P);

    OElem[8][10]=-3.9082-5.453*sin(P)-14.975*cos(P)+3.527*sin(2*P)\
      -14.975*cos(P)+3.527*sin(2*P)+1.673*cos(2*P)-1.051*sin(3*P)\
      +0.328*cos(3*P)+0.179*sin(4*P)-0.292*cos(4*P)+0.019*sin(5*P)\
      +0.100*cos(5*P)-0.031*sin(6*P)-0.026*cos(6*P)+0.011*cos(S-P);

    OElem[8][11]=40.72+6.68*sin(P)+6.90*cos(P)-1.18*sin(2*P)\
      -0.03*cos(2*P)+0.15*sin(3*P)-0.14*cos(3*P);

    //Convert to rectangular coordinates
    OElem[8][6]=OElem[8][11]*cos(OElem[8][9])*cos(OElem[8][10]);
    OElem[8][7]=OElem[8][11]*sin(OElem[8][9])*cos(OElem[8][10]);
    OElem[8][8]=OElem[8][11]*sin(OElem[8][10]);
  }

  //Perturbation corrections - case for the moon
  if (n==100){
    double Lm,Dm,F,Ls;
    Ls=OElem[0][2]+OElem[0][5];
    FirstCircle2(&Ls);
    Lm=OElem[100][5]+OElem[100][2]+OElem[100][0];
    FirstCircle2(&Lm);
    Dm=Lm-Ls;
    FirstCircle2(&Dm);
    F=Lm-OElem[100][0];

    OElem[100][9]=OElem[100][9]-.022235*sin(OElem[100][5]-2*Dm)\
      +0.011484*sin(2*Dm)\
      -0.0032463*sin(OElem[0][5])\
      -0.0010297*sin(2*OElem[100][5]-2*Dm)\
      -9.9484e-4*sin(OElem[100][5]-2*Dm+OElem[0][5])\
      +9.2502e-4*sin(OElem[100][5]+2*Dm)\
      +8.0285e-4*sin(2*Dm-OElem[0][5])\
      +7.1558e-4*sin(OElem[100][5]-OElem[0][5])\
      -6.1086e-4*sin(Dm)\
      -5.4105e-4*sin(OElem[100][5]+OElem[0][5])\
      -2.6180e-4*sin(2*F-2*Dm)\
      +1.9199e-4*sin(OElem[100][5]-4*Dm);

    OElem[100][10]=OElem[100][10]-3.0194e-3*sin(F-2*Dm)\
      -9.5993e-4*sin(OElem[100][5]-F-2*Dm)\
      -8.0285e-4*sin(OElem[100][5]+F-2*Dm)\
      +5.7596e-4*sin(F+2*Dm)\
      +2.9671e-4*sin(2*OElem[100][5]+F);

    OElem[100][11]=OElem[100][11]-0.58*cos(OElem[100][5]-2*Dm)-.46*cos(2*Dm);

    //Convert to rectangular coordinates
    OElem[100][6]=OElem[100][11]*cos(OElem[100][9])*cos(OElem[100][10]);
    OElem[100][7]=OElem[100][11]*sin(OElem[100][9])*cos(OElem[100][10]);
    OElem[100][8]=OElem[100][11]*sin(OElem[100][10]);
  }

  //Perturbation corrections - case for Jupiter
  if (n==4){
    OElem[4][9]=OElem[4][9]-5.7945e-3*sin(2*OElem[4][5]-5*OElem[5][5]-1.17984)\
      -9.7738e-4*sin(2*OElem[4][5]-2*OElem[5][5]+0.36652)\
      +7.3304e-4*sin(3*OElem[4][5]-5*OElem[5][5]+0.36652)\
      -6.2832e-4*sin(OElem[4][5]-2*OElem[5][5])+3.8397e-4*cos(OElem[4][5]-OElem[5][5])\
      +4.0143e-4*sin(2*OElem[4][5]-3*OElem[5][5]+0.90757)\
      -2.7925e-4*sin(OElem[4][5]-5*OElem[5][5]-1.2043);

    //Convert to rectangular coordinates
    OElem[4][6]=OElem[4][11]*cos(OElem[4][9])*cos(OElem[4][10]);
    OElem[4][7]=OElem[4][11]*sin(OElem[4][9])*cos(OElem[4][10]);
    OElem[4][8]=OElem[4][11]*sin(OElem[4][10]);
  }

  //Perturbation corrections - case for Saturn
  if (n==5){
    OElem[5][9]=OElem[5][9]+1.4172e-2*sin(2*OElem[4][5]-5*OElem[5][5]-1.17984)\
      -3.9968e-3*cos(2*OElem[4][5]-4*OElem[5][5]-3.4906e-2)\
      +2.0769e-3*sin(OElem[4][5]-2*OElem[5][5]-5.2360e-2)\
      +8.0285e-4*sin(2*OElem[4][5]-6*OElem[5][5]-1.2043)\
      +2.4435e-4*sin(OElem[4][5]-3*OElem[5][5]+0.55851);

    OElem[5][10]=OElem[5][10]-3.4906e-4*cos(2*OElem[4][5]-4*OElem[5][5]-3.4906e-2)\
      +3.1416e-4*sin(2*OElem[4][5]-6*OElem[5][5]-0.85521);

    //Convert to rectangular coordinates
    OElem[5][6]=OElem[5][11]*cos(OElem[5][9])*cos(OElem[5][10]);
    OElem[5][7]=OElem[5][11]*sin(OElem[5][9])*cos(OElem[5][10]);
    OElem[5][8]=OElem[5][11]*sin(OElem[5][10]);
  }

  //Perturbation corrections - case for Uranus
  if (n==6){
    OElem[6][9]=OElem[6][9]+6.9813e-4*sin(OElem[5][5]-2*OElem[6][5]+0.10472)\
      +6.1086e-4*sin(OElem[5][5]-3*OElem[6][5]+0.57596)\
      -2.6180e-4*sin(OElem[4][5]-OElem[6][5]+0.34907);

    //Convert to rectangular coordinates
    OElem[6][6]=OElem[6][11]*cos(OElem[6][9])*cos(OElem[6][10]);
    OElem[6][7]=OElem[6][11]*sin(OElem[6][9])*cos(OElem[6][10]);
    OElem[6][8]=OElem[6][11]*sin(OElem[6][10]);
  }
}
//---------------------------------------------------------------------------
//Converts the ecliptic coordinates to geocentric (topocentric if
//applicable) equatorial right-ascension and declination for
//a satelite of the sun or a planet.
void GeoSatCoord(int n)
{
  double x,y,z,sinangle,cosangle,x2,y2,z2,arg;
  double gclat,rho,HA,g,mpar,*X_,T,T0;
  float *X_f;
  X_=d_vector(0,3);
  X_f=vector(0,3);

  //Case for the sun
  if (n==0){
    x=OElem[0][6];
    y=OElem[0][7]*AL.cos_ecl;
    z=OElem[0][7]*AL.sin_ecl;
    x2=x*x;
    y2=y*y;
    arg=atan2(y,x);              //RA
    FirstCircle2(&arg);
    OElem[0][9]=arg;
    OElem[0][10]=atan2(z,sqrt(x2+y2));
    OElem[0][11]=sqrt(x2+y2+z*z);
  }

  //Case for solar satelites
  if (n<100 && n!=0){
    //Get the geocentric coordinates
    OElem[n][6]=OElem[n][6]+OElem[0][6];
    OElem[n][7]=OElem[n][7]+OElem[0][7];
    OElem[n][8]=OElem[n][8]+OElem[0][8];

    //Convert to equatorial coordinates
    x=OElem[n][6];
    y=OElem[n][7];
    z=OElem[n][8];
    sinangle=-AL.sin_ecl;
    cosangle=AL.cos_ecl;
    XRotate2(&x,&y,&z,&sinangle,&cosangle);
    OElem[n][6]=x;
    OElem[n][7]=y;
    OElem[n][8]=z;
    x2=x*x;
    y2=y*y;
    arg=atan2(y,x);              //RA
    FirstCircle2(&arg);
    OElem[n][9]=arg;
    OElem[n][10]=atan2(z,sqrt(x2+y2));   //Declination
    OElem[n][11]=sqrt(x2+y2+z*z);        //Distance
  }

  //Case for earth satelites
  if (n>99&&n<200){
    //Convert to equatorial coordinates
    x=OElem[n][6];
    y=OElem[n][7];
    z=OElem[n][8];
    sinangle=-AL.sin_ecl;
    cosangle=AL.cos_ecl;
    XRotate2(&x,&y,&z,&sinangle,&cosangle);
    OElem[n][6]=x;
    OElem[n][7]=y;
    OElem[n][8]=z;
    x2=x*x;
    y2=y*y;
    z2=z*z;
    arg=atan2(y,x);              //RA
    FirstCircle2(&arg);
    OElem[n][9]=arg;
    OElem[n][10]=atan2(z,sqrt(x2+y2));   //Declination
    OElem[n][11]=sqrt(x2+y2+z2);        //Distance

    if (PS.Topocentric){
      //Apply topocentric correction
      mpar=asin(1/OElem[n][11]);

      gclat=AL.lat-3.358013e-3*sin(2*AL.lat);
      rho=0.99883 + 0.00167*cos(2*AL.lat) + AL.alt; //in earth radii

      HA=AL.l_ori-OElem[n][9];
      FirstCircle2(&HA);
      g=atan(tan(gclat)/cos(HA));
      FirstCircle2(&g);

      //Convert to topocentric values
      OElem[n][9]=OElem[n][9]-mpar*rho*cos(gclat)*sin(HA)/cos(OElem[n][10]);
      OElem[n][10]=OElem[n][10]-mpar*rho*sin(gclat)*sin(g-OElem[n][10])/sin(g);
      X_[0]=OElem[n][11];
      X_[1]=OElem[n][10];
      X_[2]=OElem[n][9];
      SphToCosines2(X_);
      OElem[n][6]=X_[0];
      OElem[n][7]=X_[1];
      OElem[n][8]=X_[2];
    }
  }

  //Satelites of Mars
  if (n>199 && n<202){
    double sini, cosi;

    x=OElem[n][6];
    y=OElem[n][7];
    z=OElem[n][8];

    //Rotate about the x-axis by the negative inclination
    //of the Laplacian plane
    sini=-sin(SSData[n].OE[14]);
    cosi=cos(SSData[n].OE[14]);
    XRotate2(&x,&y,&z,&sini,&cosi);

    //Rotate about the z-axis by the negative of the node
    //of the Laplacian plane
    sini=-sin(SSData[n].OE[12]);
    cosi=cos(SSData[n].OE[12]);
    ZRotate2(&x,&y,&z,&sini,&cosi);

    //Precess coordinates from 1950 geocenter
    X_f[0]=x; X_f[1]=y; X_f[2]=z;
    T=PS.time.jul;
    T0=SSData[n].Epoch;
    Precess(X_f,&T,&T0);
    x=X_f[0]; y=X_f[1]; z=X_f[2];

    //Convert to geocentric equatorial coordinates
    OElem[n][6]=OElem[3][6]+x*4.263523271e-5;
    OElem[n][7]=OElem[3][7]+y*4.263523271e-5;
    OElem[n][8]=OElem[3][8]+z*4.263523271e-5;

    //Convert to spherical coordinates
    arg=atan2(OElem[n][7],OElem[n][6]);
    FirstCircle2(&arg);
    OElem[n][9]=arg;
    OElem[n][10]=atan2(OElem[n][8],sqrt(OElem[n][6]*OElem[n][6]+OElem[n][7]*OElem[n][7]));
    OElem[n][11]=sqrt(OElem[n][6]*OElem[n][6]+OElem[n][7]*OElem[n][7]+OElem[n][8]*OElem[n][8]);
  }

  //First four satelites of Saturn
  if (n>201 && n<206){
    //The coordinates are relative to the equator plane of
    //Saturn which is referenced to the ecliptic of 1950.
    //We must first convert these coordinates to ecliptic coordinates
    double sinomega_s=-sin(OElem[n][12]);  //Negative sine of node of Saturn's equatorial plane
    double cosomega_s=cos(OElem[n][12]);  //Cosine of node of Saturn's equatorial plane
    double sini_s=-sin(OElem[n][13]);  //Negative sine of inclination of Saturn's equatorial plane
    double cosi_s=cos(OElem[n][13]);  //Cosine of inclination of Saturn's equatorial plane

    //Rotate about the x-axis by the negative inclination
    //of Saturn's equatorial plane
    x=OElem[n][6];
    y=OElem[n][7];
    z=OElem[n][8];
    XRotate2(&x,&y,&z,&sini_s,&cosi_s);

    //Rotate about the z-axis by the negative of the node
    //of Saturn's equatorial plane
    ZRotate2(&x,&y,&z,&sinomega_s,&cosomega_s);

    //Convert the ecliptic coordinates to equatorial
    //(saturnocentric) coordinates.
    sinangle=-AL.sin_ecl;
    cosangle=AL.cos_ecl;
    XRotate2(&x,&y,&z,&sinangle,&cosangle);

    //Precess coordinates from 1950 geocenter
    X_f[0]=x; X_f[1]=y; X_f[2]=z;
    T=PS.time.jul;
    T0=2433282.0;
    Precess(X_f,&T,&T0);
    x=X_f[0]; y=X_f[1]; z=X_f[2];

    //Convert to true geocentric coordinates (centered on the earth)
    OElem[n][6]=OElem[5][6]+x*4.263523271e-5;
    OElem[n][7]=OElem[5][7]+y*4.263523271e-5;
    OElem[n][8]=OElem[5][8]+z*4.263523271e-5;

    //Convert to spherical coordinates
    arg=atan2(OElem[n][7],OElem[n][6]);
    FirstCircle2(&arg);
    OElem[n][9]=arg;
    OElem[n][10]=atan2(OElem[n][8],sqrt(OElem[n][6]*OElem[n][6]+OElem[n][7]*OElem[n][7]));
    OElem[n][11]=sqrt(OElem[n][6]*OElem[n][6]+OElem[n][7]*OElem[n][7]+OElem[n][8]*OElem[n][8]);
  }

  //Last three satelites of Saturn
  if (n>205 && n<209){
    //Convert ecliptic to earth equatorial (planetocentric) coordinates
    sinangle=-AL.sin_ecl;
    cosangle=AL.cos_ecl;
    x=OElem[n][6];
    y=OElem[n][7];
    z=OElem[n][8];
    XRotate2(&x,&y,&z,&sinangle,&cosangle);

    //Precess coordinates from 1950 geocenter
    X_f[0]=x; X_f[1]=y; X_f[2]=z;
    T=PS.time.jul;
    T0=2433282.0;
    Precess(X_f,&T,&T0);
    x=X_f[0]; y=X_f[1]; z=X_f[2];

    //Convert to true geocentric coordinates (centered on the earth)
    OElem[n][6]=OElem[5][6]-x*4.263523271e-5;
    OElem[n][7]=OElem[5][7]-y*4.263523271e-5;
    OElem[n][8]=OElem[5][8]-z*4.263523271e-5;

    //Convert to spherical coordinates
    arg=atan2(OElem[n][7],OElem[n][6]);
    FirstCircle2(&arg);
    OElem[n][9]=arg;
    OElem[n][10]=atan2(OElem[n][8],sqrt(OElem[n][6]*OElem[n][6]+OElem[n][7]*OElem[n][7]));
    OElem[n][11]=sqrt(OElem[n][6]*OElem[n][6]+OElem[n][7]*OElem[n][7]+OElem[n][8]*OElem[n][8]);
  }

  //Satelites of Jupiter
  if (n>208 && n<213){
    double sini, cosi, sinomega, cosomega;
    double w,t0;

    x=OElem[n][6];
    y=OElem[n][7];
    z=OElem[n][8];

    //Rotate about the x-axis by the negative inclination
    //of Jupiter's equatorial plane
    sini=sin(OElem[n][13]);
    cosi=cos(OElem[n][13]);
    XRotate2(&x,&y,&z,&sini,&cosi);

    //Rotate about the z-axis by Jupiter's node on the ecliptic
    sinomega=sin(pi+OElem[4][0]);
    cosomega=cos(pi+OElem[4][0]);
    ZRotate2(&x,&y,&z,&sinomega,&cosomega);

    //Rotate onto the plane of the ecliptic
    sini=-sin(OElem[4][1]); //Negative sine of inclination of Jupiter's orbit on the ecliptic
    cosi=cos(OElem[4][1]);  //Cosine of inclination of Jupiter's orbit on the ecliptic
    XRotate2(&x,&y,&z,&sini,&cosi);

    //Rotate towards the vernal equinox
    sinomega=-sin(OElem[4][0]);
    cosomega=cos(OElem[4][0]);
    ZRotate2(&x,&y,&z,&sinomega,&cosomega);

    //Convert ecliptic to earth equatorial (planetocentric) coordinates
    sini=-AL.sin_ecl;
    cosi=AL.cos_ecl;
    XRotate2(&x,&y,&z,&sini,&cosi);

    //Convert to true geocentric coordinates (centered on the earth)
    OElem[n][6]=OElem[4][6]+x*4.263523271e-5;
    OElem[n][7]=OElem[4][7]+y*4.263523271e-5;
    OElem[n][8]=OElem[4][8]+z*4.263523271e-5;

    //Convert to spherical coordinates
    arg=atan2(OElem[n][7],OElem[n][6]);
    FirstCircle2(&arg);
    OElem[n][9]=arg;
    OElem[n][10]=atan2(OElem[n][8],sqrt(OElem[n][6]*OElem[n][6]+OElem[n][7]*OElem[n][7]));
    OElem[n][11]=sqrt(OElem[n][6]*OElem[n][6]+OElem[n][7]*OElem[n][7]+OElem[n][8]*OElem[n][8]);
  }

  free_d_vector(X_,0,3);
  free_vector(X_f,0,3);
}
//---------------------------------------------------------------------------
//Determines the instantaneous planetary orbital elements for all
//solar system objects, T is the julian date
void GetOE(double *T)
{
  //Satelites of the Sun
  for (int i=0;i<PS.NSunSat;i++){GetOE_(i,T);}

  //Satelites of the Earth
  for (int i=100;i<PS.NEarSat+100;i++){GetOE_(i,T);}

  //Satelites of Mars
  for (int i=200;i<PS.NMarSat+200;i++){GetOE_(i,T);}

  //Satelites of Saturn
  for (int i=202;i<PS.NSatSat+202;i++){GetOE_(i,T);}

  //Satelites of Jupiter
  for (int i=209;i<PS.NJupSat+209;i++){GetOE_(i,T);}
}
//---------------------------------------------------------------------------
//Determine the instantaneous orbital elements of a solar system object
void GetOE_(int i, double *T)
{
  double d,arg;

  //Satelites of the Sun
  if (i<PS.NSunSat){
    d=*T-SSData[i].Epoch;
    for (int j=0;j<9;j++){
      if (j<6) OElem[i][j]=SSData[i].OE[j*2]+SSData[i].OE[j*2+1]*d;
      else OElem[i][j+6]=SSData[i].OE[j*2]+SSData[i].OE[j*2+1]*d;
      if (j!=3 && j!=4){
        //Return to a value between 0 and 2*pi
        arg=OElem[i][j];
        FirstCircle2(&arg);
        OElem[i][j]=arg;
      }
    }
    return;
  }

  //Satelites of the Earth
  if ((i>99)&&(i<100+PS.NEarSat)){
    d=*T-SSData[i].Epoch;
    for (int j=0;j<9;j++){
      if (j<6) OElem[i][j]=SSData[i].OE[j*2]+SSData[i].OE[j*2+1]*d;
      else OElem[i][j+6]=SSData[i].OE[j*2]+SSData[i].OE[j*2+1]*d;
      if (j!=3 && j!=4){
        //Return to a value between 0 and 2*pi
        arg=OElem[i][j];
        FirstCircle2(&arg);
        OElem[i][j]=arg;
      }
    }
    return;
  }

  //Satelites of Mars
  if ((i>199)&&(i<PS.NMarSat+200)){
    d=*T-SSData[i].Epoch;
    for (int j=0;j<9;j++){
      if (j<6) {
        OElem[i][j]=SSData[i].OE[j*2]+SSData[i].OE[j*2+1]*d;
      } else {
        if (j==6){
          //Mean longitude of the node of the Laplacian plane on EME of 1950.0
          OElem[i][12]=SSData[i].OE[12]+SSData[i].OE[13]*d+SSData[i].OE[16]*d*d;
        } else {
          //Mean inclination of the Laplacian plane to EME of 1950.0
          OElem[i][j+6]=SSData[i].OE[j*2]+SSData[i].OE[j*2+1]*d;
        }
      }
      if (j!=3 && j!=4){
        //Return to a value between 0 and 2*pi
        arg=OElem[i][j];
        FirstCircle2(&arg);
        OElem[i][j]=arg;
      }
    }
    //Convert mean longitude to mean anolmaly
    arg=OElem[i][5]-OElem[i][2]+SSData[200].OE[10];
    FirstCircle2(&arg);
    OElem[i][5]=arg;
    //Convert longitude of pericenter to argument of perihelion
    arg=OElem[i][2]-OElem[i][0];
    FirstCircle2(&arg);
    OElem[i][2]=arg;

    return;
  }

  //Satelites of Saturn. A separate theory is used for
  //each of the seven major satelites, Harper and Taylor
  //,Astron. Astrophy., 268, 326-349 (1993)).  Note also
  //that the orbital elements listed are different from those
  //used conventionally in this program. These elements are
  //later converted into the standard set (below) after
  //corrections for libration and other perturbations have
  //been made.
  float Ts,Ts2,l_s,lambda_s,i_s,Omega_s,Theta,Theta_,Ls,g;
  float i_,i_a,Omega_a,e;
  float N,P,L,L2,L4,P4,P6,N6,psi,t_;
  t_=1950.0+((*T-2433282.423)/365.2422)-1866.261;
  d=*T-SSData[202].Epoch;

  //Theory of Mimas
  if (i==202){
    psi=8.877791773e-2*t_;
    L=SSData[202].OE[10]+6.667061901*d-0.761574*sin(psi)-1.2566e-2*sin(3*psi)\
      -3.74198e-4*sin(5*psi);
    P=SSData[202].OE[4]+SSData[202].OE[5]*d;
    N=SSData[202].OE[0]+SSData[202].OE[1]*d;
    OElem[202][0]=N;
    OElem[202][1]=SSData[202].OE[2];
    OElem[202][2]=P-N;
    OElem[202][3]=SSData[202].OE[6];
    OElem[202][4]=SSData[202].OE[8];
    OElem[202][5]=L-P;
  }

  //Theory of Enceladus
  if (i==203){
    L2=SSData[203].OE[10]+4.585536714*d;
    L4=SSData[205].OE[10]+2.295717641*d;
    P4=SSData[205].OE[4]+SSData[205].OE[5]*d;
    L=L2+5.1836e-3*sin(1.5562e-3*d+5.48557)+3.64483e-3*sin(2*L4-L2-P4);
    P=2*L4-L2;
    N=SSData[203].OE[0]+SSData[203].OE[1]*d;
    OElem[203][0]=N;
    OElem[203][1]=SSData[203].OE[2];
    OElem[203][2]=P-N;
    OElem[203][3]=SSData[203].OE[6];
    OElem[203][4]=SSData[203].OE[8];
    OElem[203][5]=L-P;
  }

  //Theory of Tethys
  if (i==204){
    psi=8.877791773e-2*t_;
    L=SSData[204].OE[10]+3.328306439*d-0.09539*(-0.761574*sin(psi)\
      -1.2566e-2*sin(3*psi)-3.741986e-4*sin(5*psi));
    P=SSData[204].OE[4]+SSData[204].OE[5]*d;
    N=SSData[204].OE[0]+SSData[204].OE[1]*d;
    OElem[204][0]=N;
    OElem[204][1]=SSData[204].OE[2];
    OElem[204][2]=P-N;
    OElem[204][3]=SSData[204].OE[6];
    OElem[204][4]=SSData[204].OE[8];
    OElem[204][5]=L-P;
  }

  //Theory of Dione
  if (i==205){
    L=L4-4.573e-4*sin(1.556198e-3*d+5.4856)-3.0252e-4*sin(2*L4-L2-P4);
    N=SSData[205].OE[0]+SSData[205].OE[1]*d;
    OElem[205][0]=N;
    OElem[205][1]=SSData[205].OE[2];
    OElem[205][2]=P4-N;
    OElem[205][3]=SSData[205].OE[6];
    OElem[205][4]=SSData[205].OE[8];
    OElem[205][5]=L-P4;
  }

  //Theory of Rhea
  if (i==206){
    P6=SSData[207].OE[4]+SSData[207].OE[5]*d;
    N6=SSData[207].OE[0]-SSData[207].OE[1]*d;
    P=atan2(SSData[206].OE[8]*sin(SSData[206].OE[4]+4.80569e-4*d)+0.001*sin(P6),\
      SSData[206].OE[8]*cos(SSData[206].OE[4]+4.80569e-4*d)+0.001*cos(P6));
    L=SSData[206].OE[10]+1.390853699*d+0.2499333633*sin(SSData[206].OE[2])*sin(SSData[206].OE[0]-4.80569e-4*d);
    N=2.946655224+(sin(SSData[206].OE[8])*sin(SSData[206].OE[0]-4.80569e-4*d)+3.502876e-4*sin(N6))/0.470477553;
    OElem[206][0]=N;
    OElem[206][1]=0.4898318906-7.94125e-4*sin(SSData[206].OE[2])*cos(SSData[206].OE[0]-4.80569e-4*d)+3.50287e-4*cos(N6);
    OElem[206][2]=P-N;
    OElem[206][3]=SSData[206].OE[6];
    OElem[206][4]=SSData[206].OE[8];
    OElem[206][5]=L-P;
  }

  //Theory of Titan
  if (i==207){
    i_a=0.479003868+sin(SSData[207].OE[2])*cos(N6);
    Omega_a=2.944316343+2.125499917*sin(SSData[207].OE[2])*sin(N6);

    Ts=(*T-2415020.0)/36525;
    Ts2=Ts*Ts;
    l_s=3.062637449+21.32009566*Ts-8.727e-6*Ts2;
    lambda_s=4.664628045+21.32990615*Ts;
    i_s=0.04344367109+4.249877e-5*Ts-5.934e-7*Ts2;
    Omega_s=1.978329869-4.532253548e-3*Ts-6.632251158e-7*Ts2;

    psi=atan2(sin(i_s)*sin(Omega_a-Omega_s),cos(i_s)*sin(i_a)-sin(i_s)*cos(i_a)*cos(Omega_a-Omega_s));
    Theta_=atan2(sin(i_a)*sin(Omega_a-Omega_s),-sin(i_s)*cos(i_a)+cos(i_s)*sin(i_a)*cos(Omega_a-Omega_s));
    Theta=Theta_+Omega_s;
    Ls=lambda_s-(Theta-Omega_s)-Omega_s;
    g=P6-Omega_a-psi;

    L=SSData[207].OE[10]+0.3940425807*d\
      +0.2499333622*sin(SSData[207].OE[2])*sin(N6)\
      -0.0001757*sin(l_s)-0.0002151*sin(2*Ls)+0.0000567*sin(2*Ls+psi);
    e=SSData[207].OE[8]-0.0001841*cos(2*g)+0.0000731*cos(2*(Ls-g));
    N=P6+0.0063044*sin(2*g)+0.0025027*sin(2*(Ls-g));
    i_=i_a+0.0002320*cos(2*Ls+psi);
    N=Omega_a+0.0005034*sin(2*Ls+psi);
    OElem[207][0]=N;
    OElem[207][1]=i_;
    OElem[207][2]=P-N;
    OElem[207][3]=SSData[207].OE[6];
    OElem[207][4]=e;
    OElem[207][5]=L-P;
  }

  //Theory of Iapetus (most perturbations neglected)
  if (i==208){
    float a,d2,d3;
    d2=d*d;
    d3=d2*d;
    a=SSData[208].OE[6];
    L=SSData[208].OE[10]+7.920219759e-2*d;
    e=SSData[208].OE[8]+5.523889e-10*d;
    P=SSData[208].OE[4]+SSData[208].OE[5]*d;
    i_=SSData[208].OE[2]-4.8381817e-7*d-8.47758e-13*d2+1.934196e-18*d3;
    N=SSData[208].OE[0]+SSData[208].OE[1]*d+1.6615e-12*d2+2.865e-18*d3;
    OElem[208][0]=N;
    OElem[208][1]=i_;
    OElem[208][2]=P-N;
    OElem[208][3]=a;
    OElem[208][4]=e;
    OElem[208][5]=L-P;
  }

  //Satelites of Saturn, reference frame elements (mostly unused)
  if ((i>201)&&(i<PS.NSatSat+202)){
    d=*T-SSData[i].Epoch;
    for (int j=6;j<9;j++){
      OElem[i][j+6]=SSData[i].OE[j*2]+SSData[i].OE[j*2+1]*d;
      //Return to a value between 0 and 2*pi
      arg=OElem[i][j];
      FirstCircle2(&arg);
      OElem[i][j]=arg;
    }
    return;
  }

  //Satelites of Jupiter (Lieske's E1, from Jean Meeus)
  if ((i>208)&&(i<PS.NJupSat+209)){
    double l1, l2, l3, l4, p1, p2, p3, p4, w1, w2, w3, w4;
    double k, Gamma, Phi_l, psi, G, Gp, P;
    double S, L, tanB, r, T0, Ij, B;

    d=*T-2443000.5;
    k=pi/180.0;

    l1=(106.07719+203.488955790*d)*k;
    l2=(175.73161+101.374724735*d)*k;
    l3=(120.55883+50.317609207*d)*k;
    l4=(84.44459+21.571071177*d)*k;

    p1=(97.0881+0.16138586*d)*k;
    p2=(154.8663+0.04726307*d)*k;
    p3=(188.1840+0.00712734*d)*k;
    p4=(335.2868+0.00184000*d)*k;

    w1=(312.3346-0.13279386*d)*k;
    w2=(100.4411-0.03263064*d)*k;
    w3=(119.1942-0.00717703*d)*k;
    w4=(322.6186-0.00175934*d)*k;

    //Note that Gamma is in degrees, all other angles are in radians
    Gamma=0.33033*sin((163.679+0.0010512*d)*k)+0.03439*sin((34.486-0.0161731*d)*k);
    Phi_l=(199.6766+0.17379190*d)*k;
    psi=(316.5182-0.00000208*d)*k;
    G=(30.23756+0.0830925701*d+Gamma)*k;
    Gp=(31.97853+0.0334597339*d)*k;
    P=13.469942*k;

    //Theory of Io
    if (i==209){
      S=0.47259*sin(2*(l1-l2))-0.00186*sin(G);
      S+=-0.03478*sin(p3-p4)+0.00162*sin(p2-p3);
      S+=0.01081*sin(l2-2*l3+p3)+0.00158*sin(4*(l1-l2));
      S+=0.00738*sin(Phi_l)-0.00155*sin(l1-l3);
      S+=0.00713*sin(l2-2*l3+p2)-0.00138*sin(psi+w3-2*P-2*G);
      S+=-0.00674*sin(p1+p3-2*P-2*G)-0.00115*sin(2*(l1-2*l2+w2));
      S+=0.00666*sin(l2-2*l3+p4)+0.00089*sin(p2-p4);
      S+=0.00445*sin(l1-p3)+0.00085*sin(l1+p3-2*P-2*G);
      S+=-0.00354*sin(l1-l2)+0.00083*sin(w2-w3);
      S+=-0.00317*sin(2*psi-2*P)+0.00053*sin(psi-w2);
      S+=0.00265*sin(l1-p4);
      S=S*k;
      L=l1+S;
      tanB=0.0006393*sin(L-w1);
      tanB+=0.0001825*sin(L-w2);
      tanB+=0.0000329*sin(L-w3);
      tanB+=-0.0000311*sin(L-psi);
      tanB+=0.0000093*sin(L-w4);
      tanB+=0.0000075*sin(3*L-4*l2-1.9927*S+w2);
      tanB+=0.0000046*sin(L+psi-2*P-2*G);
      r=-0.0041339*cos(2*(l1-l2));
      r+=-0.0000387*cos(l1-p3);
      r+=-0.0000214*cos(l1-p4);
      r+=0.0000170*cos(l1-l2);
      r+=-0.0000131*cos(4*(l1-l2));
      r+=0.0000106*cos(l1-l3);
      r+=-0.0000066*cos(l1+p3-2*P-2*G);
    }

    //Theory of Europa
    if (i==210){
      S=1.06476*sin(2*(l2-l3))-0.00115*sin(l1-2*l3+p3);
      S+=0.04256*sin(l1-2*l2+p3)-0.00094*sin(2*(l2-w2));
      S+=0.03581*sin(l2-p3)+0.00086*sin(2*(l1-2*l2+w2));
      S+=0.02395*sin(l1-2*l2+p4)-0.00086*sin(5*Gp-2*G+52.225*k);
      S+=0.01984*sin(l2-p4)-0.00078*sin(l2-l4);
      S+=-0.01778*sin(Phi_l)-0.00064*sin(3*l3-7*l4+4*p4);
      S+=0.01654*sin(l2-p2)+0.00064*sin(p1-p4);
      S+=0.01334*sin(l2-2*l3+p2)-0.00063*sin(l1-2*l3+p4);
      S+=0.01294*sin(p3-p4)+0.00058*sin(w3-w4);
      S+=-0.01142*sin(l2-l3)+0.00056*sin(2*(psi-P-G));
      S+=-0.01057*sin(G)+0.00056*sin(2*(l2-l4));
      S+=-0.00775*sin(2*(psi-P))+0.00055*sin(2*(l1-l3));
      S+=0.00524*sin(2*(l1-l2))+0.00052*sin(3*l3-7*l4+p3+3*p4);
      S+=-0.00460*sin(l1-l3)-0.00043*sin(l1-p3);
      S+=0.00316*sin(psi-2*G+w3-2*P)+0.00041*sin(5*(l2-l3));
      S+=-0.00203*sin(p1+p3-2*P-2*G)+0.00041*sin(p4-P);
      S+=0.00146*sin(psi-w3)+0.00032*sin(w2-w3);
      S+=-0.00145*sin(2*G)+0.00032*sin(2*(l3-G-P));
      S+=0.00125*sin(psi-w4);
      S=S*k;
      L=l2+S;
      tanB=0.0081004*sin(L-w2);
      tanB+=0.0004512*sin(L-w3);
      tanB+=-0.0003284*sin(L-psi);
      tanB+=0.0001160*sin(L-w4);
      tanB+=0.0000272*sin(l1-2*l3+1.0146*S+w2);
      tanB+=-0.0000144*sin(L-w1);
      tanB+=0.0000143*sin(L+psi-2*P-2*G);
      tanB+=0.0000035*sin(L-psi+G);
      tanB+=-0.0000028*sin(l1-2*l3+1.0146*S+w3);
      r=0.0093848*cos(l1-l2);
      r+=-0.0003116*cos(l2-p3);
      r+=-0.0001744*cos(l2-p4);
      r+=-0.0001442*cos(l2-p2);
      r+=0.0000553*cos(l2-l3);
      r+=0.0000523*cos(l1-l3);
      r+=-0.0000290*cos(2*(l1-l2));
      r+=0.0000164*cos(2*(l2-w2));
      r+=0.0000107*cos(l1-2*l3+p3);
      r+=-0.0000102*cos(l2-p1);
      r+=-0.0000091*cos(2*(l1-l3));
    }

    //Theory of Ganymede
    if (i==211){
      S=0.16490*sin(l3-p3)+0.00091*sin(w3-w4);
      S+=0.09081*sin(l3-p4)+0.00080*sin(3*l3-7*l4+p3+3*p4);
      S+=-0.06907*sin(l2-l3)-0.00075*sin(2*l2-3*l3+p3);
      S+=0.03784*sin(p3-p4)+0.00072*sin(p1+p3-2*P-2*G);
      S+=0.01846*sin(2*(l3-l4))+0.00069*sin(p4-P);
      S+=-0.01340*sin(G)-0.00058*sin(2*l3-3*l4+p4);
      S+=-0.01014*sin(2*(psi-P))-0.00057*sin(l3-2*l4+p4);
      S+=0.00704*sin(l2-2*l3+p3)+0.00056*sin(l3+p3-2*P-2*G);
      S+=-0.00620*sin(l2-2*l3+p2)-0.00052*sin(l2-2*l3+p1);
      S+=-0.00541*sin(l3-l4)-0.00050*sin(p2-p3);
      S+=0.00381*sin(l2-2*l3+p4)+0.00048*sin(l3-2*l4+p3);
      S+=0.00235*sin(psi-w3)-0.00045*sin(2*l2-3*l3+p4);
      S+=0.00198*sin(psi-w4)-0.00041*sin(p2-p4);
      S+=0.00176*sin(Phi_l)-0.00038*sin(2*G);
      S+=0.00130*sin(3*(l3-l4))-0.00037*sin(p3-p4+w3-w4);
      S+=0.00125*sin(l1-l3)-0.00032*sin(3*l3-7*l4+2*p3+2*p4);
      S+=-0.00119*sin(5*Gp-2*G+52.225*k)+0.00030*sin(4*(l3-l4));
      S+=0.00109*sin(l1-l2)+0.00029*sin(l3+p4-2*P-2*G);
      S+=-0.00100*sin(3*l3-7*l4+4*p4)-0.00028*sin(w3+psi-2*P-2*G);
      S+=0.00026*sin(l3-P-G)-0.00021*sin(l3-p2);
      S+=0.00024*sin(l2-3*l3+2*l4)+0.00017*sin(2*(l3-p3));
      S+=0.00021*sin(2*(l3-P-G));
      S=S*k;
      L=l3+S;
      tanB=0.0032402*sin(L-w3);
      tanB+=-0.0016911*sin(L-psi);
      tanB+=0.0006847*sin(L-w4);
      tanB+=-0.0002797*sin(L-w2);
      tanB+=0.0000321*sin(L+psi-2*P-2*G);
      tanB+=0.0000051*sin(L-psi+G);
      tanB+=-0.0000045*sin(L-psi-G);
      tanB+=-0.0000045*sin(L+psi-2*P);
      tanB+=0.0000037*sin(L+psi-2*P-3*G);
      tanB+=0.0000030*sin(2*l2-3*L+4.03*S+w2);
      tanB+=-0.0000021*sin(2*l2-3*L+4.03*S+w3);
      r=-0.0014388*cos(l3-p3);
      r+=-0.0007919*cos(l3-p4);
      r+=0.0006342*cos(l2-l3);
      r+=-0.0001761*cos(2*(l3-l4));
      r+=0.0000294*cos(l3-l4);
      r+=-0.0000156*cos(3*(l3-l4));
      r+=0.0000156*cos(l1-l3);
      r+=-0.0000153*cos(l1-l2);
      r+=0.0000070*cos(2*l2-3*l3+p3);
      r+=-0.0000051*cos(l3+p3-2*P-2*G);
    }

    //Theory of Callisto
    if (i==212){
      S=0.84287*sin(l4-p4)+0.00061*sin(l1-l4);
      S+=0.03431*sin(p4-p3)-0.00056*sin(psi-w3);
      S+=-0.03305*sin(2*(psi-P))-0.00054*sin(l3-2*l4+p3);
      S+=-0.03211*sin(G)+0.00051*sin(l2-l4);
      S+=-0.01862*sin(l4-p3)+0.00042*sin(2*(psi-G-P));
      S+=0.01186*sin(psi-w4)+0.00039*sin(2*(p4-w4));
      S+=0.00623*sin(l4+p4-2*G-2*P)+0.00036*sin(psi+P-p4-w4);
      S+=0.00387*sin(2*(l4-p4))+0.00035*sin(2*Gp-G+188.37*k);
      S+=-0.00284*sin(5*Gp-2*G+52.225*k)-0.00035*sin(l4-p4+2*P-2*psi);
      S+=-0.00234*sin(2*(psi-p4))-0.00032*sin(l4+p4-2*P-G);
      S+=-0.00223*sin(l3-l4)+0.00030*sin(2*Gp-2*G+149.15*k);
      S+=-0.00208*sin(l4-P)+0.00029*sin(3*l3-7*l4+2*p3+2*p4);
      S+=0.00178*sin(psi+w4-2*p4)+0.00028*sin(l4-p4+2*psi-2*P);
      S+=0.00134*sin(p4-P)-0.00028*sin(2*(l4-w4));
      S+=0.00125*sin(2*(l4-G-P))-0.00027*sin(p3-p4+w3-w4);
      S+=-0.00117*sin(2*G)-0.00026*sin(5*Gp-3*G+188.37*k);
      S+=-0.00112*sin(2*(l3-l4))+0.00025*sin(w4-w3);
      S+=0.00107*sin(3*l3-7*l4+4*p4)-0.00025*sin(l2-3*l3+2*l4);
      S+=0.00102*sin(l4-G-P)-0.00023*sin(3*(l3-l4));
      S+=0.00096*sin(2*l4-psi-w4)+0.00021*sin(2*l4-2*P-3*G);
      S+=0.00087*sin(2*(psi-w4))-0.00021*sin(2*l3-3*l4+p4);
      S+=-0.00085*sin(3*l3-7*l4+p3+3*p4)+0.00019*sin(l4-p4-G);
      S+=0.00085*sin(l3-2*l4+p4)-0.00019*sin(2*l4-p3-p4);
      S+=-0.00081*sin(2*(l4-psi))-0.00018*sin(l4-p4+G);
      S+=0.00071*sin(l4+p4-2*P-3*G)-0.00016*sin(l4+p3-2*P-2*G);
      S=S*k;
      L=l4+S;
      tanB=-0.0076579*sin(L-psi);
      tanB+=0.0044134*sin(L-w4);
      tanB+=-0.0005112*sin(L-w3);
      tanB+=0.0000773*sin(L+psi-2*P-2*G);
      tanB+=0.0000104*sin(L-psi+G);
      tanB+=-0.0000102*sin(L-psi-G);
      tanB+=0.0000088*sin(L+psi-2*P-3*G);
      tanB+=-0.0000038*sin(L+psi-2*P-G);
      r=-0.0073546*cos(l4-p4);
      r+=0.0001621*cos(l4-p3);
      r+=0.0000974*cos(l3-l4);
      r+=-0.0000543*cos(l4+p4-2*P-2*G);
      r+=-0.0000271*cos(2*(l4-p4));
      r+=0.0000182*cos(l4-P);
      r+=0.0000177*cos(2*(l3-l4));
      r+=-0.0000167*cos(2*l4-psi-w4);
      r+=0.0000167*cos(psi-w4);
      r+=-0.0000155*cos(2*(l4-P-G));
      r+=0.0000142*cos(2*(l4-psi));
      r+=0.0000105*cos(l1-l4);
      r+=0.0000092*cos(l2-l4);
      r+=-0.0000089*cos(l4-P-G);
      r+=-0.0000062*cos(l4+p4-2*P-3*G);
      r+=0.0000048*cos(2*(l4-w4));
    }

    //Correction for precession of jupiter's equinox
    T0=(*T-2433282.423)/36525;
    P=(1.3966626*T0+0.0003088*T0*T0)*k;
    L+=P;
    psi+=P;

    //Jupiter's inclination on its orbital plane
    OElem[i][13]=(3.120262+0.0006*(*T-2415019.5)/36525)*k;

    //Longitude of the node of the equator of Jupiter on the ecliptic
    OElem[i][12]=psi;

    OElem[i][9]=L;
    OElem[i][10]=atan(tanB);
    OElem[i][11]=(r+1)*SSData[i].OE[6];

    //Convert to rectangular coordinates
    OElem[i][6]=OElem[i][11]*cos(OElem[i][9])*cos(OElem[i][10]);
    OElem[i][7]=OElem[i][11]*sin(OElem[i][9])*cos(OElem[i][10]);
    OElem[i][8]=OElem[i][11]*sin(OElem[i][10]);
  }
}
//---------------------------------------------------------------------------
//Convert planetocentric coordinates to geocentric equatorial coordinates
//and return the longitude/latitude difference between the center of the
//planet (geocentric).  Based on theory and rotational elements presented
//in 2001 Astronomical Almanac.
//Returns true if the coordinate is on the earth-side half of the planet.
bool PlanetToGeoCoord(int *N, double *r, double *T, double *lambda,
  double *phi, double *dalpha, double *ddelta,bool Initialize)
{
  static double cosBeta_e,sinBeta_e,cosdelta,cosdelta1,sindelta;
  static double sindelta1,sindalpha,cosdalpha, lambda_e, sinpn, cospn;
  static double xe,ye,ze;
  double X,Y,dlambda,cosphi,sinphi,x,y,z,vdot;

  if (Initialize){
    double K, K2, W1;
    cosdelta=cos(OElem[*N][10]);
    sindelta=sin(OElem[*N][10]);
    cosdelta1=cos(SSData[*N].OE[14]);
    sindelta1=sin(SSData[*N].OE[14]);
    sindalpha=sin(SSData[*N].OE[12]-OElem[*N][9]);
    cosdalpha=cos(SSData[*N].OE[12]-OElem[*N][9]);
    sinBeta_e=-sindelta1*sindelta-cosdelta1*cosdelta*cosdalpha;
    cosBeta_e=sqrt(1-sinBeta_e*sinBeta_e);
    W1=SSData[*N].OE[16]+SSData[*N].OE[17]*(*T-SSData[*N].Epoch-0.0057755*OElem[*N][11]);

    sinpn=cosdelta1*sindalpha/cosBeta_e;
    cospn=(sindelta1*cosdelta-cosdelta1*sindelta*cosdalpha)/cosBeta_e;

    K=acos(cosdelta*sindalpha/cosBeta_e);
    K2=asin((-cosdelta1*sindelta+sindelta1*cosdelta*cosdalpha)/cosBeta_e);
    if (K2<0) K=twopi-K;

    if (SSData[*N].OE[17]>0) lambda_e=W1-K;
    else lambda_e=K-W1;

    xe=cosBeta_e*cos(lambda_e);
    ye=cosBeta_e*sin(lambda_e);
    ze=sinBeta_e;
    return true;
  }

  dlambda=*lambda-lambda_e;
  cosphi=cos(*phi);
  sinphi=sin(*phi);
  if (SSData[*N].OE[17]>0) X=(*r)*cosphi*sin(dlambda);
  else X=-(*r)*cosphi*sin(dlambda);
  Y=(*r)*(sin(*phi)*cosBeta_e-cosphi*sinBeta_e*cos(dlambda));

  *dalpha=-(X*cospn+Y*sinpn);
  *ddelta=(-X*sinpn+Y*cospn);

  //Determine whether the planetographic coordinate point is
  //visible from earth
  x=cosphi*cos(*lambda);
  y=cosphi*sin(*lambda);
  z=sinphi;
  vdot=x*xe+y*ye+z*ze;

  if (vdot>0) return true;
  else return false;
}
//---------------------------------------------------------------------------
//Loads the Orbital Elements of solar system objects
void LoadOElem(AnsiString filename)
{
  int i,n;
  char buf[128];
  String sbuf;

  //Explanation of symbols used in OElem data file and
  //correspondence with the orbital elements array OE.
  //The OElem file uses units of degrees for angle, days
  //for time, A.U. for solar satelite orbit semi-major axes,
  //and earth radii for all other orbit semi-major axes.
  //The OE array uses the same units except that radians are
  //used for angles.
  //
  //SSData[i].OE[0] = Longitude of the ascending node, N.
  //SSData[i].OE[1] = Ascending node rate, N~.
  //SSData[i].OE[2] = Inclination of the ecliptic, i.
  //SSData[i].OE[3] = Inclination rate, i~.
  //SSData[i].OE[4] = Argument of perihelion, w, or in some
  //                  cases longitude of the pericenter, P
  //SSData[i].OE[5] = w, or P rate; w~ or P~.
  //SSData[i].OE[6] = Semi-major axis of the orbit, a.
  //SSData[i].OE[7] = Semi-major axis rate, a~.
  //SSData[i].OE[8] = Eccentricity, e.
  //SSData[i].OE[9] = Eccentricity rate, e~.
  //SSData[i].OE[10] = Mean anomaly, M, or in some cases
  //                  the mean longitude, L.
  //SSData[i].OE[11] = M, or L rate, M~ or L~.
  //SSData[i].OE[12] = Node of the reference plane to which the
  //                   object coordinates are referenced, n.
  //                   Usually this is the node of the planet equator
  //                   relative to the ecliptic or earth's equator.
  //                   Or in the case of planets, the right
  //                   ascension of the north pole, alpha_1 (in the Astronomical Almanac).
  //SSData[i].OE[13] = Rate of the above, n~ or l~.
  //SSData[i].OE[14] = Inclination of the reference plane, j.
  //                   Or in the case of the planets, the
  //                   declination of the north pole, delta (in the Astronomical Almanac).
  //SSData[i].OE[15] = Rate of the above, j~ or d~.
  //SSData[i].OE[16] = Argument of the prime meridian, W, W_0 (in the Astronomical Almanac).
  //                   For mars, this is the secular rate of the longitude, LA
  //SSData[i].OE[17] = Rate of the above, W~, W_dot (in the Astronomical Almanac).
  //SSData[i].OE[18] = Equatorial radius in A.U, r.

  //Open the file for input
  FILE *infile;
  if (!FileExists(filename)) {
    String osbuf = "Could not open file " + filename;
    Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    return;
  }
  infile=fopen(filename.c_str(),"rt");
  fseek(infile, 0, SEEK_SET);

  //Read in the satelites of the sun
  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  n=sbuf.SubString(18,sbuf.Length()-17).Trim().ToInt();
  PS.NSunSat=n;
  //Skip a line
  fgets(buf,sizeof(buf),infile);

  for (i=0;i<n;i++) {
    //Get the planet name
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].Name=sbuf.SubString(6,sbuf.Length()-5).Trim();
    //Get the symbol class relevant for the object
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].SymbClass=sbuf.SubString(11,sbuf.Length()-10).Trim().ToInt();
    //Get the Epoch of the orbital elements (Julian date)
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].Epoch=sbuf.SubString(7,sbuf.Length()-6).Trim().ToDouble();
    //Get the orbital elements
    for (int j=0;j<19;j++){
      fgets(buf,sizeof(buf),infile);
      sbuf=buf;
      if (j!=6&&j!=7&&j!=8&&j!=9&&j!=18){
        SSData[i].OE[j]=(sbuf.SubString(4,sbuf.Length()-3).Trim().ToDouble())*pi/180;
      } else {
        SSData[i].OE[j]=sbuf.SubString(4,sbuf.Length()-3).Trim().ToDouble();
      }
    }
    //Skip a line
    fgets(buf,sizeof(buf),infile);
  }

  //Read in satelites of earth
  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  n=sbuf.SubString(20,sbuf.Length()-19).Trim().ToInt();
  PS.NEarSat=n;
  //Skip a line
  fgets(buf,sizeof(buf),infile);

  for (i=100;i<n+100;i++) {
    //Get the satelite name
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].Name=sbuf.SubString(6,sbuf.Length()-5).Trim();
    //Get the symbol class relevant for the object
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].SymbClass=sbuf.SubString(11,sbuf.Length()-10).Trim().ToInt();
    //Get the Epoch of the orbital elements (Julian date)
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].Epoch=sbuf.SubString(7,sbuf.Length()-6).Trim().ToDouble();
    //Get the orbital elements
    for (int j=0;j<18;j++){
      fgets(buf,sizeof(buf),infile);
      sbuf=buf;
      if (j!=6&&j!=7&&j!=8&&j!=9){
        SSData[i].OE[j]=(sbuf.SubString(4,sbuf.Length()-3).Trim().ToDouble())*pi/180;
      } else {
        SSData[i].OE[j]=sbuf.SubString(4,sbuf.Length()-3).Trim().ToDouble();
      }
    }
    //Get the satelite radius
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].OE[18]=sbuf.SubString(4,sbuf.Length()-3).Trim().ToDouble();
    //Skip a line
    fgets(buf,sizeof(buf),infile);
  }

  //Read in satelites of mars (2 maximum)
  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  n=sbuf.SubString(19,sbuf.Length()-18).Trim().ToInt();
  PS.NMarSat=n;
  //Skip a line
  fgets(buf,sizeof(buf),infile);

  for (i=200;i<n+200;i++) {
    //Get the satelite name
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].Name=sbuf.SubString(6,sbuf.Length()-5).Trim();
    //Get the symbol class relevant for the object
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].SymbClass=sbuf.SubString(11,sbuf.Length()-10).Trim().ToInt();
    //Get the Epoch of the orbital elements (Julian date)
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].Epoch=sbuf.SubString(7,sbuf.Length()-6).Trim().ToDouble();
    //Get the orbital elements
    for (int j=0;j<18;j++){
      fgets(buf,sizeof(buf),infile);
      sbuf=buf;
      if (j!=6&&j!=7&&j!=8&&j!=9){
        SSData[i].OE[j]=(sbuf.SubString(4,sbuf.Length()-3).Trim().ToDouble())*pi/180;
      } else {
        SSData[i].OE[j]=sbuf.SubString(4,sbuf.Length()-3).Trim().ToDouble();
      }
    }
    //Get the radius
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].OE[18]=sbuf.SubString(4,sbuf.Length()-3).Trim().ToDouble();
    //Skip a line
    fgets(buf,sizeof(buf),infile);
  }

  //Read in satelites of saturn (7 maximum)
  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  n=sbuf.SubString(21,sbuf.Length()-20).Trim().ToInt();
  PS.NSatSat=n;
  //Skip a line
  fgets(buf,sizeof(buf),infile);

  for (i=202;i<n+202;i++) {
    //Get the satelite name
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].Name=sbuf.SubString(6,sbuf.Length()-5).Trim();
    //Get the symbol class relevant for the object
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].SymbClass=sbuf.SubString(11,sbuf.Length()-10).Trim().ToInt();
    //Get the Epoch of the orbital elements (Julian date)
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].Epoch=sbuf.SubString(7,sbuf.Length()-6).Trim().ToDouble();
    //Get the orbital elements
    for (int j=0;j<18;j++){
      fgets(buf,sizeof(buf),infile);
      sbuf=buf;
      if (j!=6&&j!=7&&j!=8&&j!=9){
        SSData[i].OE[j]=(sbuf.SubString(4,sbuf.Length()-3).Trim().ToDouble())*pi/180;
      } else {
        SSData[i].OE[j]=sbuf.SubString(4,sbuf.Length()-3).Trim().ToDouble();
      }
    }
    //Get the radius
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].OE[18]=sbuf.SubString(4,sbuf.Length()-3).Trim().ToDouble();
    //Skip a line
    fgets(buf,sizeof(buf),infile);
  }

  //Read in satelites of jupiter (4 maximum)
  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  n=sbuf.SubString(22,sbuf.Length()-21).Trim().ToInt();
  PS.NJupSat=n;
  //Skip a line
  fgets(buf,sizeof(buf),infile);

  for (i=209;i<n+209;i++) {
    //Get the satelite name
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].Name=sbuf.SubString(6,sbuf.Length()-5).Trim();
    //Get the symbol class relevant for the object
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].SymbClass=sbuf.SubString(11,sbuf.Length()-10).Trim().ToInt();
    //Get the Epoch of the orbital elements (Julian date)
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].Epoch=sbuf.SubString(7,sbuf.Length()-6).Trim().ToDouble();
    //Get the orbital elements
    for (int j=0;j<18;j++){
      fgets(buf,sizeof(buf),infile);
      sbuf=buf;
      if (j!=6&&j!=7&&j!=8&&j!=9){
        SSData[i].OE[j]=(sbuf.SubString(4,sbuf.Length()-3).Trim().ToDouble())*pi/180;
      } else {
        SSData[i].OE[j]=sbuf.SubString(4,sbuf.Length()-3).Trim().ToDouble();
      }
    }
    //Get the radius
    fgets(buf,sizeof(buf),infile);
    sbuf=buf;
    SSData[i].OE[18]=sbuf.SubString(4,sbuf.Length()-3).Trim().ToDouble();
    //Skip a line
    fgets(buf,sizeof(buf),infile);
  }

  fclose(infile);
}
//---------------------------------------------------------------------------
//Get the obliquity of the earth's axis at Julian date T
void GetObliquity(double *T)
{
  double ecl,t1,t2;
  t1=*T-2415019;
  t2=t1*t1;
  ecl=0.4093197552-(6.217295775e-9)*t1-(1.453631779e-17)*t2+(1.790922110e-22)*t2*t1;
  AL.sin_ecl=sin(ecl);
  AL.cos_ecl=cos(ecl);
}
//---------------------------------------------------------------------------
//Determine the illuminated fraction of the planet or moon's disk and provides
//the visual magnitude
void Illumination(int n, double *k, double *mag)
{
  double i, R_, d;

  R_=OElem[0][11];

  if (n==100){
    //Earth's moon
    double psi;
    psi=acos(sin(OElem[0][10])*sin(OElem[n][10])+cos(OElem[0][10])*cos(OElem[n][10])*cos(OElem[0][9]-OElem[n][9]));
    d=OElem[n][11]*4.263429e-5;
    i=atan(R_*sin(psi)/(d-R_*cos(psi)));
    if (i<0) i+=pi;
    *k=(1+cos(i))/2;
    *mag=-20;
  } else {
    //Planet disk
    double r, dr, x, y, z;
    x=OElem[n][6]-OElem[0][6];
    y=OElem[n][7]-OElem[0][7];
    z=OElem[n][8]-OElem[0][8];
    d=sqrt(x*x+y*y+z*z);
    r=OElem[n][11];
    dr=r+d;
    *k=(dr*dr-R_*R_)/(4*r*d);
    i=acos(2*(*k)-1)*180.0/pi;

    //Mercury
    if (n==1) *mag=1.16+5*log10(r*d)+0.02838*(i-50)+0.0001023*(i-50)*(i-50);
    //Venus
    if (n==2) *mag=-4.00+5*log10(r*d)+0.01322*i+0.0000004247*i*i*i;
    //Mars
    if (n==3) *mag=-1.3+5*log10(r*d)+0.01486*i;
    //Jupiter
    if (n==4) *mag=-8.93+5*log10(r*d);
    //Saturn
    if (n==5) *mag=-8.68+5*log10(r*d);
    //Uranus
    if (n==6) *mag=-6.85+5*log10(r*d);
    //Neptune
    if (n==7) *mag=-7.05+5*log10(r*d);
    //Pluto
    if (n>7) *mag=13.8;
  }
}
//---------------------------------------------------------------------------
//Rotates a rectangular coordinate about the x-axis (double precision)
void XRotate2(double *x,double *y,double *z,double *sinangle,double *cosangle)
{
  double y0=*y;
  *y=(*sinangle)*(*z)+(*cosangle)*y0;
  *z=(*cosangle)*(*z)-(*sinangle)*y0;
}
//---------------------------------------------------------------------------
//Rotates a rectangular coordinate about the y-axis (double precision)
void YRotate2(double *x,double *y,double *z,double *sinangle,double *cosangle)
{
  double x0=*x;
  *x=(*cosangle)*x0-(*sinangle)*(*z);
  *z=(*sinangle)*x0+(*cosangle)*(*z);
}
//---------------------------------------------------------------------------
//Rotates a rectangular coordinate about the z-axis (double precision)
void ZRotate2(double *x,double *y,double *z,double *sinangle,double *cosangle)
{
  double x0=*x;
  *x=(*sinangle)*(*y)+(*cosangle)*x0;
  *y=(*cosangle)*(*y)-(*sinangle)*x0;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//Map Projection Routines
//---------------------------------------------------------------------------
//Returns the screen direction cosines (x,y) of a sky coordinate (lambda,q)
//If the point is not hidden by other parts of the map then the function
//returns "true".  Force calculation forces the calculation of points even
//if they are below the horizon
bool SkyToScreen(float *q,float *lambda,int *x1,int *y1,float *R0,int *w2,int *h2,bool force_calculation)
{
  bool proceed=true;

  //Make sure that things below the horizon are not drawn when
  //the horizon mask is on
  if (PS.HorizonMask){
    float azimuth=0, elevation=0;
    float lambda1=*lambda,q1=*q;
    EquToHor(&lambda1,&q1,&azimuth,&elevation,AL.l_ori);
    if (AL.lat<0) elevation=-elevation;
    if (elevation<-1e-6) proceed=false;
  }

  if (proceed||force_calculation){
    float lambda_,cosa,sina;
    float *X1,x,y;
    X1=vector(0,2);

    //Subtract the sidereal time
    lambda_=*lambda-AL.l_ori+pihalved;
    FirstCircle(&lambda_);
    X1[0]=1; X1[1]=*q; X1[2]=lambda_;

    //Convert equatorial sky angles to rectangular direction
    //cosines
    SphToCosines(X1);

    //Rotate about x-axis by the latitude angle
    XRotate(X1,&(AL.sin_lat),&(AL.cos_lat));

    //Rotate about the y-axis by the negative azimuth angle +pi
    cosa=-AL.cos_azim;
    sina=AL.sin_azim;
    YRotate(X1,&sina,&cosa);

    //Rotate about the x-axis by the negative of the elevation angle
    if (PS.Projection!=3) {
      sina=-AL.sini;
      XRotate(X1,&sina,&(AL.cosi));
    } else {
      //...except when using the Mercator projection
      cosa=AL.cosi;
      sina=-AL.sini;
      XRotate(X1,&cosa,&sina);
    }

    if (PS.Projection==3) Mercator(X1,&x,&y);
    if (PS.Projection==2) Planar(X1,&x,&y);
    if (PS.Projection==1) Lambert(X1,&x,&y);
    if (PS.Projection==0) { //Stereographic
      x=-X1[0]/2;
      y=X1[1]/2;
    }
    *x1=*w2+x*(*R0);
    *y1=*h2-y*(*R0);

    //Make sure "hidden" areas of the hemisphere are not drawn
    if ((X1[2]>0)||(PS.Projection==3)) proceed=true;
    else proceed=false;

    //Check that the point is within screen bounds
    if ((*x1<0)||(*x1>(*w2)*2)||(*y1<0)||(*y1>(*h2)*2)) proceed=false;

    free_vector(X1,0,2);
  }
  return proceed;
}
//---------------------------------------------------------------------------
//Returns the sky coordinate (lambda,q) of a screen coordinate (x,y)
void ScreenToSky(int *x,int *y,float *q,float *lambda,float *R0,int *w2,int *h2)
{
  float cosa,sina,arg,*X1;
  X1=vector(0,2);
  X1[0]=(*x-*w2)/(*R0);
  X1[1]=(*h2-*y)/(*R0);
  if (PS.Projection==0){
    X1[0]=-X1[0]*2;
    X1[1]=X1[1]*2;
  } else {
    if (PS.Projection!=1){
      X1[0]=X1[0]*2;
      X1[1]=X1[1]*2;
    }
  }
  arg=1-X1[0]*X1[0]-X1[1]*X1[1];
  if (arg>0) X1[2]=sqrt(arg);
  else X1[2]=0;

  //Get the rectangular coordinates prior to the projection transform
  if (PS.Projection==3) InverseMercator(X1);
  if (PS.Projection==2) InversePlanar(X1);
  if (PS.Projection==1) InverseLambert(X1);

  //Rotate about the x-axis by the elevation angle
  if (PS.Projection!=3){
    XRotate(X1,&(AL.sini),&(AL.cosi));
  } else {
    //Case for Mercator projection
    XRotate(X1,&AL.cosi,&AL.sini);
  }

  //Rotate about the y-axis by the the azimuth angle +pi
  cosa=-AL.cos_azim;
  sina=-AL.sin_azim;
  YRotate(X1,&sina,&cosa);

  //Rotate about x-axis by the negative of the latitude angle
  cosa=AL.cos_lat;
  sina=-AL.sin_lat;
  XRotate(X1,&sina,&cosa);

  //Convert to spherical coordinates
  CosinesToSph(X1);

  //Add the sidereal time
  X1[2]=AL.l_ori+X1[2]-pihalved;
  *lambda=X1[2];
  FirstCircle(lambda);
  *q=X1[1];

  free_vector(X1,0,2);
}
//---------------------------------------------------------------------------
//Converts spherical coordinate angles to rectangular cosines
void SphToCosines(float *X)
{
  float cosq,sinq;
  cosq=cos(X[1]);
  sinq=sin(X[1]);
  X[0]=cosq*cos(X[2]);
  X[1]=cosq*sin(X[2]);
  X[2]=sinq;
}
//---------------------------------------------------------------------------
//Converts spherical coordinate angles to rectangular cosines
//Double precision version
void SphToCosines2(double *X)
{
  double cosq,sinq,r;
  r=X[0];
  cosq=r*cos(X[1]);
  sinq=r*sin(X[1]);
  X[0]=cosq*cos(X[2]);
  X[1]=cosq*sin(X[2]);
  X[2]=sinq;
}
//---------------------------------------------------------------------------
//Rotates a rectangular coordinate X about the x-axis
void XRotate(float *X,float *sinangle,float *cosangle)
{
  float x1=X[1];
  X[1]=(*sinangle)*X[2]+(*cosangle)*x1;
  X[2]=(*cosangle)*X[2]-(*sinangle)*x1;
}
//---------------------------------------------------------------------------
//Rotates a rectangular coordinate X about the z-axis
void ZRotate(float *X,float *sinangle,float *cosangle)
{
  float x0=X[0];
  X[0]=(*sinangle)*X[1]+(*cosangle)*x0;
  X[1]=(*cosangle)*X[1]-(*sinangle)*x0;
}
//---------------------------------------------------------------------------
//Rotates a rectangular coordinate X about the y-axis
void YRotate(float *X,float *sinangle,float *cosangle)
{
  float x0=X[0];
  X[0]=(*cosangle)*x0-(*sinangle)*X[2];
  X[2]=(*sinangle)*x0+(*cosangle)*X[2];
}
//---------------------------------------------------------------------------
//Provides projection for Planar mapping
void Planar(float *X1,float *x,float *y)
{
  float R,arg,q,cosq,coslambda,sinlambda;
  if (X1[2]>1) X1[2]=1;
  if (X1[2]<-1) X1[2]=-1;
  q=asin(X1[2]);
  cosq=cos(q);
  arg=pihalved-q;
  if (arg==pihalved||arg==threepihalved) arg+=1e-7;
  R=tan(arg)/2;
  coslambda=X1[0]/cosq;
  sinlambda=X1[1]/cosq;
  *x=-R*coslambda;
  *y=R*sinlambda;
}
//---------------------------------------------------------------------------
//Provides projection for Lambert mapping
void Lambert(float *X1,float *x,float *y)
{
  float R,arg,q,cosq,sinlambda,coslambda;
  if (X1[2]>1) X1[2]=1;
  if (X1[2]<-1) X1[2]=-1;
  q=asin(X1[2]);
  cosq=cos(q);
  sinlambda=X1[1]/cosq;
  coslambda=X1[0]/cosq;
  arg=(pihalved-q)/2;
  if (arg==pihalved||arg==threepihalved) arg=pihalved-1e-7;
  R=tan(arg);
  *x=-R*coslambda;
  *y=R*sinlambda;
}
//---------------------------------------------------------------------------
//Provides projection for Mercator mapping
void Mercator(float *X1,float *x,float *y)
{
  float U,q,lambda,arg;
  if (X1[2]>1) X1[2]=1;
  if (X1[2]<-1) X1[2]=-1;
  q=asin(X1[2]);
  if (X1[1]==0) X1[1]=1e-8;
  lambda=atan(X1[0]/X1[1]);
  if (X1[1]<0) lambda+=pi;
  arg=(pihalved-q)/2;
  if (arg==pihalved||arg==threepihalved) arg+=1e-7;
  U=tan(arg);
  if (U!=0) *y=log(U)/2;
  else *y=1000;
  if (lambda<pi) *x=-lambda/2;
  else *x=pi-lambda/2;
}
//---------------------------------------------------------------------------
//Converts horizon coordinates to equatorial sky coordinates
void HorToEqu(float *h,float *Az,float *q,float *lambda)
{
  float *M,sinlat,coslat;
  M=vector(0,2);
  M[0]=cos(*h)*sin(*Az);
  M[1]=cos(*h)*cos(*Az);
  M[2]=sin(*h);

  //Rotate about x-axis by the complement of the latitude
  sinlat=AL.sin_lat;
  coslat=AL.cos_lat;
  XRotate(M,&coslat,&sinlat);

  //Convert to spherical coordinates
  CosinesToSph(M);
  *q=M[1];
  *lambda=M[2]+AL.l_ori-pihalved;  //Add the sidereal time
  FirstCircle(lambda);

  free_vector(M,0,2);
}
//---------------------------------------------------------------------------
//Converts rectangular cosines to spherical coordinate angles
void CosinesToSph(float *X)
{
  float q,cosq,lambda,arg;
  if (X[2]>1) X[2]=1;
  if (X[2]<-1) X[2]=-1;
  q=asin(X[2]);
  cosq=cos(q);
  if (cosq!=0) {
    arg=X[1]/cosq;
    if (arg>1) arg=1;
    if (arg<-1) arg=-1;
    lambda=asin(arg);
  } else {
    lambda=pihalved;
  }
  if (X[0]<0) lambda=pi-lambda;
  X[0]=1;
  X[1]=q;
  X[2]=lambda;
}
//---------------------------------------------------------------------------
//Provides inverse projection for Planar mapping
void InversePlanar(float *X)
{
  float arg,q,cosq,sinlambda,lambda;
  if (X[0]==0) X[0]=1e-8;
  lambda=atan(-X[1]/X[0]);
  sinlambda=sin(lambda);
  if (sinlambda==0) sinlambda=1e-8;
  arg=atan(X[1]/sinlambda);
  q=pihalved-arg;
  cosq=cos(q);
  X[0]=cosq*cos(lambda);
  X[1]=cosq*sinlambda;
  X[2]=sin(q);
}
//---------------------------------------------------------------------------
//Provides inverse projection for Lambert mapping
void InverseLambert(float *X)
{
  float arg,q,cosq,sinlambda,lambda;
  if (X[0]==0) X[0]=1e-16;
  lambda=atan(-X[1]/X[0]);
  sinlambda=sin(lambda);
  if (sinlambda==0) sinlambda=1e-16;
  arg=atan(X[1]/sinlambda);
  q=pihalved-2*arg;
  cosq=cos(q);
  X[0]=cosq*cos(lambda);
  X[1]=cosq*sinlambda;
  X[2]=sin(q);
}
//---------------------------------------------------------------------------
//Provides inverse projection for Mercator mapping
void InverseMercator(float *X)
{
  float U,q,cosq,lambda;
  lambda=-X[0]-pihalved;
  if (X[1]==2000) U=0;
  else U=exp(X[1]);
  q=-pihalved+2*atan(U);
  if (q>pihalved) {q=pi-q; lambda+=pi;}
  cosq=cos(q);
  X[0]=cosq*cos(lambda);
  X[1]=cosq*sin(lambda);
  X[2]=sin(q);
}
//---------------------------------------------------------------------------
//Check to see if a coordinate is within the bounds of
//the geometric map (i.e. not necessarily within the bounds
//of the screen)
bool IsInMap(int *i,int *j,float *x2,float *y2,bool horizontal)
{
  bool InMap=true;

  if (horizontal){
    if (PS.Projection==0){
      if (sqrt((*i-PS.w2)*(*i-PS.w2)+*y2)>PS.R0/2) InMap=false;
    } else {
      if (PS.Projection==1){
        if (sqrt((*i-PS.w2)*(*i-PS.w2)+*y2)>PS.R0) InMap=false;
      } else {
        if (PS.Projection==3){
          if (*i-PS.w2>PS.R0*pihalved) InMap=false;
        }
      }
    }
  } else {
    if (PS.Projection==0){
      if (sqrt((*j-PS.h2)*(*j-PS.h2)+*x2)>PS.R0/2) InMap=false;
    } else {
      if (PS.Projection==1){
        if (sqrt((*j-PS.h2)*(*j-PS.h2)+*x2)>PS.R0) InMap=false;
      } else {
        if (PS.Projection==3){
          if (*i-PS.w2>PS.R0*pihalved) InMap=false;
        }
      }
    }
  }
  return InMap;
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//Object database routines
//---------------------------------------------------------------------------
//Loads star positions and display information into an array
//for quick display. Array is sorted by increasing magnitude index.
void LoadStarMap(int MaxVmag)
{
  static int LastMaxVmag=PS.MaxStarMag;
  FILE *starcat;
  String filename=PS.ProgPath+"Catalogs\\SAO\\SAO_SORTED.DAT";
  if (!FileExists(filename)) {
    String osbuf = "Could not open file " + filename;
    Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    return;
  }
  starcat=fopen(filename.c_str(),"rb");
  fseek(starcat,0,SEEK_SET);

  static bool startflag=true;

  float *fptr,fdum=0.0;
  int *iptr,idum=0,index,mag_index,last_mag_index;
  short *sptr,sdum=0;
  iptr=&idum; fptr=&fdum; sptr=&sdum;
  mag_index=(MaxVmag-150)/50;
  last_mag_index=(LastMaxVmag-150)/50;

  //If the maximum visual magnitude has changed since the
  //last call, then deallocate the star database arrays
  //and reallocate them.
  if (MaxVmag!=LastMaxVmag||startflag){
    if (!startflag) {free_matrices(-1,StarBlkIndex[last_mag_index][431]);}
    index=StarBlkIndex[mag_index][431];
    //Initialize matrices (allocate space for rows)
    ra_star=vector(0,index);
    dec_star=vector(0,index);
    num_star=i_vector(0,index);
    symb_star=s_vector(0,index);
  }

  index=0;
  for (int l=0;l<432;l++){
    for (int k=0;k<StarBlkNum[mag_index][l];k++){
      //Catalogue number
      fread(iptr,4,1,starcat);
      num_star[index]=*iptr;
      //R.A.
      fread(fptr,4,1,starcat);
      ra_star[index]=*fptr;
      //declination
      fread(fptr,4,1,starcat);
      dec_star[index]=*fptr;
      //Bitmap index for the star display
      fread(sptr,2,1,starcat);
      symb_star[index]=*sptr;
      index++;
    }
    //Skip the remaining records
    fseek(starcat,14*(StarBlkNum[19][l]-StarBlkNum[mag_index][l]),SEEK_CUR);
  }
  NStars=index;
  fclose(starcat);
  LastMaxVmag=MaxVmag;
}
//---------------------------------------------------------------------------
//Loads object positions and basic display information
//from catalogs
void LoadCatalog(int catalog,bool startflag)
{
  FILE *catfile;
  String sbuf;
  float *fptr,fdum=0.0;
  short *sptr,sdum=0;
  int *iptr,idum=0;
  fptr=&fdum;
  sptr=&sdum;
  iptr=&idum;

  //Load RNGC catalog
  if (catalog==0){
    String filename=PS.ProgPath+"Catalogs\\RNGC\\RNGC.DAT";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
      return;
    }
    catfile=fopen(filename.c_str(),"rb");
    fseek(catfile,0,SEEK_SET);

    //Initialize matrices on startup
    if (startflag){
      ra_ngc=matrix(0,431,0,242);
      dec_ngc=matrix(0,431,0,242);
      mag_ngc=s_matrix(0,431,0,242);
      num_ngc=s_matrix(0,431,0,242);
      ext_ngc=s_matrix(0,431,0,242);
      type_ngc=s_matrix(0,431,0,242);
      show_ngc=b_matrix(0,431,0,242);
      NumNGC=s_vector(0,431);
    }

    //Load the header information (the file structure)
    for (int l=0;l<432;l++){
      fread(sptr,2,1,catfile);
      NumNGC[l]=*sptr;
    }

    //Load the data
    for (int l=0;l<432;l++){
      for (int k=0;k<NumNGC[l];k++){
        //Catalogue number
        fread(sptr,2,1,catfile);
        num_ngc[l][k]=*sptr;
        //Catalogue number extension
        fread(sptr,2,1,catfile);
        ext_ngc[l][k]=*sptr;
        //Object type code
        fread(sptr,2,1,catfile);
        type_ngc[l][k]=*sptr;
        //Right ascension
        fread(fptr,4,1,catfile);
        ra_ngc[l][k]=*fptr;
        //Declination
        fread(fptr,4,1,catfile);
        dec_ngc[l][k]=*fptr;
        //Magnitude
        fread(fptr,4,1,catfile);
        mag_ngc[l][k]=100*(*fptr);
        if (mag_ngc[l][k]>2000) mag_ngc[l][k]=2000;
        //Determine whether the object should be displayed
        if (mag_ngc[l][k]<=PS.MaxMag[type_ngc[l][k]]&&PS.ShowObjects[type_ngc[l][k]]){
          show_ngc[l][k]=true;
        } else {
          show_ngc[l][k]=false;
        }
      }
    }
  }

  //Load IC catalog
  if (catalog==1){
    String filename=PS.ProgPath+"Catalogs\\IC\\IC.DAT";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
      return;
    }
    catfile=fopen(filename.c_str(),"rb");
    fseek(catfile,0,SEEK_SET);

    //Initialize matrices on startup
    if (startflag){
      ra_ic=matrix(0,431,0,411);
      dec_ic=matrix(0,431,0,411);
      mag_ic=s_matrix(0,431,0,411);
      num_ic=s_matrix(0,431,0,411);
      type_ic=s_matrix(0,431,0,411);
      show_ic=b_matrix(0,431,0,411);
      NumIC=s_vector(0,431);
    }

    //Load the header information (the file structure)
    for (int l=0;l<432;l++){
      fread(sptr,2,1,catfile);
      NumIC[l]=*sptr;
    }

    //Load the data
    for (int l=0;l<432;l++){
      for (int k=0;k<NumIC[l];k++){
        //Catalogue number
        fread(sptr,2,1,catfile);
        num_ic[l][k]=*sptr;
        //Object type code
        fread(sptr,2,1,catfile);
        type_ic[l][k]=*sptr;
        //Right ascension
        fread(fptr,4,1,catfile);
        ra_ic[l][k]=*fptr;
        //Declination
        fread(fptr,4,1,catfile);
        dec_ic[l][k]=*fptr;
        //Magnitude
        fread(fptr,4,1,catfile);
        mag_ic[l][k]=100*(*fptr);
        if (mag_ic[l][k]>2000) mag_ic[l][k]=2000;
        //Determine whether the object should be displayed
        if (mag_ic[l][k]<=PS.MaxMag[type_ic[l][k]]&&PS.ShowObjects[type_ic[l][k]]){
          show_ic[l][k]=true;
        } else {
          show_ic[l][k]=false;
        }
      }
    }
  }

  //Load Messier database
  if (catalog==2){
    String filename=PS.ProgPath+"Catalogs\\Messier\\Messier.DAT";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
      return;
    }
    catfile=fopen(filename.c_str(),"rb");
    fseek(catfile,0,SEEK_SET);

    //Load the data
    for (int i=0;i<110;i++){
      //RNGC Catalogue number (if not available = 0; only three records are 0)
      fread(sptr,2,1,catfile);
      mes_ngc[i]=*sptr;
      //Object type code
      fread(sptr,2,1,catfile);
      type_mes[i]=*sptr;
      //Right ascension
      fread(fptr,4,1,catfile);
      ra_mes[i]=*fptr;
      //Declination
      fread(fptr,4,1,catfile);
      dec_mes[i]=*fptr;
      //Magnitude
      fread(fptr,4,1,catfile);
      mag_mes[i]=*fptr;
      fseek(catfile,55,SEEK_CUR);
      //Determine whether the object should be displayed
      if ((mag_mes[i]<=PS.MaxMag[type_mes[i]])&&PS.ShowObjects[type_mes[i]]) show_mes[i]=true;
      else  show_mes[i]=false;
    }
  }

  //Load Lynd database
  if (catalog==3){
    String filename=PS.ProgPath+"Catalogs\\Lynd\\Lynd.dat";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
      return;
    }
    catfile=fopen(filename.c_str(),"rb");
    fseek(catfile,0,SEEK_SET);

    //Initialize matrices on startup
    if (startflag){
      ra_lyn=matrix(0,431,0,180);
      dec_lyn=matrix(0,431,0,180);
      num_lyn=s_matrix(0,431,0,180);
      NumLyn=s_vector(0,431);
    }

    //Load the header information (the file structure)
    for (int l=0;l<432;l++){
      fread(sptr,2,1,catfile);
      NumLyn[l]=*sptr;
    }

    //Load the data
    for (int l=0;l<432;l++){
      for (int k=0;k<NumLyn[l];k++){
        //Record number (in full Lynd file, Lynd_full.dat)
        fread(sptr,2,1,catfile);
        num_lyn[l][k]=*sptr;
        //Right ascension
        fread(fptr,4,1,catfile);
        ra_lyn[l][k]=*fptr;
        //Declination
        fread(fptr,4,1,catfile);
        dec_lyn[l][k]=*fptr;
      }
    }
  }

  //Load Barnard database
  if (catalog==4){
    String filename=PS.ProgPath+"Catalogs\\Barnard\\Barnard.dat";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
      return;
    }
    catfile=fopen(filename.c_str(),"rb");
    fseek(catfile,0,SEEK_SET);

    //Initialize matrices on startup
    if (startflag){
      ra_bar=vector(0,348);
      dec_bar=vector(0,348);
      num_bar=s_vector(0,348);
      ext_bar=s_vector(0,348);
    }

    //Load the data
    for (int i=0;i<349;i++){
      //Catalog number
      fread(sptr,2,1,catfile);
      num_bar[i]=*sptr;
      //Catalog extension number
      fread(sptr,2,1,catfile);
      ext_bar[i]=*sptr;
      //Right ascension
      fread(fptr,4,1,catfile);
      ra_bar[i]=*fptr;
      //Declination
      fread(fptr,4,1,catfile);
      dec_bar[i]=*fptr;
      fseek(catfile,22,SEEK_CUR);
    }
  }

  //Load Arp database
  if (catalog==5){
    String filename=PS.ProgPath+"Catalogs\\Arp\\Arp.dat";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
      return;
    }
    catfile=fopen(filename.c_str(),"rb");
    fseek(catfile,(64*44)+34,SEEK_SET);

    //Initialize matrices on startup
    if (startflag){
      ra_arp=vector(0,338);
      dec_arp=vector(0,338);
    }

    //Load the data
    for (int i=0;i<338;i++){
      //Right ascension
      fread(fptr,4,1,catfile);
      ra_arp[i]=*fptr;
      //Declination
      fread(fptr,4,1,catfile);
      dec_arp[i]=*fptr;
      if (i!=337) fseek(catfile,38,SEEK_CUR);
    }
  }

  //Load RC3 database.  Note that the data for this catalogue is indexed in
  //a manner similar to the star database to minimize its size
  if (catalog==6){
    String filename=PS.ProgPath+"Catalogs\\RC3\\RC3_SORTED.DAT";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
      return;
    }
    catfile=fopen(filename.c_str(),"rb");
    fseek(catfile,0,SEEK_SET);

    //Initialize matrices on startup
    if (startflag){
      ra_rc3=vector(0,23010);
      dec_rc3=vector(0,23010);
      mag_rc3=vector(0,23010);
      a_rc3=vector(0,23010);
      b_rc3=vector(0,23010);
      pa_rc3=vector(0,23010);
      num_rc3=s_vector(0,23010);
      show_rc3=b_vector(0,23010);
      NumRC3=s_vector(0,432);
    }

    //Load the header information (the file structure)
    int junk[433];
    for (int l=0;l<=432;l++){
      fread(iptr,4,1,catfile);
      NumRC3[l]=*iptr;
      junk[l]=NumRC3[l];
    }

    //Load the data
    for (int i=0;i<23011;i++){
      //Catalogue number
      fread(iptr,4,1,catfile);
      num_rc3[i]=*iptr;
      //Right ascension
      fread(fptr,4,1,catfile);
      ra_rc3[i]=*fptr;
      //Declination
      fread(fptr,4,1,catfile);
      dec_rc3[i]=*fptr;
      //Magnitude
      fread(fptr,4,1,catfile);
      mag_rc3[i]=*fptr;
      //Major axis diameter (in radians)
      fread(fptr,4,1,catfile);
      a_rc3[i]=*fptr;
      //Minor axis diameter (in radians)
      fread(fptr,4,1,catfile);
      b_rc3[i]=*fptr;
      //Position angle (measured east from north in radians)
      fread(fptr,4,1,catfile);
      pa_rc3[i]=*fptr;

      //Determine whether the object should be displayed
      if (mag_rc3[i]*100<=PS.MaxMag[5]&&PS.ShowObjects[5]) show_rc3[i]=true;
      else show_rc3[i]=false;
    }
  }

  fclose(catfile);
}
//---------------------------------------------------------------------------
//Time and date routines
//---------------------------------------------------------------------------
//Computes local sidereal time based on the time
//and date in the selected time/date entry
float GetLST(void)
{
  double T;
  float L,GMST0,LMST,UTime;

  //Get the sun's mean longitude
  T=PS.time.jul;
  GetOE(&T);
  L=OElem[0][2]+OElem[0][5];
  FirstCircle(&L);

  //Get the universal time
  TIME_ t=PS.time;
  LTtoUT(&t);
  UTime=(t.hour/12.0 + t.min/720.0 + t.sec/43200.0)*pi;

  GMST0=L+pi;
  FirstCircle(&GMST0);
  LMST=GMST0+UTime+AL.lng;
  FirstCircle(&LMST);

  return LMST;
}
//---------------------------------------------------------------------------
//Takes a Gregorian date and returns a Julian date, with Universal
//Time included as a decimal fraction
double GregToJul(TIME_ Greg_t)
{
  double UTime,jul;
  TIME_ t;

  t=Greg_t;
  //Convert t to universal time
  LTtoUT(&t);

  UTime=t.hour/24.0 + t.min/1440.0 + t.sec/86400.0;
  jul=367*t.year-(7*(t.year+((t.mon+9)/12)))/4+(275*t.mon)/9+t.day+UTime+1721013.5;

  //Add 1 jul day if before JD = 2415079.5 (March 1, 1900)
  if (jul < 2415079.5) jul += 1.0;

  return jul;
}
//---------------------------------------------------------------------------
//Takes a Julian date and returns a Gregorian date string as mm/dd/yy
String JulToGreg(double jul)
{
  double A, B, C, D, E, Z, alpha;
  float F, jul_;
  int day, month, year;
  String day_, month_, year_;

  jul_=jul+0.5;
  Z=floor(jul_);
  F=jul_-Z;
  if (Z<2299161) {
    A=Z;
  } else {
    alpha=floor(((float)(Z-1867216.25))/36524.25);
    A=Z+1+alpha-floor(alpha/4);
  }
  B=A+1524;
  C=floor(((float)(B-122.1))/365.25);
  D=floor(365.25*C);
  E=floor((B-D)/30.6001);

  day=B-D-floor(30.6001*E);
  if (E<14) month=E-1;
  else month=E-13;
  if (month>2) year=C-4716;
  else year=C-4715;

  day_=IntToStr(day);
//  if (day_.Length()<2) day_="0"+day_;
  month_=IntToStr(month);
//  if (month_.Length()<2) month_="0"+month_;
  year_=IntToStr(year);//.SubString(year_.Length()-1,2);

  return month_+"/"+day_+"/"+year_;
}
//---------------------------------------------------------------------------
//Convert a local time into UT (universal time), changes the date if
//necessary and applies the daylight savings time correction
void LTtoUT(TIME_ *t_)
{
  int months[12]={31,28,31,30,31,30,31,31,30,31,30,31};
  bool nextday=false;
  bool yesterday=false,leapyear;
  TIME_ t=*t_;

  //Is it a leap year/leap century?
  leapyear=IsLeapYear(t.year);

  //If it is a leap year add an extra day to February
  if (leapyear) months[1]+=1;

  //Convert to UT, add the timezone difference (E of Greenwich)
  t.hour=t.hour-PS.TimeZone;

  //Daylight savings time correction
  if (PS.DaylightSavings) t.hour=t.hour-1;

  if (t.hour<0) {t.hour=t.hour+24; yesterday=true;}
  if (t.hour>23) {t.hour=t.hour-24; nextday=true;}

  if (nextday){
    t.day=t.day+1;
    if (t.day>months[t.mon-1]) {
      t.day=1;
      t.mon=t.mon+1;
      if (t.mon>12){t.mon=1; t.year=t.year+1;}
    }
  }
  if (yesterday){
    t.day=t.day-1;
    if (t.day<1) {
      if (t.mon>1) t.mon=t.mon-1;
      else {t.mon=12; t.year=t.year-1;}
      t.day=months[t.mon-1];
    }
  }

  *t_=t;
}
//---------------------------------------------------------------------------
//Moves the current selected time forward
void AdvanceTime(void)
{
  int diff;
  int months[12]={0,31,59,90,120,151,181,212,243,273,304,334};
  int months_[12]={31,28,31,30,31,30,31,31,30,31,30,31};
  double InitTime;
  static bool FirstTime=true;
  double CurTime,TDiff;

  struct TIME_ t;
  bool leapyear=false;

  static struct TIME_ last_t;
  static bool lastwasleapyear=false;

  if (FirstTime){
    FirstTime=false;
    last_t=StartTime;

    //Is it a leap year?  Is it a leap century?
    //(Note that year is always returned as a full number,
    //eg. 1971 or 2045)
    lastwasleapyear=IsLeapYear(last_t.year);
  }

  //If the last time was a leap year, add a day to February
  if (lastwasleapyear) {
    for (int i=2;i<12;i++){months[i]++;}
    months_[1]++;
  }

  InitTime=(months[last_t.mon-1]+last_t.day)*86400+last_t.hour*3600+last_t.min*60+last_t.sec+last_t.hund/100;

  //Determine how much time has elapsed since the program
  //started
  t=GetTime();
  if (!leapyear){
    CurTime=(t.year-last_t.year)*31536000+(months[t.mon-1]+t.day)*86400+t.hour*3600+t.min*60+t.sec+t.hund/100;
  } else {
    CurTime=(t.year-last_t.year)*31622400+(months[t.mon-1]+t.day)*86400+t.hour*3600+t.min*60+t.sec+t.hund/100;
  }
  TDiff=(CurTime-InitTime)*PS.ClockRate/86400.00; //Time difference in days

  //Is it a leap year?  Is it a leap century?
  leapyear=IsLeapYear(PS.time.year);

  //If it's a leap year, add a day to February
  if (leapyear) {
    for (int i=2;i<12;i++){months[i]++;}
    months_[1]++;
  }

  diff=(int)TDiff;
  PS.time.day+=diff;
  if (PS.time.day>months_[PS.time.mon-1]){
    PS.time.mon++;
    if (PS.time.mon>12){
      PS.time.mon=1;
      PS.time.year++;
    }
  }
  TDiff-=diff;

  diff=TDiff*24;
  PS.time.hour+=diff;
  if (PS.time.hour>=24){
    PS.time.hour=0;
    PS.time.day++;
    if (PS.time.day>months_[PS.time.mon-1]){
      PS.time.mon++;
      if (PS.time.mon>12){
        PS.time.mon=1;
        PS.time.year++;
      }
    }
  }
  TDiff=TDiff*24-diff;
  diff=TDiff*60;
  PS.time.min+=diff;
  if (PS.time.min>=60){
    PS.time.min=0;
    PS.time.hour++;
    if (PS.time.hour>=24){
      PS.time.hour=0;
      PS.time.day++;
      if (PS.time.day>months_[PS.time.mon-1]){
        PS.time.mon++;
        if (PS.time.mon>12){
          PS.time.mon=1;
          PS.time.year++;
        }
      }
    }
  }
  TDiff=TDiff*60-diff;
  diff=TDiff*60;
  PS.time.sec+=diff;
  if (PS.time.sec>=60){
    PS.time.sec=0;
    PS.time.min++;
    if (PS.time.min>=60){
      PS.time.min=0;
      PS.time.hour++;
      if (PS.time.hour>=24){
        PS.time.hour=0;
        PS.time.day++;
        if (PS.time.day>months_[PS.time.mon-1]){
          PS.time.mon++;
          if (PS.time.mon>12){
            PS.time.mon=1;
            PS.time.year++;
          }
        }
      }
    }
  }
  TDiff=TDiff*60-diff;
  diff=TDiff*100;
  PS.time.hund+=diff;
  if (PS.time.hund>=100){
    PS.time.hund=0;
    PS.time.sec++;
    if (PS.time.sec>=60){
      PS.time.sec=0;
      PS.time.min++;
      if (PS.time.min>=60){
        PS.time.min=0;
        PS.time.hour++;
        if (PS.time.hour>=24){
          PS.time.hour=0;
          PS.time.day++;
          if (PS.time.day>months_[PS.time.mon-1]){
            PS.time.mon++;
            if (PS.time.mon>12){
              PS.time.mon=1;
              PS.time.year++;
            }
          }
        }
      }
    }
  }
  last_t=t;
  lastwasleapyear=leapyear;
}
//---------------------------------------------------------------------------
//Returns the current time and date in a TIME_ structure
struct TIME_ GetTime(void)
{
  String buf;
  struct time t; //Defined in <time.h>
  struct date d;  //Defined in <time.h>

  struct TIME_ t_;

  gettime(&t);
  buf=t.ti_min;
  t_.min=buf.ToInt();
  buf=t.ti_hour;
  t_.hour=buf.ToInt();
  buf=t.ti_hund;
  t_.hund=buf.ToDouble();
  buf=t.ti_sec;
  t_.sec=buf.ToInt();

  getdate(&d);
  t_.year=d.da_year;
  buf=(unsigned char)d.da_day;
  t_.day=buf.ToInt();
  buf=(unsigned char)d.da_mon;
  t_.mon=buf.ToInt();

  return t_;
}
//---------------------------------------------------------------------------
//Adds Julian days d to a TIME_ structure
struct TIME_ AddSeconds(struct TIME_ t,double d)
{
  int months[12]={31,28,31,30,31,30,31,31,30,31,30,31};
  float day,day_fraction,hour_fraction,min_fraction;

  day=t.day+t.hour/24.0+t.min/1440.0+t.sec/86400.0+d;
  while (day>months[t.mon-1]){
    months[1]=28;
    if (IsLeapYear(t.year)) months[1]++;
    day-=months[t.mon-1];
    t.mon++;
    if (t.mon>12) {
      t.mon-=12;
      t.year++;
    }
  }
  t.day=floor(day);
  day_fraction=day-t.day;
  t.hour=floor(day_fraction*24);
  hour_fraction=day_fraction*24-t.hour;
  t.min=floor(hour_fraction*60);
  min_fraction=hour_fraction*60-t.min;
  t.sec=floor(min_fraction*60);
  return t;
}
//---------------------------------------------------------------------------
//Determines if a year is a leap year
bool IsLeapYear(int year)
{
  div_t x;
  bool leapyear=false;

  //Is it a leap year/leap century?
  x=div(year,4);
  if (x.rem==0) leapyear=true;

  //If the year is the first year of a century (eg, 1900 or 2000)
  //the year is only a leap year if it's divisible by 400.
  if (leapyear){
    x=div(year,100);
    if (x.rem==0){
      //The year is the first year of a century
      x=div(year,400);
      if (x.rem!=0) leapyear=false;
    }
  }
  return leapyear;
}

//---------------------------------------------------------------------------
//Formatting routines
//---------------------------------------------------------------------------
//Gets the string for TIME_ time
String GetTimeDateS(TIME_ time)
{
  String day,hour,min,sec,year,TDString;
  int mon;
  String months[12]={"January","February","March","April",\
                     "May","June","July","August","September",\
                     "October","November","December"};

  hour=IntToStr(time.hour);
  if (time.hour<10) hour="0"+hour;
  min=IntToStr(PS.time.min);
  if (time.min<10) min="0"+min;
  sec=IntToStr(PS.time.sec);
  if (time.sec<10) sec="0"+sec;
  year=IntToStr(PS.time.year);
  day=IntToStr(PS.time.day);
  mon=time.mon;
  TDString=hour+":"+min+":"+sec+", "+months[mon-1]+" "+day+", "+year;
  return TDString;
}
//---------------------------------------------------------------------------
//Takes a right ascension in radians and returns a string in
//the format 00h 00' 00.0"
String GetRAString(float ra)
{
  String ostring;
  float hours_,min_,sec_;
  int hours,min;

  hours_=ra*24.0/twopi;
  hours=floor(hours_);
  min_=(hours_-hours)*60;
  min=floor(min_);
  sec_=(min_-min)*60;
  if (sec_>=59.9) {
    sec_=0;
    min+=1;
    if (min>59){
      hours+=1;
      if (hours>23){
        hours=0;
      }
    }
  }
  ostring=IntToStr(hours)+"h "+IntToStr(min)+"\' "+FormatFloat("00.0",sec_)+"\"";
  return ostring;
}
//---------------------------------------------------------------------------
//Takes a declination in radians and returns a string in
//the format 00 00' 00.0"
String GetDecString(float dec, bool HiPrecision)
{
  String ostring;
  float sec,dec_;
  int deg,min;

  dec_=fabs(dec)*180/pi;

  deg=floor(dec_);
  min=floor((dec_-deg)*60.0);
  sec=(dec_-deg-min/60.0)*3600.0;

  if (dec<0) ostring="-";
  else ostring="";
  if (HiPrecision) ostring+=IntToStr(deg)+" "+IntToStr(min)+"\' "+FormatFloat("00.0000",sec)+"\"";
  else ostring+=IntToStr(deg)+" "+IntToStr(min)+"\' "+FormatFloat("00.0",sec)+"\"";
  return ostring;
}

//---------------------------------------------------------------------------
//Functions that calculate astrometric quantities such
//as elevation, azimuth, times of rise and set etc.
//---------------------------------------------------------------------------
//Precess a coordinate to epoch T (expressed as the Julian date)
//from a start epoch T0
void Precess(float *X,double *T, double *T0)
{
  static double lastT=0;
  static double lastT0=0;
  static float sinzeta,sinz,sintheta,coszeta,cosz,costheta;
  if ((fabs(lastT-*T)>1)||(lastT0!=*T0)){
    //Only recompute the precessional constants if the time
    //differs by more than a day from the initial time or
    //the start epochs have changed.
    double t0_=*T0-2415020.0, t1=*T-*T0;
    double t2=t1*t1, t3=t2*t1;
    double zeta,z,theta;

    zeta=(3.058605837e-7 + 5.073391594e-15*t0_)*t1 + 1.097538869e-15*t2 + 1.791036852e-21*t3;
    z=zeta + 2.874679621e-15*t2 + 9.950204731e-23*t3;
    theta=(2.660966504e-7 - 3.100002170e-15*t0_)*t1 - 1.548183968e-15*t2 - 4.179085988e-21*t3;
    sinzeta=sin(-zeta);
    coszeta=cos(-zeta);
    sinz=sin(-z);
    cosz=cos(-z);
    sintheta=sin(theta);
    costheta=cos(theta);

    lastT=*T;
    lastT0=*T0;
  }

  //Make the transformation
  ZRotate(X,&sinzeta,&coszeta);
  YRotate(X,&sintheta,&costheta);
  ZRotate(X,&sinz,&cosz);
}
//---------------------------------------------------------------------------
//Precession of a single spherical RA, dec coordinate
void Precess_sp(float *ra,float *dec,double *T, double *T0)
{
  float *X;
  X=vector(0,3);

  X[0]=1;
  X[1]=*dec;
  X[2]=*ra;
  SphToCosines(X);
  Precess(X,T,T0);
  CosinesToSph(X);
  *dec=X[1];
  *ra=X[2];
  FirstCircle(ra);

  free_vector(X,0,3);
}
//---------------------------------------------------------------------------
//Adjust the coordinates for an entire class of objects for precession at
//Julian date jday.  This routine adjusts the global variable PS.Epoch to
//reflect the selected precession epoch.
void PrecessClass(int Class,double jday,double startepoch)
{
  //Pass startepoch=0 to load default startepochs (i.e. the epoch for which
  //the database coordinates are compiled)
  float ra,dec;
  bool defaultepoch=false;
  if (startepoch==0) defaultepoch=true;

  //Case for constellation boundaries and figures
  if (Class==-3){
    //Catalogued constellation boundary coordinates are relative to Jan 0 1875.
    if (defaultepoch) startepoch=2405888.5;

    //Constellation boundaries
    for (int i=0;i<ConstTot[102];i++){
      dec=ConstDec[i];
      ra=ConstRA[i];
      Precess_sp(&ra,&dec,&jday,&startepoch);
      ConstDec[i]=dec;
      ConstRA[i]=ra;
    }

    //Catalogued constellation figure endpoints are relative to Jan 0 2000.
    if (defaultepoch) startepoch=2451544.5;

    //Constellation figures
    int N=ConstFigNPts[180];
    for (int i=0;i<N;i++){
      dec=ConstFigDec[i];
      ra=ConstFigRA[i];
      Precess_sp(&ra,&dec,&jday,&startepoch);
      ConstFigDec[i]=dec;
      ConstFigRA[i]=ra;
    }

    //Constellation labels
    for (int i=0;i<88;i++){
      dec=ConstLabDec[i];
      ra=ConstLabRA[i];
      Precess_sp(&ra,&dec,&jday,&startepoch);
      ConstLabDec[i]=dec;
      ConstLabRA[i]=ra;
    }
  }

  //Case for stars
  if (Class==-2){
    //Catalogued SAO star coordinates are relative to Jan 0 2000.
    if (defaultepoch) startepoch=2451544.5;

    for (int i=0;i<NStars;i++){
      dec=dec_star[i];
      ra=ra_star[i];
      Precess_sp(&ra,&dec,&jday,&startepoch);
      dec_star[i]=dec;
      ra_star[i]=ra;
    }
  }

  //Case for object catalogues
  if (Class>-1){
    startepoch=2451544.5; //Jan 0, 2000 is assumed to be the default epoch
  }

  PS.Epoch=jday;
  PS.StartEpoch[Class+3]=startepoch;
}
//---------------------------------------------------------------------------
//Returns elevation at RA and dec at sidereal time SidTime
float Elevation(float ra, float dec, float SidTime)
{
  float sinlambda,sinq,cosq;
  float elev,arg;

  ra=ra-SidTime+pihalved;
  FirstCircle(&ra);
  sinq=sin(dec);
  cosq=cos(dec);
  sinlambda=sin(ra);
  arg=AL.sin_lat*cosq*sinlambda+AL.cos_lat*sinq;
  if (arg>1) arg=1;
  if (arg<-1) arg=-1;
  elev=asin(arg);

  return elev;
}
//---------------------------------------------------------------------------
//Determine the approximate rising time of an object at sidereal time SidTime.
//Returns a string representing the time or the string "Never rises" if object
//never rises.
String GetRiseTime(float RA, float Dec, float SidTime, struct TIME_ CurTime)
{
  float T, dT, azim=0, elev=0, diffT, curT, Theta, arg;
  int Hour, Min, Sec;
  bool flag;
  String sbuf,h,m,s;

  //Determine whether the object ever rises
  if (AL.lat>0) {if (Dec<(AL.lat-pihalved)) return "Never rises.";}
  else {if (Dec>(AL.lat+pihalved)) return "Never rises.";}

  //Determine whether the object ever sets
  if (AL.lat>0) {if (Dec>AL.lat) return "Never sets.";}
  else {if (Dec<AL.lat) return "Never sets.";}

  //Current time in decimal hours
  curT=CurTime.hour + CurTime.min/60.0 + CurTime.sec/3600.0;

  //Determine the current elevation
  EquToHor(&RA,&Dec,&azim,&elev,SidTime);

  arg=fabs(tan(fabs(Dec))*tan(fabs(AL.lat)));
  if (arg>1) arg=1;
  Theta=fabs(acos(arg));
  diffT=fabs(SidTime-RA);
  if (diffT>pi) diffT=twopi-diffT;
  if (azim>pi){
    if (Dec>0) curT=curT-(pi-diffT-Theta)*12.0/pi;
    else curT=curT-(Theta-diffT)*12.0/pi;
  } else {
    if (Dec>0) curT=curT-(pi+diffT-Theta)*12.0/pi;
    else curT=curT-(Theta+diffT)*12.0/pi;
  }

  if (curT<0) curT+=24;
  if (curT>24) curT-=24;
  Hour=floor(curT);
  curT=(curT-Hour)*60;
  Min=floor(curT);
  Sec=floor((curT-Min)*60);
  h=IntToStr(Hour);
  m=IntToStr(Min);
  s=IntToStr(Sec);
  if (h.Length()<2) h="0"+h;
  if (m.Length()<2) m="0"+m;
  if (s.Length()<2) s="0"+s;
  sbuf=h+":"+m+":"+s;

  return sbuf;
}
//---------------------------------------------------------------------------
//Determine the approximate setting time of an object at sidereal time SidTime.
//Returns a string representing the time or the string "Never sets" if object
//never sets.
String GetSetTime(float RA, float Dec, float SidTime, struct TIME_ CurTime)
{
  float T, dT, azim=0, elev=0, diffT, curT, Theta,arg;
  int Hour, Min, Sec;
  bool flag;
  String sbuf,h,m,s;

  //Determine whether the object ever rises
  if (AL.lat>0) {if (Dec<(AL.lat-pihalved)) return "Never rises.";}
  else {if (Dec>(AL.lat+pihalved)) return "Never rises.";}

  //Determine whether the object ever sets
  if (AL.lat>0) {if (Dec>AL.lat) return "Never sets.";}
  else {if (Dec<AL.lat) return "Never sets.";}

  //Current time in decimal hours
  curT=CurTime.hour + CurTime.min/60.0 + CurTime.sec/3600.0;

  //Determine the current elevation
  EquToHor(&RA,&Dec,&azim,&elev,SidTime);

  arg=fabs(tan(fabs(Dec))*tan(fabs(AL.lat)));
  if (arg>1) arg=1;
  Theta=fabs(acos(arg));
  diffT=fabs(SidTime-RA);
  if (diffT>pi) diffT=twopi-diffT;
  if (azim>pi){
    if (Dec>0) curT=curT+(pi+diffT-Theta)*12.0/pi;
    else curT=curT+(Theta+diffT)*12.0/pi;
  } else {
    if (Dec>0) curT=curT+(pi-diffT-Theta)*12.0/pi;
    else curT=curT+(Theta-diffT)*12.0/pi;
  }

  if (curT<0) curT+=24;
  if (curT>24) curT-=24;
  Hour=floor(curT);
  curT=(curT-Hour)*60;
  Min=floor(curT);
  Sec=floor((curT-Min)*60);
  h=IntToStr(Hour);
  m=IntToStr(Min);
  s=IntToStr(Sec);
  if (h.Length()<2) h="0"+h;
  if (m.Length()<2) m="0"+m;
  if (s.Length()<2) s="0"+s;
  sbuf=h+":"+m+":"+s;

  return sbuf;
}
//---------------------------------------------------------------------------
//Converts equatorial coordinates to horizon coordinates at sidereal time
//SidTime
void EquToHor(float *lambda,float *q,float *Az,float *h,float SidTime)
{
  //Uses astronomical convention with 0 at the south point,
  //90 at the west point, 180 at the north point and
  //270 at the east point
  float *X;
  X=vector(0,2);

  float lambda1;
  lambda1=SidTime-pihalved-*lambda; //Subtract the sidereal time to get the hour angle

  //Convert to rectangular coordinates
  X[0]=1; X[1]=*q; X[2]=lambda1;
  SphToCosines(X);

  //Rotate about x by the complement of the declination
  XRotate(X,&(AL.cos_lat),&(AL.sin_lat));

  //Convert back to spherical coordinates
  CosinesToSph(X);
  *h=X[1];
  *Az=X[2]-threepihalved;
  FirstCircle(Az);

  free_vector(X,0,2);
}
//---------------------------------------------------------------------------
//Converts equatorial coordinates to ecliptic coordinates
void EqToEcl(float *lambda, float *q)
{
  double T;
  float *X,sin_ecl,cos_ecl;
  static double StartT=0;
  X=vector(0,2);

  //Check to see if a recalculation of the obliquity o is
  //necessary
  T=PS.time.jul;
  if (T!=StartT){
    //Get the earth's orbital elements at the current time
    GetOE(&T);
    GetObliquity(&T);
    StartT=T;
  }
  //Convert to rectangular coordinates
  X[0]=1; X[1]=*q; X[2]=*lambda;
  SphToCosines(X);

  //Rotate about x-axis by the complement of
  //the ecliptic
  sin_ecl=AL.sin_ecl;
  cos_ecl=AL.cos_ecl;
  XRotate(X,&sin_ecl,&cos_ecl);

  //Convert back to spherical coordinates
  CosinesToSph(X);
  *q=X[1];
  *lambda=X[2];
  FirstCircle(lambda);

  free_vector(X,0,2);
}
//---------------------------------------------------------------------------
//Converts equatorial coordinates to ecliptic coordinates
void EclToEq(float *lambda, float *q)
{
  double T;
  float *X,sin_ecl,cos_ecl;
  static double StartT=0;
  X=vector(0,2);

  //Check to see if a recalculation of the obliquity o is
  //necessary
  T=PS.time.jul;
  if (T!=StartT){
    //Get the earth's orbital elements at the current time
    GetOE(&T);
    GetObliquity(&T);
    StartT=T;
  }

  //Convert to rectangular coordinates
  X[0]=1; X[1]=*q; X[2]=*lambda;
  SphToCosines(X);

  //Rotate about x-axis by the negative complement of
  //the ecliptic
  sin_ecl=-AL.sin_ecl;
  cos_ecl=AL.cos_ecl;
  XRotate(X,&sin_ecl,&cos_ecl);

  //Convert back to spherical coordinates
  CosinesToSph(X);
  *q=X[1];
  *lambda=X[2];
  FirstCircle(lambda);

  free_vector(X,0,2);
}
//---------------------------------------------------------------------------
//Converts equatorial coordinates to galactic longitude and latitude
void EqToGal(float *lambda, float *q)
{
  static float GPoleRASin=0.222400;
  static float GPoleRACos=0.974956;
  static float GPoleDecSin=-0.456063;
  static float GPoleDecCos=0.889948;
  static float GCenRASin,GCenRACos;
  static bool firstrun=true;
  float *X1;
  X1=vector(0,2);

  //Epoch 2000 coordinates of the galactic north pole
  //RA = 12h 51m = 3.364122 radians
  //dec = 27 08' = 0.473566 radians
  //...and the galactic center (0 point of the galactic coordinates)
  //RA = 17h 45.7m = 4.650000 radians
  //dec =-29 00' = -0.506145 radians

  //On the first call, compute the galactic center
  //longitude (in the rotated equatorial frame
  if (firstrun){
    //Convert to rectangular coordinates
    X1[0]=1; X1[1]=-0.506145; X1[2]=4.65;
    SphToCosines(X1);

    //Rotate about z-axis by the R.A. of the galactic pole
    ZRotate(X1,&GPoleRASin,&GPoleRACos);

    //Rotate about y-axis by the negative complement of
    //the declination of the galactic pole
    YRotate(X1,&GPoleDecCos,&GPoleDecSin);

    //Convert to spherical coordinates
    CosinesToSph(X1);

    GCenRASin=sin(X1[2]);
    GCenRACos=cos(X1[2]);
    firstrun=false;
  }

  //Convert to rectangular coordinates
  X1[0]=1; X1[1]=*q; X1[2]=*lambda;
  SphToCosines(X1);

  //Rotate about z-axis by the R.A. of the galactic pole
  ZRotate(X1,&GPoleRASin,&GPoleRACos);

  //Rotate about y-axis by the negative complement of the
  //declination of the galactic pole
  YRotate(X1,&GPoleDecCos,&GPoleDecSin);

  //Rotate about z-axis by the negative R.A. of the rotated
  //galactic center
  ZRotate(X1,&GCenRASin,&GCenRACos);

  //Convert back to spherical coordinates
  CosinesToSph(X1);
  *q=-X1[1];
  *lambda=X1[2];
  FirstCircle(lambda);

  free_vector(X1,0,2);
}
//---------------------------------------------------------------------------
//Converts galactic coordinates to equatorial coordinates
void GalToEq(float *lambda, float *q)
{
  static float GPoleRASin=-0.222400;
  static float GPoleRACos=0.974956;
  static float GPoleDecSin=0.456063;
  static float GPoleDecCos=0.889948;
  static float GCenRASin,GCenRACos;
  static bool firstrun=true;
  float *X1;
  X1=vector(0,2);

  //Epoch 2000 coordinates of the galactic north pole
  //RA = 12h 51m = 3.364122 radians
  //dec = 27 08' = 0.473566 radians
  //...and the galactic center (0 point of the galactic coordinates)
  //RA = 17h 45.7m = 4.650000 radians
  //dec =-29 00' = -0.506145 radians

  //On the first call, compute the galactic center
  //longitude (in the rotated equatorial frame
  if (firstrun){
    float angle;
    //Convert to rectangular coordinates
    X1[0]=1; X1[1]=-0.506145; X1[2]=4.65;
    SphToCosines(X1);

    //Rotate about z-axis by the R.A. of the galactic pole
    angle=-GPoleRASin;
    ZRotate(X1,&angle,&GPoleRACos);

    //Rotate about y-axis by the negative complement of
    //the declination of the galactic pole
    angle=-GPoleDecSin;
    YRotate(X1,&GPoleDecCos,&angle);

    //Convert to spherical coordinates
    CosinesToSph(X1);

    X1[2]+=pi;
    GCenRASin=sin(X1[2]);
    GCenRACos=cos(X1[2]);
    firstrun=false;
  }

  //Convert to rectangular coordinates
  X1[0]=1; X1[1]=*q; X1[2]=*lambda;
  SphToCosines(X1);

  //Rotate about z-axis by the R.A. of the rotated galactic center
  ZRotate(X1,&GCenRASin,&GCenRACos);

  //Rotate about y-axis by the complement of the declination
  //of the galactic pole
  YRotate(X1,&GPoleDecCos,&GPoleDecSin);

  //Rotate about z-axis by the negative R.A. of the galactic pole
  ZRotate(X1,&GPoleRASin,&GPoleRACos);

  //Convert back to spherical coordinates
  CosinesToSph(X1);
  *q=X1[1]; *lambda=X1[2];

  free_vector(X1,0,2);
}

//---------------------------------------------------------------------------
//BASIC PROGRAM FILE I/O (for loading and saving settings, etc.)
//---------------------------------------------------------------------------
//Load the default settings from the .ini file
void LoadSettings(String filename)
{
  FILE *infile;
  if (!FileExists(filename)) {
    String osbuf = "Could not open file " + filename;
    Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    return;
  }
  infile=fopen(filename.c_str(),"rt");
  fseek(infile,0,SEEK_SET);

  char buf[1024];
  AnsiString sbuf;
  int len;
  static bool startup=true;

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
//  PS.ProgPath=sbuf.SubString(10,len-9);  // Obsolete

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  PS.MaxStarMag=sbuf.SubString(12,len-11).ToInt();

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  PS.Projection=sbuf.SubString(12,len-11).ToInt();

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  PS.R0=sbuf.SubString(4,len-3).ToInt();

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  PS.location=sbuf.SubString(10,len-9).ToInt();

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  if (sbuf.SubString(11,len-10)=="true") PS.lighttime=true;
  else PS.lighttime=false;

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  if (sbuf.SubString(9,len-8)=="true") PS.refract=true;
  else PS.refract=false;

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  if (sbuf.SubString(17,len-16)=="true") PS.ShowPlanetPaths=true;
  else PS.ShowPlanetPaths=false;

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  for (int i=0;i<n_objects;i++){
    if (sbuf.SubString(14+i*2,1)=="1") PS.ShowObjects[i]=true;
    else PS.ShowObjects[i]=false;
  }

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  for (int i=0;i<n_objects;i++){
    PS.Symbol[i]=sbuf.SubString(9+i*2,1).ToInt();
  }

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  for (int i=0;i<14;i++){
    PS.PlanetSymbol[i]=sbuf.SubString(15+i*3,2).Trim().ToInt();
  }

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  PS.PlanetResolution=sbuf.SubString(18,len-17).ToInt();

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  for (int i=0;i<n_objects;i++){
    PS.MaxMag[i]=sbuf.SubString(9+i*5,4).Trim().ToInt();
  }

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  for (int i=0;i<n_cat;i++){
    if (sbuf.SubString(9+i*2,1)=="1") PS.UseCat[i]=true;
    else PS.UseCat[i]=false;
  }

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  for (int i=0;i<n_objects;i++){
    if (sbuf.SubString(13+i*2,1)=="1"){
      PS.DrawObjLab[i]=true;
    } else PS.DrawObjLab[i]=false;
  }

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  if (sbuf.SubString(13,len-12)=="true") PS.HorizonMask=true;
  else PS.HorizonMask=false;

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  PS.MajLngInc=sbuf.SubString(11,len-10).ToDouble();

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  PS.MinLngInc=sbuf.SubString(11,len-10).ToDouble();

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  PS.MajLatInc=sbuf.SubString(11,len-10).ToDouble();

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  PS.MinLatInc=sbuf.SubString(11,len-10).ToDouble();

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  PS.MouseCoordType=sbuf.SubString(16,len-10).ToDouble();

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  PS.CenterCoordType=sbuf.SubString(17,len-10).ToDouble();

  PS.w=MainF->Image->Width;
  PS.w2=PS.w/2;
  PS.h=MainF->Image->Height;
  PS.h2=PS.h/2;

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  if (sbuf.SubString(11,len-10)=="true") PS.ShowStars=true;
  else PS.ShowStars=false;

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  if (sbuf.SubString(13,len-12)=="true") PS.ShowDeepSky=true;
  else PS.ShowDeepSky=false;

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  if (sbuf.SubString(13,len-12)=="true") PS.ShowPlanets=true;
  else PS.ShowPlanets=false;

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  if (sbuf.SubString(10,len-9)=="true") PS.ShowGrid=true;
  else PS.ShowGrid=false;

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  if (sbuf.SubString(11,len-10)=="true") PS.ShowTools=true;
  else PS.ShowTools=false;

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  if (sbuf.SubString(12,len-11)=="true") PS.ShowLegend=true;
  else PS.ShowLegend=false;

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  for (int i=0;i<12;i++){
    PS.StarSizes[i]=sbuf.SubString(12+i*3,2).Trim().ToInt();
  }

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  AL.azim=sbuf.SubString(9,len-8).ToDouble();

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  AL.incl=sbuf.SubString(11,len-10).ToDouble();

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  PS.RedrawInterval=sbuf.SubString(16,len-15).ToInt();

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  PS.ClockRate=sbuf.SubString(11,len-10).ToDouble();

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  if (sbuf.SubString(16,len-15)=="true") PS.DrawConstBound=true;
  else PS.DrawConstBound=false;

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  if (sbuf.SubString(14,len-13)=="true") PS.DrawConstFig=true;
  else PS.DrawConstFig=false;

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  if (sbuf.SubString(14,len-13)=="true") PS.DrawConstLab=true;
  else PS.DrawConstLab=false;

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  if (sbuf.SubString(13,len-12)=="true") PS.Topocentric=true;
  else PS.Topocentric=false;

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  for (int i=0;i<9;i++){
    if (sbuf.SubString(12+i*2,1)=="1") PS.DrawPPath[i]=true;
    else PS.DrawPPath[i]=false;
  }

  //Color settings
  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  CS.Hor=(Graphics::TColor)(sbuf.SubString(5,len-4).ToInt());

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  CS.Ecl=(Graphics::TColor)(sbuf.SubString(5,len-4).ToInt());

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  CS.Gal=(Graphics::TColor)(sbuf.SubString(5,len-4).ToInt());

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  CS.Sky=(Graphics::TColor)(sbuf.SubString(5,len-4).ToInt());

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  CS.NightSky=(Graphics::TColor)(sbuf.SubString(10,len-9).ToInt());

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  CS.BackGnd=(Graphics::TColor)(sbuf.SubString(9,len-8).ToInt());

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  CS.HighLight=(Graphics::TColor)(sbuf.SubString(11,len-10).ToInt());

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  CS.MainGrid=(Graphics::TColor)(sbuf.SubString(10,len-9).ToInt());

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  CS.SubGrid=(Graphics::TColor)(sbuf.SubString(9,len-8).ToInt());

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  CS.GridLab=(Graphics::TColor)(sbuf.SubString(9,len-8).ToInt());

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  CS.ConstFig=(Graphics::TColor)(sbuf.SubString(10,len-9).ToInt());

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  CS.ConstLab=(Graphics::TColor)(sbuf.SubString(10,len-9).ToInt());

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  CS.ConstBnd=(Graphics::TColor)(sbuf.SubString(10,len-9).ToInt());

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  len=sbuf.Length();
  CS.GalOutline=(Graphics::TColor)(sbuf.SubString(10,len-9).ToInt());

  //Load the location information
  if (startup){
    //Read the first line to get the number of favorite location
    //indices in the location file
    int *iptr,idum=0;
    iptr=&idum;
    filename=PS.ProgPath+"Cities.dat";
    if (!FileExists(filename)) {
      String osbuf = "Could not open file " + filename;
      Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
      return;
    }
    infile=fopen(filename.c_str(),"rb");
    fseek(infile,0,SEEK_SET);
    fread(iptr,sizeof(iptr),1,infile);
    FavLocNum=*iptr;
    fclose(infile);
  }
  String name;
  float longitude, latitude, TimeZone, elevation;
  bool DaylightSavings;
  LoadLocation(PS.location,&name,&longitude,&latitude,&elevation,&TimeZone,&DaylightSavings);
  AL.lat=latitude;
  AL.cos_lat=cos(latitude);
  AL.sin_lat=sin(latitude);
  AL.lng=longitude;
  AL.alt=elevation;
  PS.TimeZone=TimeZone;
  PS.DaylightSavings=DaylightSavings;

  startup=false;
  fclose(infile);
}
//---------------------------------------------------------------------------
//Load information from record with index n from the
//location database file
void LoadLocation(int n,String *name,float *longitude,float *latitude,\
  float *elevation, float *TimeZone,bool *DaylightSavings)
{
  FILE *infile;
  String filename,sbuf;
  char buf[2], nbuf[33];
  float *fptr,fdum=0;
  int idum=0;
  fptr=&fdum;

  filename=PS.ProgPath+"Cities.dat";
  if (!FileExists(filename)) {
    String osbuf = "Could not open file " + filename;
    Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    return;
  }
  infile=fopen(filename.c_str(),"rb");
  fseek(infile,(FavLocNum+2)*4+n*49,SEEK_SET);

  //Location name
  fgets(nbuf,sizeof(nbuf),infile);
  *name=nbuf;
  *name=(*name).Trim();
  //Latitude
  fread(fptr,4,1,infile);
  *latitude=(*fptr)*pi/180;
  //Longitude
  fread(fptr,4,1,infile);
  *longitude=(*fptr)*pi/180;
  FirstCircle(longitude);
  //Elevation
  fread(fptr,4,1,infile);
  *elevation=*fptr;
  //Time zone
  fread(fptr,4,1,infile);
  *TimeZone=*fptr;
  //Daylight savings flag
  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  if (sbuf=="0") *DaylightSavings=false;
  else *DaylightSavings=true;

  fclose(infile);
}
//---------------------------------------------------------------------------
//Save the settings in the .ini file
void SaveSettings(String filename)
{
  FILE *outfile;
  outfile=fopen(filename.c_str(),"wt");

  String sbuf,c;

  sbuf="ProgPath="+PS.ProgPath+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="MaxStarMag="+IntToStr(PS.MaxStarMag)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="Projection="+IntToStr(PS.Projection)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="R0="+IntToStr((int)PS.R0)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="location="+IntToStr(PS.location)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  if (PS.lighttime) sbuf="lighttime=true\n";
  else sbuf="lighttime=false\n";
  fprintf(outfile,"%s",sbuf.c_str());

  if (PS.refract) sbuf="refract=true\n";
  else sbuf="refract=false\n";
  fprintf(outfile,"%s",sbuf.c_str());

  if (PS.ShowPlanetPaths) sbuf="ShowPlanetPaths=true\n";
  else sbuf="ShowPlanetPaths=false\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="ShowObjects={";
  for (int i=0;i<n_objects;i++){
    if (PS.ShowObjects[i]) c="1";
    else c="0";
    if (i<n_objects-1) sbuf+=c+",";
    else sbuf+=c+"}\n";
  }
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="Symbol={";
  for (int i=0;i<n_objects;i++){
    c=IntToStr(PS.Symbol[i]);
    if (i<n_objects-1) sbuf+=c+",";
    else sbuf+=c+"}\n";
  }
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="PlanetSymbol={";
  for (int i=0;i<14;i++){
    c=IntToStr(PS.PlanetSymbol[i])+"  ";
    c=c.SubString(1,2);
    if (i<13) sbuf+=c+",";
    else sbuf+=c+"}\n";
  }
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="PlanetResolution="+IntToStr((int)PS.PlanetResolution)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="MaxMag={";
  for (int i=0;i<n_objects;i++){
    c=IntToStr(PS.MaxMag[i])+"       ";
    c=c.SubString(1,4);
    if (i<n_objects-1) sbuf+=c+",";
    else sbuf+=c+"}";
  }
  sbuf+="}\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="UseCat={";
  for (int i=0;i<n_cat;i++){
    if (PS.UseCat[i]) c="1";
    else c="0";
    if (i<n_cat-1) sbuf+=c+",";
    else sbuf+=c+"}\n";
  }
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="DrawObjLab={";
  for (int i=0;i<n_objects;i++){
    if (PS.DrawObjLab[i]) c="1";
    else c="0";
    if (i<n_objects-1) sbuf+=c+",";
    else sbuf+=c+"}\n";
  }
  fprintf(outfile,"%s",sbuf.c_str());

  if (PS.HorizonMask) sbuf="HorizonMask=true\n";
  else sbuf="HorizonMask=false\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="MajLngInc="+FormatFloat("0.########",PS.MajLngInc)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="MinLngInc="+FormatFloat("0.########",PS.MinLngInc)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="MajLatInc="+FormatFloat("0.########",PS.MajLatInc)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="MinLatInc="+FormatFloat("0.########",PS.MinLatInc)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="MouseCoordType="+IntToStr(PS.MouseCoordType)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="CenterCoordType="+IntToStr(PS.CenterCoordType)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  if (PS.ShowStars) sbuf="ShowStars=true\n";
  else sbuf="ShowStars=false\n";
  fprintf(outfile,"%s",sbuf.c_str());

  if (PS.ShowDeepSky) sbuf="ShowDeepSky=true\n";
  else sbuf="ShowDeepSky=false\n";
  fprintf(outfile,"%s",sbuf.c_str());

  if (PS.ShowPlanets) sbuf="ShowPlanets=true\n";
  else sbuf="ShowPlanets=false\n";
  fprintf(outfile,"%s",sbuf.c_str());

  if (PS.ShowGrid) sbuf="ShowGrid=true\n";
  else sbuf="ShowGrid=false\n";
  fprintf(outfile,"%s",sbuf.c_str());

  if (PS.ShowTools) sbuf="ShowTools=true\n";
  else sbuf="ShowTools=false\n";
  fprintf(outfile,"%s",sbuf.c_str());

  if (PS.ShowLegend) sbuf="ShowLegend=true\n";
  else sbuf="ShowLegend=false\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="StarSizes={";
  for (int i=0;i<12;i++){
    c=IntToStr(PS.StarSizes[i]);
    if (c.Length()<2) c=c+" ";
    if (i<11) sbuf+=c+",";
    else sbuf+=c+"}\n";
  }
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="Azimuth="+FormatFloat("0.#######e+00",AL.azim)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="Elevation="+FormatFloat("0.#######e+00",AL.incl)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="RedrawInterval="+IntToStr(PS.RedrawInterval)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="ClockRate="+FormatFloat("0.#######e+00",PS.ClockRate)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  if (PS.DrawConstBound) sbuf="DrawConstBound=true\n";
  else sbuf="DrawConstBound=false\n";
  fprintf(outfile,"%s",sbuf.c_str());

  if (PS.DrawConstFig) sbuf="DrawConstFig=true\n";
  else sbuf="DrawConstFig=false\n";
  fprintf(outfile,"%s",sbuf.c_str());

  if (PS.DrawConstLab) sbuf="DrawConstLab=true\n";
  else sbuf="DrawConstLab=false\n";
  fprintf(outfile,"%s",sbuf.c_str());

  if (PS.Topocentric) sbuf="Topocentric=true\n";
  else sbuf="Topocentric=false\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="DrawPPath={";
  for (int i=0;i<9;i++){
    if (PS.DrawPPath[i]) c="1";
    else c="0";
    if (i<8) sbuf+=c+",";
    else sbuf+=c+"}\n";
  }
  fprintf(outfile,"%s",sbuf.c_str());

  //Color settings
  sbuf="Hor="+IntToStr((int)CS.Hor)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="Ecl="+IntToStr((int)CS.Ecl)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="Gal="+IntToStr((int)CS.Gal)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="Sky="+IntToStr((int)CS.Sky)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="NightSky="+IntToStr((int)CS.NightSky)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="BackGnd="+IntToStr((int)CS.BackGnd)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="HighLight="+IntToStr((int)CS.HighLight)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="MainGrid="+IntToStr((int)CS.MainGrid)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="SubGrid="+IntToStr((int)CS.SubGrid)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="GridLab="+IntToStr((int)CS.GridLab)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="ConstFig="+IntToStr((int)CS.ConstFig)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="ConstLab="+IntToStr((int)CS.ConstLab)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="ConstBnd="+IntToStr((int)CS.ConstBnd)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  sbuf="GalOutln="+IntToStr((int)CS.GalOutline)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());

  fclose(outfile);
}
//---------------------------------------------------------------------------
//Load the settings for the planet paths
void LoadPPSettings(void)
{
  //Load the path setting information
  FILE *infile;
  bool Proceed;
  String sbuf;
  char buf[128];

  sbuf=PS.ProgPath+"PPath.dat";
  if (!FileExists(sbuf)) {
    String osbuf = "Could not open file " + sbuf;
    Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    return;
  }
  infile=fopen(sbuf.c_str(),"rt");
  fseek(infile,0,SEEK_SET);

  //NOTE: Format for "planet" indices in the database (a planet is defined
  //here as any solar system object falling into the following categories)
  //0-99: satelites of the sun
  //100-199: satelites of earth
  //200-201: satelites of mars
  //202-205: jupiter's galilean satelites
  //206-211: Cassini and Herschel's satelites of saturn

  for (int i=0; i<211; i++){
    Proceed=false;
    if (i<PS.NSunSat) Proceed=true;
    if (i>99 && i<(100+PS.NEarSat)) Proceed=true;
    if (i>199) Proceed=true;

    if (Proceed){
      SSData[i].PathSD=ReadDouble(infile);
      SSData[i].PathED=ReadDouble(infile);
      SSData[i].Increment=ReadDouble(infile);
      SSData[i].ShowPath=ReadBool(infile);
      SSData[i].ShowPoints=ReadBool(infile);
      SSData[i].ShowLines=ReadBool(infile);
      SSData[i].ShowLabels=ReadBool(infile);
      SSData[i].PointCol=(Graphics::TColor)ReadInt(infile);
      SSData[i].LineCol=(Graphics::TColor)ReadInt(infile);
      SSData[i].LabelCol=(Graphics::TColor)ReadInt(infile);
    }
  }
  fclose(infile);
}
//---------------------------------------------------------------------------
//Save the settings for the planet paths
void SavePPSettings(void)
{
  FILE *outfile;
  bool Proceed;
  outfile=fopen((PS.ProgPath+"PPath.dat").c_str(),"wt");

  //NOTE: Format for "planet" indices in the database (a planet is defined
  //here as any solar system object falling into the following categories)
  //0-99: satelites of the sun
  //100-199: satelites of earth
  //200-201: satelites of mars
  //202-205: jupiter's galilean satelites
  //206-211: Cassini and Herschel's satelites of saturn

  for (int i=0;i<211;i++){
    Proceed=false;
    if (i<PS.NSunSat) Proceed=true;
    if (i>99 && i<(100+PS.NEarSat)) Proceed=true;
    if (i>199) Proceed=true;

    if (Proceed){
      WriteDouble(outfile, SSData[i].PathSD);
      WriteDouble(outfile, SSData[i].PathED);
      WriteDouble(outfile, SSData[i].Increment);
      WriteBool(outfile, SSData[i].ShowPath);
      WriteBool(outfile, SSData[i].ShowPoints);
      WriteBool(outfile, SSData[i].ShowLines);
      WriteBool(outfile, SSData[i].ShowLabels);
      WriteInt(outfile, (int)SSData[i].PointCol);
      WriteInt(outfile, (int)SSData[i].LineCol);
      WriteInt(outfile, (int)SSData[i].LabelCol);
    }
  }
  fclose(outfile);
}
//---------------------------------------------------------------------------
//Load Constellation info
void LoadConstBound(void)
{
  FILE *infile,*infile2,*infile3;
  int *ibuf,idum=0,k=0,lastnum,num;
  float *fbuf,fdum=0,ra,dec;
  ibuf=&idum;
  fbuf=&fdum;

  //Load the constellation boundary information
  String filename=PS.ProgPath+"\\Constellations\\Boundaries.dat";
  if (!FileExists(filename)) {
    String osbuf = "Could not open file " + filename;
    Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    return;
  }
  infile=fopen(filename.c_str(),"rb");
  fseek(infile,0,SEEK_SET);

  lastnum=0;
  for (int i=0;i<102;i++){
    fread(ibuf,4,1,infile);
    num=*ibuf;

    if (i>0) ConstTot[i]=ConstTot[i-1]+lastnum;
    if (i==0) ConstTot[i]=0;

    for (int j=0;j<num;j++){
      fread(fbuf,4,1,infile);
      ConstRA[k]=*fbuf;
      fread(fbuf,4,1,infile);
      ConstDec[k]=*fbuf;
      k++;
    }
    lastnum=num;
  }
  ConstTot[102]=ConstTot[101]+lastnum;
  fclose(infile);

  //Load the constellation figure information
  filename=PS.ProgPath+"\\Constellations\\Figures.dat";
  if (!FileExists(filename)) {
    String osbuf = "Could not open file " + filename;
    Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    return;
  }
  infile2=fopen(filename.c_str(),"rb");
  fseek(infile2,0,SEEK_SET);

  int nseg,npoint,N1=0,N2=0;

  for (int i=0;i<79;i++){
    fread(ibuf,4,1,infile2);
    nseg=*ibuf;
    ConstFigNSeg[i]=nseg;
    for (int j=0;j<nseg;j++){
      fread(ibuf,4,1,infile2);
      npoint=*ibuf;
      ConstFigNPts[N2]=npoint;
      N2++;
      for (int k=0;k<npoint;k++){
        fread(fbuf,4,1,infile2);
        ra=*fbuf;
        ConstFigRA[N1]=ra;
        fread(fbuf,4,1,infile2);
        dec=*fbuf;
        ConstFigDec[N1]=dec;
        N1++;
      }
    }
  }
  ConstFigNPts[180]=N1-1; //The last index of the array contains the total number of points
  fclose(infile2);

  //Load the constellation labels
  filename=PS.ProgPath+"\\Constellations\\CNames.dat";
  if (!FileExists(filename)) {
    String osbuf = "Could not open file " + filename;
    Application->MessageBox(osbuf.c_str(), "SkyAtlas", MB_OK);
    return;
  }
  infile3=fopen(filename.c_str(),"rb");
  fseek(infile3,0,SEEK_SET);
  char buf[25];
  String sbuf;

  for (int i=0;i<88;i++){
    fgets(buf,25,infile3);
    sbuf=buf;
    ConstLabel[i]=sbuf.Trim();
    fread(fbuf,4,1,infile3);
    ConstLabRA[i]=*fbuf;
    fread(fbuf,4,1,infile3);
    ConstLabDec[i]=*fbuf;
  }
  fclose(infile3);
}

//---------------------------------------------------------------------------
//LOW LEVEL ROUTINES (memory allocation for arrays etc.)
//---------------------------------------------------------------------------
//Returns angle i (in radians) to a value between 0 and 2pi
//-single precision
void FirstCircle(float *angle)
{
  *angle=*angle-floor(*angle/twopi)*twopi;
}
//---------------------------------------------------------------------------
//Returns angle i (in radians) to a value between 0 and 2pi
//-double precision
void FirstCircle2(double *angle)
{
  *angle=*angle-floor(*angle/twopi)*twopi;
}
//---------------------------------------------------------------------------
//Allocate a float vector with subscript range v[nl..nh]
float *vector(int nl, int nh)
{
  float *v;
  v=(float *)malloc((size_t) ((nh-nl+1+NR_END)*sizeof(float)));
  return v-nl+NR_END;
}
//---------------------------------------------------------------------------
//Free a float vector allocated with vector()
void free_vector(float *v, int nl, int nh)
{
  free((FREE_ARG)(v+nl-NR_END));
}
//---------------------------------------------------------------------------
//Allocate a double vector with subscript range v[nl..nh]
double *d_vector(int nl, int nh)
{
  double *v;
  v=(double *)malloc((size_t) ((nh-nl+1+NR_END)*sizeof(double)));
  return v-nl+NR_END;
}
//---------------------------------------------------------------------------
//Free a double vector allocated with b_vector()
void free_d_vector(double *v, int nl, int nh)
{
  free((FREE_ARG)(v+nl-NR_END));
}
//---------------------------------------------------------------------------
//Allocate a short vector with subscript range v[nl..nh]
short *s_vector(int nl,int nh)
{
  short *v;
  v=(short *)malloc((size_t) ((nh-nl+1+NR_END)*sizeof(short)));
  return v-nl+NR_END;
}
//---------------------------------------------------------------------------
//Free a short vector allocated with s_vector()
void free_s_vector(short *v, int nl, int nh)
{
  free((FREE_ARG)(v+nl-NR_END));
}
//---------------------------------------------------------------------------
//Allocate an int vector with subscript range v[nl..nh]
int *i_vector(int nl,int nh)
{
  int *v;
  v=(int *)malloc((size_t) ((nh-nl+1+NR_END)*sizeof(int)));
  return v-nl+NR_END;
}
//---------------------------------------------------------------------------
//Free an int vector allocated with i_vector()
void free_i_vector(int *v, int nl, int nh)
{
  free((FREE_ARG)(v+nl-NR_END));
}
//---------------------------------------------------------------------------
//Allocate a bool vector with subscript range v[nl..nh]
bool *b_vector(int nl,int nh)
{
  bool *v;
  v=(bool *)malloc((size_t) ((nh-nl+1+NR_END)*sizeof(bool)));
  return v-nl+NR_END;
}
//---------------------------------------------------------------------------
//Free a bool vector allocated with b_vector()
void free_b_vector(bool *v, int nl, int nh)
{
  free((FREE_ARG)(v+nl-NR_END));
}
//---------------------------------------------------------------------------
//Allocate a float matrix with subscript range m[nrl..nh][ncl..nch]
float **matrix(int nrl, int nrh, int ncl, int nch)
{
  int i, nrow=nrh-nrl+1, ncol=nch-ncl+1;
  float **m;

  //Allocate pointers to rows
  m=(float **)malloc((size_t) ((nrow+NR_END)*sizeof(float*)));
  m += NR_END;
  m -= nrl;

  m[nrl]=(float *)malloc((size_t)((nrow*ncol+NR_END)*sizeof(float)));
  m[nrl] += NR_END;
  m[nrl] -= ncl;

  for(i=nrl+1;i<=nrh;i++) m[i]=m[i-1]+ncol;

  //return pointer to array of pointers to rows
  return m;
}
//---------------------------------------------------------------------------
//Free a float matrix allocated with matrix()
void free_matrix(float **m,int nrl,int nrh,int ncl,int nch)
{
  free((FREE_ARG)(m[nrl]+ncl-NR_END));
  free((FREE_ARG)(m+nrl-NR_END));
}
//---------------------------------------------------------------------------
//Allocate a short matrix with subscript range m[nrl..nh][ncl..nch]
short **s_matrix(int nrl, int nrh, int ncl, int nch)
{
  int i, nrow=nrh-nrl+1, ncol=nch-ncl+1;
  short **m;

  //Allocate pointers to rows
  m=(short **)malloc((size_t) ((nrow+NR_END)*sizeof(short*)));
  m += NR_END;
  m -= nrl;

  m[nrl]=(short *)malloc((size_t)((nrow*ncol+NR_END)*sizeof(short)));
  m[nrl] += NR_END;
  m[nrl] -= ncl;

  for(i=nrl+1;i<=nrh;i++) m[i]=m[i-1]+ncol;

  //return pointer to array of pointers to rows
  return m;
}
//---------------------------------------------------------------------------
//Free a short matrix allocated with s_matrix()
void free_s_matrix(short **m,int nrl,int nrh,int ncl,int nch)
{
  free((FREE_ARG)(m[nrl]+ncl-NR_END));
  free((FREE_ARG)(m+nrl-NR_END));
}
//---------------------------------------------------------------------------
//Allocate an int matrix with subscript range m[nrl..nh][ncl..nch]
int **i_matrix(int nrl, int nrh, int ncl, int nch)
{
  int i, nrow=nrh-nrl+1, ncol=nch-ncl+1;
  int **m;

  //Allocate pointers to rows
  m=(int **)malloc((size_t) ((nrow+NR_END)*sizeof(int*)));
  m += NR_END;
  m -= nrl;

  m[nrl]=(int *)malloc((size_t)((nrow*ncol+NR_END)*sizeof(int)));
  m[nrl] += NR_END;
  m[nrl] -= ncl;

  for(i=nrl+1;i<=nrh;i++) m[i]=m[i-1]+ncol;

  //return pointer to array of pointers to rows
  return m;
}
//---------------------------------------------------------------------------
//Free an int matrix allocated with i_matrix()
void free_i_matrix(int **m,int nrl,int nrh,int ncl,int nch)
{
  free((FREE_ARG)(m[nrl]+ncl-NR_END));
  free((FREE_ARG)(m+nrl-NR_END));
}
//---------------------------------------------------------------------------
//Allocate a bool matrix with subscript range m[nrl..nh][ncl..nch]
bool **b_matrix(int nrl, int nrh, int ncl, int nch)
{
  int i, nrow=nrh-nrl+1, ncol=nch-ncl+1;
  bool **m;

  //Allocate pointers to rows
  m=(bool **)malloc((size_t) ((nrow+NR_END)*sizeof(bool*)));
  m += NR_END;
  m -= nrl;

  m[nrl]=(bool *)malloc((size_t)((nrow*ncol+NR_END)*sizeof(bool)));
  m[nrl] += NR_END;
  m[nrl] -= ncl;

  for(i=nrl+1;i<=nrh;i++) m[i]=m[i-1]+ncol;

  //return pointer to array of pointers to rows
  return m;
}
//---------------------------------------------------------------------------
//Free a bool matrix allocated with b_matrix()
void free_b_matrix(bool **m,int nrl,int nrh,int ncl,int nch)
{
  free((FREE_ARG)(m[nrl]+ncl-NR_END));
  free((FREE_ARG)(m+nrl-NR_END));
}
//---------------------------------------------------------------------------
//Frees the object database matrices
void free_matrices(int database,int vector_size)
{
  //database is an integer representing the database for which to
  //deallocate memory
  // 0 = Star database
  if (database==-1){
    free_vector(ra_star,0,vector_size);
    free_vector(dec_star,0,vector_size);
    free_i_vector(num_star,0,vector_size);
    free_s_vector(symb_star,0,vector_size);
  }
  // 1 = RNGC database
  if (database==0){
    free_matrix(ra_ngc,0,431,0,1000);
    free_matrix(dec_ngc,0,431,0,1000);
    free_s_matrix(mag_ngc,0,431,0,1000);
    free_s_matrix(num_ngc,0,431,0,1000);
    free_s_matrix(ext_ngc,0,431,0,1000);
    free_s_matrix(type_ngc,0,431,0,1000);
    free_s_vector(NumNGC,0,431);
    free_b_matrix(show_ngc,0,431,0,1000);
  }
  // 2 = IC database
  if (database==1){
    free_matrix(ra_ic,0,431,0,1000);
    free_matrix(dec_ic,0,431,0,1000);
    free_s_matrix(mag_ic,0,431,0,1000);
    free_s_matrix(num_ic,0,431,0,1000);
    free_s_matrix(type_ic,0,431,0,1000);
    free_s_vector(NumIC,0,431);
    free_b_matrix(show_ic,0,431,0,1000);
  }
  // 3 = Lynd database
  if (database==3){
    free_matrix(ra_lyn,0,431,0,180);
    free_matrix(dec_lyn,0,431,0,180);
    free_s_matrix(num_lyn,0,431,0,180);
    free_s_vector(NumLyn,0,431);
  }
  // 4 = Barnard database
  if (database==4){
    free_vector(ra_bar,0,348);
    free_vector(dec_bar,0,348);
    free_s_vector(num_bar,0,348);
    free_s_vector(ext_bar,0,348);
  }
  // 5 = Arp database
  if (database==5){
    free_vector(ra_arp,0,338);
    free_vector(dec_arp,0,338);
  }
}
//---------------------------------------------------------------------------
//Strip off non-numeric characters so that the output makes sense
//for float text input
double StripBlank(String s)
{
  String Allowed[11]={"0","1","2","3","4","5","6","7","8","9","."};
  bool OK,firstdecimal=true,firstnonzero=false;
  int j;
  String os="",c;
  s=s.Trim();
  if (s=="") s="0";

  //Now fill all of the blanks with 0's
  for (int i=1;i<=s.Length();i++){
    c=s.SubString(i,1);
    OK=false; j=0;
    while (j<11 && !OK) {
      if (c==Allowed[j]) OK=true;
      j++;
    }
    if (!OK || (j==11 && !firstdecimal)) c="0";
    if (j==11) firstdecimal=false;
    if (j==1 && !firstnonzero) c="";
    if (j!=1) firstnonzero=true;
    os+=c;
  }
  if (!firstdecimal||os=="") os+=0;
  return os.ToDouble();
}
//---------------------------------------------------------------------------
//Read a line from a file and return a boolean value
bool ReadBool(FILE *infile)
{
  char buf[1024];
  String sbuf;
  bool bval=false;
  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();
  if (sbuf=="1"||sbuf=="true") bval=true;

  return bval;
}
//---------------------------------------------------------------------------
//Read a line from a file and return a float value
double ReadDouble(FILE *infile)
{
  char buf[1024];
  String sbuf;
  fgets(buf,sizeof(buf),infile);
  sbuf=buf;

  return sbuf.Trim().ToDouble();
}
//---------------------------------------------------------------------------
//Read a line from a file and return an integer value
int ReadInt(FILE *infile)
{
  char buf[1024];
  String sbuf;

  fgets(buf,sizeof(buf),infile);
  sbuf=buf;

  return sbuf.Trim().ToInt();
}
//---------------------------------------------------------------------------
//Read a line from a file and return a String value
String ReadStr(FILE *infile)
{
  char buf[1024];
  String sbuf;
  fgets(buf,sizeof(buf),infile);
  sbuf=buf;
  sbuf=sbuf.Trim();

  return sbuf;
}
//---------------------------------------------------------------------------
//Write a line containing a boolean value to infile
void WriteBool(FILE *outfile,bool bval)
{
  String sbuf;
  if (bval) sbuf="true\n";
  else sbuf="false\n";
  fprintf(outfile,"%s",sbuf.c_str());
}
//---------------------------------------------------------------------------
//Write a line containing a double value to infile
void WriteDouble(FILE *outfile,double fval)
{
  String sbuf;
  sbuf=FormatFloat("0.0000000000e+00",fval)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());
}
//---------------------------------------------------------------------------
//Write a line containing an integer value to infile
void WriteInt(FILE *outfile,int ival)
{
  String sbuf;
  sbuf=IntToStr(ival)+"\n";
  fprintf(outfile,"%s",sbuf.c_str());
}
//---------------------------------------------------------------------------
//Write a line containing a String value to infile
void WriteStr(FILE *outfile,String sbuf)
{
  sbuf+="\n";
  fprintf(outfile,"%s",sbuf.c_str());
}
//---------------------------------------------------------------------------
//Reads characters in infile until the string <str> is encountered.
void SkipToStr(FILE *infile,String str,int NSkip)
{
  String strbuf="****";
  char ch;
  while (strbuf!=str) {
    ch=fgetc(infile);
    strbuf=strbuf+ch;
    strbuf=(strbuf.SubString(2,4));
  }
  //Skip some characters
  for (int i=0;i<NSkip;i++){
    ch=fgetc(infile);
  }
}
//---------------------------------------------------------------------------
//Returns the path part of a filename
String GetFilePath(String filename)
{
  int len=filename.Length(),i=0;
  do {i++;} while (filename.SubString(len-i,1)!="\\" && i<=len);
  return filename.SubString(0,len-i);
}
