//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "StarSet.h"
#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cspin"
#pragma link "CSPIN"
#pragma resource "*.dfm"
TStarSettings *StarSettings;
Graphics::TBitmap *Starpic=new Graphics::TBitmap();

extern Settings PS;
Settings PSBackup;
extern bool DrawingMap;
extern void LoadStarMap(int MaxV);

void PrecessClass(int Class,double jday,double startepoch);
//---------------------------------------------------------------------------
__fastcall TStarSettings::TStarSettings(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TStarSettings::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  ApplyBtnClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TStarSettings::FormActivate(TObject *Sender)
{
  DrawForm(Sender);

  //Save a copy of the initial values
  PSBackup=PS;
}
//---------------------------------------------------------------------------
void __fastcall TStarSettings::SizeListClick(TObject *Sender)
{
  StarDiameter->Value=12-PS.StarSizes[SizeList->ItemIndex]/7;
}
//---------------------------------------------------------------------------
void __fastcall TStarSettings::StarDiameterChange(TObject *Sender)
{
  String fileindex, filename;
  int w=StarDiameter->Value;

  fileindex=IntToStr((12-w)*7);
  filename=PS.ProgPath+"\\Symbols\\Stars\\"+fileindex+".bmp";
  Starpic->LoadFromFile(filename);
  Image->Canvas->Brush->Color=clBlack;
  Image->Canvas->Rectangle(0,0,12,12);
  Image->Canvas->Draw(6-w/2,6-w/2,Starpic);
}
//---------------------------------------------------------------------------
//Draw settings on the form
void __fastcall TStarSettings::DrawForm(TObject *Sender)
{
  int w;
  String fileindex, filename;

  MaxVMag->Value=PS.MaxStarMag;
  if (SizeList->ItemIndex<0||SizeList->ItemIndex>11) SizeList->ItemIndex=0;

  w=StarDiameter->Value/2;
  fileindex=IntToStr(PS.StarSizes[SizeList->ItemIndex]);
  filename=PS.ProgPath+"\\Symbols\\Stars\\"+fileindex+".bmp";
  Starpic->LoadFromFile(filename);
  Image->Canvas->CopyMode=cmSrcPaint;
  Image->Canvas->Brush->Color=clBlack;
  Image->Canvas->Rectangle(0,0,12,12);
  Image->Canvas->Draw(6-w,6-w,Starpic);
}
//---------------------------------------------------------------------------
void __fastcall TStarSettings::RestoreButClick(TObject *Sender)
{
  //Restore to original values
  PS=PSBackup;
  DrawForm(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TStarSettings::DefaultButClick(TObject *Sender)
{
  //Restore to default values
  PS.MaxStarMag=600;
  for (int i=0;i<12;i++) {PS.StarSizes[i]=i*7;}
  DrawForm(Sender);
  ApplyBtnClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TStarSettings::ApplyBtnClick(TObject *Sender)
{
  //Apply changes
  PS.MaxStarMag=MaxVMag->Value;
  PS.StarSizes[SizeList->ItemIndex]=(12-StarDiameter->Value)*7;

  //Wait for the system to stop drawing the map
  while (DrawingMap){};
  DrawingMap=true;

  //Load stars into the map array
  LoadStarMap(PS.MaxStarMag);
  PrecessClass(-2,PS.time.jul,0);

  //Draw the grid and stars
  MainF->DrawMap(PS.MaxStarMag,false);
  DrawingMap=false;
}
//---------------------------------------------------------------------------

