//---------------------------------------------------------------------------
#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "TimeDateSet.h"
#include "ServiceRoutines.h"
#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cspin"
#pragma resource "*.dfm"
TTimeDate *TimeDate;
String GetTimeDateS(int i);
String EditTimeDateS(String tstring,String dstring);
bool ignorechanges=false;

extern Settings PS;
extern Angles AL;
extern bool DrawingMap;
extern float GetLST(void);
extern void FirstCircle(float *angle);
extern bool IsLeapYear(int year);
extern double GregToJul(TIME_ Greg_t);
extern String GetTimeDateS(TIME_ time);
extern struct TIME_ GetTime(void);
extern void PrecessClass(int Class,double jday,double startepoch);

//---------------------------------------------------------------------------
__fastcall TTimeDate::TTimeDate(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TTimeDate::FormActivate(TObject *Sender)
{
  String td,buf;

  //Load timepicker control
  buf="00"+IntToStr(PS.time.hour);
  buf=buf.SubString(buf.Length()-1,2);
  td=buf+":";
  buf="00"+IntToStr(PS.time.min);
  buf=buf.SubString(buf.Length()-1,2);
  td=td+buf+":";
  buf="00"+IntToStr(PS.time.sec);
  buf=buf.SubString(buf.Length()-1,2);
  td=td+buf;
  TimePicker->Text=td;
  TimePicker->Repaint();

  //Load datepicker control
  buf="00"+IntToStr(PS.time.day);
  buf=buf.SubString(buf.Length()-1,2);
  td=buf+"/";
  buf="00"+IntToStr(PS.time.mon);
  buf=buf.SubString(buf.Length()-1,2);
  td=td+buf+"/";
  buf="0000"+IntToStr(PS.time.year);
  buf=buf.SubString(buf.Length()-3,4);
  td=td+buf;
  DatePicker->Text=td;
  DatePicker->Repaint();

  TimeZone->Text=IntToStr((int)PS.TimeZone);
  DaylightSavings->Checked=PS.DaylightSavings;
}
//---------------------------------------------------------------------------
//Gets the string for the time and date displayed in the
//time and date picker controls
String EditTimeDateS(String tstring, String dstring)
{
  String day,hour,min,sec,year,TDString,mon_;
  int mon;
  String months[12]={"January","February","March","April",\
                     "May","June","July","August","September",\
                     "October","November","December"};

  //Hour
  hour=tstring.SubString(1,2).Trim();
  if (hour=="") hour="00";
  //Minutes
  min=tstring.SubString(4,2).Trim();
  if (min=="") min="00";
  //Seconds
  sec=tstring.SubString(7,2).Trim();
  if (sec=="") sec="00";

  //Day
  day=dstring.SubString(1,2).Trim();
  if (day=="") day="00";
  //Month
  mon_=dstring.SubString(4,2).Trim();
  if (mon_=="") mon_="00";
  mon=mon_.ToInt();
  //Year
  year=dstring.SubString(7,4).Trim();
  if (year=="") year="0000";

  TDString=hour+":"+min+":"+sec+", "+months[mon-1]+" "+day+", "+year;
  return TDString;
}
//---------------------------------------------------------------------------
//Edits the date (prevents entry of invalid dates
void __fastcall TTimeDate::DatePickerChange(TObject *Sender)
{
  if (!ignorechanges){
    String day_,mon_,year_;
    String tstring,dstring=DatePicker->Text;
    int day,mon,year;
    int months[12]={31,28,31,30,31,30,31,31,30,31,30,31};

    //Check that the individual entries make sense relative
    //to the others

    //Day
    day_=dstring.SubString(1,2).Trim();
    if (day_=="") day_="00";
    day=day_.ToInt();
    //Month
    mon_=dstring.SubString(4,2).Trim();
    if (mon_=="") mon_="00";
    mon=mon_.ToInt();
    //Year
    year_=dstring.SubString(7,4).Trim();
    if (year_=="") year_="0000";
    year=year_.ToInt();

    bool leapyear=false;
    //Is it a leap year?  Is it a leap century?
    leapyear=IsLeapYear(year);

    //If it's a leap year, add a day to February
    if (leapyear) months[1]+=1;

    //Check the month number
    if (mon>12) mon=12;
    if (mon<1) mon=1;

    //Check the day of the month
    if (day>months[mon-1]) day=months[mon-1];
    if (day<1) day=1;

    if (mon<10) mon_="0"+IntToStr(mon);
    else mon_=IntToStr(mon);
    if (day<10) day_="0"+IntToStr(day);
    else day_=IntToStr(day);
    DatePicker->Text=day_+"/"+mon_+"/"+dstring.SubString(7,4);
  }
}
//---------------------------------------------------------------------------
//Edits the time (prevents entry of invalid times)
void __fastcall TTimeDate::TimePickerChange(TObject *Sender)
{
  if (!ignorechanges){
    String hour_,min_,sec_;
    String dstring,tstring=TimePicker->Text;
    int hour,min,sec;

    //Hour
    hour_=tstring.SubString(1,2).Trim();
    if (hour_=="") hour_="0";
    hour=hour_.ToInt();
    //Minutes
    min_=tstring.SubString(4,2).Trim();
    if (min_=="") min_="0";
    min=min_.ToInt();
    //Seconds
    sec_=tstring.SubString(7,2).Trim();
    if (sec_=="") sec_="0";
    sec=sec_.ToInt();

    if (hour>23) hour=23;
    if (min>59) min=59;
    if (sec>59) sec=59;
    if (hour<10) hour_="0"+IntToStr(hour);
    else hour_=IntToStr(hour);
    if (min<10) min_="0"+IntToStr(min);
    else min_=IntToStr(min);
    if (sec<10) sec_="0"+IntToStr(sec);
    else sec_=IntToStr(sec);
    TimePicker->Text=hour_+":"+min_+":"+sec_;
  }
}
//---------------------------------------------------------------------------
//Apply the changes
void __fastcall TTimeDate::ApplyButClick(TObject *Sender)
{
  struct TIME_ tb=PS.time; //Copy of old time

  PS.time.hour=TimePicker->Text.SubString(1,2).ToInt();
  PS.time.min=TimePicker->Text.SubString(4,2).ToInt();
  PS.time.sec=TimePicker->Text.SubString(7,2).ToInt();
  PS.time.hund=0;
  PS.time.mon=DatePicker->Text.SubString(4,2).ToInt();
  PS.time.day=DatePicker->Text.SubString(1,2).ToInt();
  PS.time.year=DatePicker->Text.SubString(7,4).ToInt();
  PS.DaylightSavings=DaylightSavings->Checked;
  PS.TimeZone=TimeZone->Text.ToInt();
  PS.time.jul=GregToJul(PS.time);

  //Update the time caption on the main form
  MainF->StatusBar->Panels->Items[3]->Text="LT: "+GetTimeDateS(PS.time)+ "  JD: "+FormatFloat("###########0.00",PS.time.jul);

  //Get Sidereal Time
  float angle;
  angle=GetLST();
  FirstCircle(&angle);
  AL.l_ori=angle;

  //Precess catalogues if necessary (only if dates differ by more than 100 days)
  if (fabs(PS.time.jul-tb.jul)>100.0){
    //Stars
    PrecessClass(-2,PS.time.jul,tb.jul);
    //Catalogue objects
    for (int i=0;i<10;i++){
      if (PS.UseCat[i]) PrecessClass(i,PS.time.jul,tb.jul);
    }
    //Constellation boundaries and figures
    PrecessClass(-3,PS.time.jul,tb.jul);
  }

  //Draw the map
  int X=PS.w2, Y=PS.h2;
  MainF->DrawCoord(&X,&Y,true,true);
  if (!DrawingMap){
    DrawingMap=true;
    MainF->DrawMap(PS.MaxStarMag,false);
    DrawingMap=false;
  }
}
//---------------------------------------------------------------------------
//Set to system time
void __fastcall TTimeDate::SetToSystemBtnClick(TObject *Sender)
{
  PS.time=GetTime();
  FormActivate(Sender);
}
//---------------------------------------------------------------------------

